;Ŀ
; DEMO08.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:04:22                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;input "What is your name... " a$ 
;
Mov  SI,Offset $tring_01
Call PrintStr
Call SetCursor
Call KBInput
Mov SI,Offset $Work2
Mov  DI,Offset A$
Call MoveStr
Call DoCrLf
;
;a$ = trim$ a$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset a$
Call Trim$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;a = len a$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset a$
Call Len
Add  AX,$Var0
Mov  A,AX
;
;PRINT 
;
Call DoCrLf
;
;PRINT "Your name has" a "letters in it." 
;
Mov  SI,Offset $tring_04
Call PrintStr
Call SetCursor
Mov  AX,A
Call PrintNum
Call SetCursor
Mov  SI,Offset $tring_05
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT a 
;
Mov  AX,A
Call PrintNum
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




Getkey Proc Near 
Xor  AX,AX 
Int  16h 
Cmp  AL,0 
Je   ExtendedKey 
Xor  AH,AH 
Jmp  RegularKey 
ExtendedKey: 
Mov  AL,AH 
Xor  AH,AH 
Neg  AX 
RegularKey: 
Ret 
GetKey Endp 




PrintNum Proc Near
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  AX
Cmp  AX,32768 
Jb PositiveNumber 
Neg AX 
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Mov  DL,'-'
Mov  AH,2
Int  21h
Pop  AX
PositiveNumber:
Xor  CX,CX
GetAnotherDigit:
Inc  CX
Xor  DX,DX
Div $Base
Push DX
Cmp  AX,0
Jne GetAnotherDigit
PrntDigit:
Pop  AX
Add  AL,'0'
Push AX
Push BX
Push CX
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  CX
Pop  BX
Pop  AX
Mov  DL,AL
Mov  AH,2
Int  21h
Loop PrntDigit
Inc  $Xcur
Ret
PrintNum Endp




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp



Trim$ Proc Near 
;------------------------ 
;SI=input   $Work1=output 
;------------------------ 
Mov  DI,Offset $Work2 
Call MoveStr 
Mov  SI,Offset $Work2 
Call Ltrim$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work2 
Call MoveStr 
Mov  SI,Offset $Work2 
Call Rtrim$ 
Ret 
Trim$ Endp 



Rtrim$ Proc Near 
;
; SI=address of String TO rtrim 
; * Note * trims ALL chars 0 TO 32 
;
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $Work2
Mov  DI,Offset $Work1 
Call MoveStr 
Mov  SI,Offset $Work1 
Call Len 
Mov  DI,Offset $Work1 
Mov  CX,AX 
Add  DI,AX 
Rtrim_loop: 
Mov  BX,[DI] 
Cmp  BX,32 
Jg   Rtrim_Quit 
Mov  [DI],Byte Ptr 0 
Dec  CX 
Dec  DI 
Cmp  CX,0 
Jge  Rtrim_loop 
Rtrim_quit: 
Ret 
Rtrim$ Endp 




Ltrim$ Proc Near 
;---------------------------------------- 
; SI=$Work2       Output String In   $Work1 
;---------------------------------------- 
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $Work2
Xor  CX,CX 
LtrimLoop: 
Cmp  [SI],Byte ptr 32 
Jne  LtrimDone 
Inc  SI 
Inc  CX 
Cmp  CX, 81 
Jne  LtrimLoop 
LtrimDone: 
Mov  CX, 81 
Mov  DI,Offset $Work1 
Cld 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Ret 
Ltrim$ Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


 
 
KBinput Proc Near 
Push BP 
Mov  BP,SP 
Mov  SI,Offset $KBcur 
Call PrintStr 
Xor  AX,AX 
Call ShowHideCursor 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $KBnull 
Mov  DI,Offset $Work2 
Call MoveStr 
Xor  AX,AX 
Mov  $Var0,AX 
Call GetCursor 
Mov  AX,$Xcur 
Add  AX,$Var0 
Mov  $Var1,AX 
Mov  AX,$Var1 
Mov  $Var3,AX 
Xor  AX,AX 
Mov  $Var0,AX 
Call GetCursor 
Mov  AX,$Ycur 
Add  AX,$Var0 
Mov  $Var2,AX 
KBinputLoop_1: 
Xor  AX,AX 
Mov  $Var0,AX 
Call GetKey 
Add  AX,$Var0 
Mov  $Var4,AX 
Cmp  $Var4,31 
Jg   KBinput_Pass_1 
Jmp  KBinput_Fail_1 
KBinput_Pass_1: 
Cmp  $Var4,128 
Jl   KBinput_Pass_2 
Jmp  KBinput_Fail_2 
KBinput_Pass_2: 
Xor  AX,AX 
Add  AX,$Var4 
Mov  $Var6,AX 
Mov  AX,255 
Mov  $Var4,AX 
KBinput_Fail_2: 
KBinput_Fail_1: 
Cmp  $Var4,8 
Je   KBinput_Pass_3 
Jmp  KBinput_Fail_3 
KBinput_Pass_3: 
Mov  AX,254 
Mov  $Var4,AX 
KBinput_Fail_3: 
Cmp  $Var4,-75 
Je   KBinput_Pass_4 
Jmp  KBinput_Fail_4 
KBinput_Pass_4: 
Mov  AX,254 
Mov  $Var4,AX 
KBinput_Fail_4: 
Cmp  $Var4,13 
Je   KBinput_Pass_5 
Jmp  KBinput_Fail_5 
KBinput_Pass_5: 
Jmp KBinputLoop_1A 
KBinput_Fail_5: 
Cmp  $Var4,255 
Je   KBinput_Pass_6 
Jmp  KBinput_Fail_6 
KBinput_Pass_6: 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  DI,Offset $Work1 
Mov  AX,$Var6 
Mov  [Byte Ptr DI],AX 
Xor  BX,BX 
Mov  [Byte Ptr DI+1],BX 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  AX,0 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Mov  SI,Offset $KBcur 
Call PrintStr 
Call SetCursor 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work2 
Call MoveStr 
Inc  $Var1 
KBinput_Fail_6: 
Cmp  $Var4,254 
Je   KBinput_Pass_7 
Jmp  KBinput_Fail_7 
KBinput_Pass_7: 
Xor  AX,AX 
Mov  $Var0,AX 
Mov  SI,Offset $Work2 
Call Len 
Add  AX,$Var0 
Mov  $Var5,AX 
Dec  $Var5 
Dec  $Var1 
Cmp  $Var5,1 
Jl   KBinput_Pass_8 
Jmp  KBinput_Fail_8 
KBinput_Pass_8: 
Mov  AX,1 
Mov  $Var5,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $KBnull 
Mov  DI,Offset $Work2 
Call MoveStr 
Inc  $Var1 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  SI,Offset $KBspc 
Call PrintStr 
Call SetCursor 
Xor  AX,AX 
Add  AX,$Var3 
Mov  $Var1,AX 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
KBinput_Fail_8: 
Mov  DI,Offset $Work0 
Call Nullstr 
Cld 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Mov  CX,$Var5 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work2 
Call MoveStr 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  SI,Offset $KBdblSpc 
Call PrintStr 
Call SetCursor 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  SI,Offset $KBcur 
Call PrintStr 
Call SetCursor 
KBinput_Fail_7: 
Jmp KBinputLoop_1 
KBinputLoop_1A: 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  AX,1 
Call ShowHideCursor 
Mov  SI,Offset $KBspc 
Call PrintStr 
Call SetCursor 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Pop  BP 
Ret 
KBinput Endp 
 
 


ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
$KBnull      DB 0,0
$KBcur       DB '_',0
$KBspc       DB 32,0
$KBdblSpc    DB 32,32,0

;__________________Users Initialized Data____________________

$tring_01    DB "What is your name... ",0
A            DW  0
$tring_04    DB "Your name has",0
$tring_05    DB "letters in it.",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
Data Ends

End
