;Ŀ
; DEMO14.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:06:24                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;for a = 1 to 10 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,10       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,10
Cmp  AX,A       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
Call routine1
;
;next 
;
Jmp ForLoop_01
ForLoop_01A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




PrintNum Proc Near
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  AX
Cmp  AX,32768 
Jb PositiveNumber 
Neg AX 
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Mov  DL,'-'
Mov  AH,2
Int  21h
Pop  AX
PositiveNumber:
Xor  CX,CX
GetAnotherDigit:
Inc  CX
Xor  DX,DX
Div $Base
Push DX
Cmp  AX,0
Jne GetAnotherDigit
PrntDigit:
Pop  AX
Add  AL,'0'
Push AX
Push BX
Push CX
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  CX
Pop  BX
Pop  AX
Mov  DL,AL
Mov  AH,2
Int  21h
Loop PrntDigit
Inc  $Xcur
Ret
PrintNum Endp




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




Routine2 Proc Near
Push BP
Mov  BP,SP
;
;PRINT a 
;
Mov  AX,A
Call PrintNum
Call SetCursor
Call DoCrLf
Pop  BP
Ret  00
Routine2 Endp


Routine1 Proc Near
Push BP
Mov  BP,SP
Call routine2
Pop  BP
Ret  00
Routine1 Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

A            DW  0

;_________________System Un-Initialized Data_________________


;_________________Users Un-Initialized Data__________________

Data Ends

End
