;Ŀ
; DEMO16.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:07:04                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;a$ = "Junk" 
;
Mov  SI,Offset $tring_01
Mov  DI,Offset a$
Call MoveStr
;
;open a$ for output as 1 
;
Mov  DX,Offset A$
Xor  CX,CX     ; normal read/write attribute
Mov  Eof,CX
Mov  AH,3Ch    ; create file 
Int  21h
Call TrapError
Mov  HANDLE_1,AX
Mov  BX,AX
Mov  AH,3Eh    ; close file
Int  21h
Call TrapError
Mov  DX,Offset A$
Mov  AL,1
Mov  AH,3DH    ; open file for writing
Int  21h
Call TrapError
;
;Print # 1 "abcdefghi,jklmnopqrstuvwxyz" 
;
Mov  SI,Offset $tring_04
Call Len
Mov  CX,AX
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  DX,Offset $tring_04
Mov  AH,40h
Int  21h
Call TrapError
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  CX,2
Mov  DX,Offset $CrLf
Mov  AH,40h
Int  21h
Call TrapError
;
;close 1 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;open a$ for input as 1 
;
Mov  DX,Offset A$
Xor  AX,AX
Mov  Eof,AX
Mov  AH,3DH    ; open file for reading
Int  21h
Call TrapError
Mov  HANDLE_1,AX
;
;input # 1 b$ c$ 
;
Mov  B$,0
Mov  DI,Offset B$
Mov  AX,HANDLE_1
Call DiskInput
Mov  C$,0
Mov  DI,Offset C$
Mov  AX,HANDLE_1
Call DiskInput
;
;close 1 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;PRINT b$ 
;
Mov  SI,Offset B$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;kill a$ 
;
Mov  DX,Offset A$
Mov  AH,41h
Int  21h
Call TrapError

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




TrapError Proc Near 
Jnc  NoError 
Mov  Err,AX
NoError: 
Ret
TrapError Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DiskInput Proc Near 
;
;DI = destination String 
;
Mov  $Handle,AX 
Xor  AX,AX 
Mov  SI,AX 
Mov  [DI],Byte Ptr 0 
Mov  Eof,AX 
_DiskInputLoop: 
Mov  CX,1 
Mov  $Work1,0 
Mov  BX,$Handle 
Mov  DX,Offset $Work1 
Mov  AH,3fh 
Int  21h 
Cmp  AX,1 
Je   DiskInputOk 
Mov  Eof,1 
Jmp  _DiskInputExit 
DiskInputOk: 
Cmp  $Work1,13 
Je   _GetLineFeed 
Cmp  $Work1,44 
Je   _DiskInputExit 
Cmp  $Work1,26 
Je   _DiskEof 
Mov  AL,$Work1 
Mov  [DI],AL 
Inc  DI 
Inc  SI 
Cmp  SI, 81 
Jne  _DiskInputLoop 
_GetLineFeed: 
Mov  CX,1 
Mov  $Work1,0 
Mov  BX,$Handle 
Mov  DX,Offset $Work1 
Mov  AH,3fh 
Int  21h 
_DiskInputExit: 
Mov  [DI],Byte Ptr 0 
Ret 
_DiskEof: 
Mov  Eof,1 
Mov  [DI],Byte Ptr 0 
Ret
DiskInput Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Zero        DB '0',0
$Handle      DW 0
Eof          DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "Junk",0
HANDLE_1     DW  0
$tring_04    DB "abcdefghi,jklmnopqrstuvwxyz",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
B$           DB 81 DUP(?)
C$           DB 81 DUP(?)
Data Ends

End
