;Ŀ
; DEMO17.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:07:32                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;PRINT "Creating 1st file..." 
;
Mov  SI,Offset $tring_01
Call PrintStr
Call SetCursor
Call DoCrLf
;
;open "one" for output as 1 
;
Mov  DX,Offset $tring_02
Xor  CX,CX     ; normal read/write attribute
Mov  Eof,CX
Mov  AH,3Ch    ; create file 
Int  21h
Call TrapError
Mov  HANDLE_1,AX
Mov  BX,AX
Mov  AH,3Eh    ; close file
Int  21h
Call TrapError
Mov  DX,Offset $tring_02
Mov  AL,1
Mov  AH,3DH    ; open file for writing
Int  21h
Call TrapError
;
;for a = 1 to 15 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,15       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,15
Cmp  AX,A       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;Print #1 "abcdefghijklmnopqrstuvwxyz" 
;
Mov  SI,Offset $tring_05
Call Len
Mov  CX,AX
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  DX,Offset $tring_05
Mov  AH,40h
Int  21h
Call TrapError
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  CX,2
Mov  DX,Offset $CrLf
Mov  AH,40h
Int  21h
Call TrapError
;
;next 
;
Jmp ForLoop_01
ForLoop_01A:
;
;close 1 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;PRINT "Creating 2nd file..." 
;
Mov  SI,Offset $tring_06
Call PrintStr
Call SetCursor
Call DoCrLf
;
;open "two" for output as 1 
;
Mov  DX,Offset $tring_07
Xor  CX,CX     ; normal read/write attribute
Mov  Eof,CX
Mov  AH,3Ch    ; create file 
Int  21h
Call TrapError
Mov  HANDLE_1,AX
Mov  BX,AX
Mov  AH,3Eh    ; close file
Int  21h
Call TrapError
Mov  DX,Offset $tring_07
Mov  AL,1
Mov  AH,3DH    ; open file for writing
Int  21h
Call TrapError
;
;for a = 1 to 15 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_02:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_02_NegativeStep
Mov  AX,A
Cmp  AX,15       ;Ascending Step
Jle ForLoop_02Okay
Jmp ForLoop_02A
ForLoop_02_NegativeStep:
Mov  AX,15
Cmp  AX,A       ;Descending Step
Jle ForLoop_02Okay
Jmp ForLoop_02A
ForLoop_02Okay:
;
;Print #1 " 1234567890" 
;
Mov  SI,Offset $tring_08
Call Len
Mov  CX,AX
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  DX,Offset $tring_08
Mov  AH,40h
Int  21h
Call TrapError
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  CX,2
Mov  DX,Offset $CrLf
Mov  AH,40h
Int  21h
Call TrapError
;
;next 
;
Jmp ForLoop_02
ForLoop_02A:
;
;close 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;PRINT "Merging files..." 
;
Mov  SI,Offset $tring_09
Call PrintStr
Call SetCursor
Call DoCrLf
;
;open "one" for input as 1 
;
Mov  DX,Offset $tring_02   
Xor  AX,AX
Mov  Eof,AX
Mov  AH,3DH    ; open file for reading
Int  21h
Call TrapError
Mov  HANDLE_1,AX
;
;open "two" for input as 2 
;
Mov  DX,Offset $tring_07   
Xor  AX,AX
Mov  Eof,AX
Mov  AH,3DH    ; open file for reading
Int  21h
Call TrapError
Mov  HANDLE_2,AX
;
;open "Three" for output as 3 
;
Mov  DX,Offset $tring_11
Xor  CX,CX     ; normal read/write attribute
Mov  Eof,CX
Mov  AH,3Ch    ; create file 
Int  21h
Call TrapError
Mov  HANDLE_3,AX
Mov  BX,AX
Mov  AH,3Eh    ; close file
Int  21h
Call TrapError
Mov  DX,Offset $tring_11
Mov  AL,1
Mov  AH,3DH    ; open file for writing
Int  21h
Call TrapError
;
;DO
;
DoLoop_01:
;
;IF not eof  = 0 THEN
;
Mov  AX,0
Cmp  AX,EOF
Je   _True_01
Jmp  _EndIf_01
_True_01:
;
;input #1 a$ 
;
Mov  A$,0
Mov  DI,Offset A$
Mov  AX,HANDLE_1
Call DiskInput
;
;input #2 b$ 
;
Mov  B$,0
Mov  DI,Offset B$
Mov  AX,HANDLE_2
Call DiskInput
;
;PRINT #3 a$ b$ 
;
Mov  SI,Offset A$
Call Len
Mov  CX,AX
Mov  AX,HANDLE_3
Mov  BX,AX
Mov  DX,Offset A$
Mov  AH,40h
Int  21h
Call TrapError
Mov  SI,Offset B$
Call Len
Mov  CX,AX
Mov  AX,HANDLE_3
Mov  BX,AX
Mov  DX,Offset B$
Mov  AH,40h
Int  21h
Call TrapError
Mov  AX,HANDLE_3
Mov  BX,AX
Mov  CX,2
Mov  DX,Offset $CrLf
Mov  AH,40h
Int  21h
Call TrapError
;
;ELSE
;
Jmp _EndIf_01A
_EndIf_01:
;
;EXIT LOOP
;
Jmp DoLoop_01A
;
;END IF
;
_EndIf_01A:
;
;LOOP
;
Jmp DoLoop_01
DoLoop_01A:
;
;close 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
Mov  AX,HANDLE_2
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
Mov  AX,HANDLE_3
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;PRINT "Contents of Merged file..." 
;
Mov  SI,Offset $tring_15
Call PrintStr
Call SetCursor
Call DoCrLf
;
;open "Three" for input as 1 
;
Mov  DX,Offset $tring_11   
Xor  AX,AX
Mov  Eof,AX
Mov  AH,3DH    ; open file for reading
Int  21h
Call TrapError
Mov  HANDLE_1,AX
;
;DO
;
DoLoop_02:
;
;IF not eof  = 0 THEN
;
Mov  AX,0
Cmp  AX,EOF
Je   _True_02
Jmp  _EndIf_02
_True_02:
;
;input #1 a$ 
;
Mov  A$,0
Mov  DI,Offset A$
Mov  AX,HANDLE_1
Call DiskInput
;
;PRINT a$ 
;
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;ELSE
;
Jmp _EndIf_02A
_EndIf_02:
;
;EXIT LOOP
;
Jmp DoLoop_02A
;
;END IF
;
_EndIf_02A:
;
;LOOP
;
Jmp DoLoop_02
DoLoop_02A:
;
;close 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
Mov  AX,HANDLE_2
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
Mov  AX,HANDLE_3
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;PRINT "Deleting demonstration files..." 
;
Mov  SI,Offset $tring_16
Call PrintStr
Call SetCursor
Call DoCrLf
;
;kill "One" 
;
Mov  DX,Offset $tring_17
Mov  AH,41h
Int  21h
Call TrapError
;
;kill "Two" 
;
Mov  DX,Offset $tring_18
Mov  AH,41h
Int  21h
Call TrapError
;
;kill "Three" 
;
Mov  DX,Offset $tring_11   
Mov  AH,41h
Int  21h
Call TrapError
;
;PRINT 
;
Call DoCrLf
;
;PRINT "All Done 
;
Mov  SI,Offset $tring_19
Call PrintStr
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




TrapError Proc Near 
Jnc  NoError 
Mov  Err,AX
NoError: 
Ret
TrapError Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DiskInput Proc Near 
;
;DI = destination String 
;
Mov  $Handle,AX 
Xor  AX,AX 
Mov  SI,AX 
Mov  [DI],Byte Ptr 0 
Mov  Eof,AX 
_DiskInputLoop: 
Mov  CX,1 
Mov  $Work1,0 
Mov  BX,$Handle 
Mov  DX,Offset $Work1 
Mov  AH,3fh 
Int  21h 
Cmp  AX,1 
Je   DiskInputOk 
Mov  Eof,1 
Jmp  _DiskInputExit 
DiskInputOk: 
Cmp  $Work1,13 
Je   _GetLineFeed 
Cmp  $Work1,44 
Je   _DiskInputExit 
Cmp  $Work1,26 
Je   _DiskEof 
Mov  AL,$Work1 
Mov  [DI],AL 
Inc  DI 
Inc  SI 
Cmp  SI, 81 
Jne  _DiskInputLoop 
_GetLineFeed: 
Mov  CX,1 
Mov  $Work1,0 
Mov  BX,$Handle 
Mov  DX,Offset $Work1 
Mov  AH,3fh 
Int  21h 
_DiskInputExit: 
Mov  [DI],Byte Ptr 0 
Ret 
_DiskEof: 
Mov  Eof,1 
Mov  [DI],Byte Ptr 0 
Ret
DiskInput Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Zero        DB '0',0
$Handle      DW 0
Eof          DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "Creating 1st file...",0
$tring_02    DB "one",0
HANDLE_1     DW  0
A            DW  0
$tring_05    DB "abcdefghijklmnopqrstuvwxyz",0
$tring_06    DB "Creating 2nd file...",0
$tring_07    DB "two",0
$tring_08    DB " 1234567890",0
$tring_09    DB "Merging files...",0
HANDLE_2     DW  0
$tring_11    DB "Three",0
HANDLE_3     DW  0
$tring_15    DB "Contents of Merged file...",0
$tring_16    DB "Deleting demonstration files...",0
$tring_17    DB "One",0
$tring_18    DB "Two",0
$tring_19    DB "All Done",0

;_________________System Un-Initialized Data_________________

$Work1       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
B$           DB 81 DUP(?)
Data Ends

End
