;Ŀ
; DEMO30.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:12:35                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;a$ = "Beatles" 
;
Mov  SI,Offset $tring_01
Mov  DI,Offset a$
Call MoveStr
;
;b$ = "Rolling Stones" 
;
Mov  SI,Offset $tring_03
Mov  DI,Offset b$
Call MoveStr
;
;c$ = "------------------------" 
;
Mov  SI,Offset $tring_05
Mov  DI,Offset c$
Call MoveStr
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "Before swapping strings..." 
;
Mov  SI,Offset $tring_07
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT a$ 
;
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT b$ 
;
Mov  SI,Offset B$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "After swapping strings" 
;
Mov  SI,Offset $tring_08
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;swap a$ b$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset a$
Mov  DI,Offset $Work0
Call Movestr
Mov  SI,Offset b$
Mov  DI,Offset a$
Call Movestr
Mov  SI,Offset $Work0
Mov  DI,Offset b$
Call Movestr
;
;PRINT a$ 
;
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT b$ 
;
Mov  SI,Offset B$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;a = 100 
;
Xor  AX,AX
Add  AX,100
Mov  A,AX
;
;b = 200 
;
Xor  AX,AX
Add  AX,200
Mov  B,AX
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "Before swapping numbers..." 
;
Mov  SI,Offset $tring_11
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT a 
;
Mov  AX,A
Call PrintNum
Call SetCursor
Call DoCrLf
;
;PRINT b 
;
Mov  AX,B
Call PrintNum
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "After swapping numbers" 
;
Mov  SI,Offset $tring_12
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT c$ 
;
Mov  SI,Offset C$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;swap a b 
;
Mov  AX,a
Mov  BX,b
Mov  a,BX
Mov  b,AX
;
;PRINT a 
;
Mov  AX,A
Call PrintNum
Call SetCursor
Call DoCrLf
;
;PRINT b 
;
Mov  AX,B
Call PrintNum
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




PrintNum Proc Near
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  AX
Cmp  AX,32768 
Jb PositiveNumber 
Neg AX 
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Mov  DL,'-'
Mov  AH,2
Int  21h
Pop  AX
PositiveNumber:
Xor  CX,CX
GetAnotherDigit:
Inc  CX
Xor  DX,DX
Div $Base
Push DX
Cmp  AX,0
Jne GetAnotherDigit
PrntDigit:
Pop  AX
Add  AL,'0'
Push AX
Push BX
Push CX
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  CX
Pop  BX
Pop  AX
Mov  DL,AL
Mov  AH,2
Int  21h
Loop PrntDigit
Inc  $Xcur
Ret
PrintNum Endp




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "Beatles",0
$tring_03    DB "Rolling Stones",0
$tring_05    DB "------------------------",0
$tring_07    DB "Before swapping strings...",0
$tring_08    DB "After swapping strings",0
A            DW  0
B            DW  0
$tring_11    DB "Before swapping numbers...",0
$tring_12    DB "After swapping numbers",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
B$           DB 81 DUP(?)
C$           DB 81 DUP(?)
Data Ends

End
