;Ŀ
; DEMO31.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:13:02                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;PRINT "This should print the number 24000 twice" 
;
Mov  SI,Offset $tring_01
Call PrintStr
Call SetCursor
Call DoCrLf
;
;for a = 1 to 20 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,20       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,20
Cmp  AX,A       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;for b = 1 to 30 
;
Mov  AX,1
Sub  AX,1
Mov  B,AX
ForLoop_02:
Mov  AX,1
Add  B,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_02_NegativeStep
Mov  AX,B
Cmp  AX,30       ;Ascending Step
Jle ForLoop_02Okay
Jmp ForLoop_02A
ForLoop_02_NegativeStep:
Mov  AX,30
Cmp  AX,B       ;Descending Step
Jle ForLoop_02Okay
Jmp ForLoop_02A
ForLoop_02Okay:
;
;for c = 1 to 40 
;
Mov  AX,1
Sub  AX,1
Mov  C,AX
ForLoop_03:
Mov  AX,1
Add  C,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_03_NegativeStep
Mov  AX,C
Cmp  AX,40       ;Ascending Step
Jle ForLoop_03Okay
Jmp ForLoop_03A
ForLoop_03_NegativeStep:
Mov  AX,40
Cmp  AX,C       ;Descending Step
Jle ForLoop_03Okay
Jmp ForLoop_03A
ForLoop_03Okay:
;
;d = d + 1 
;
Xor  AX,AX
Add  AX,D
Add  AX,1
Mov  D,AX
;
;next 
;
Jmp ForLoop_03
ForLoop_03A:
;
;next 
;
Jmp ForLoop_02
ForLoop_02A:
;
;next 
;
Jmp ForLoop_01
ForLoop_01A:
;
;PRINT d 
;
Mov  AX,D
Call PrintNum
Call SetCursor
Call DoCrLf
;
;d = 0 
;
Xor  AX,AX
Add  AX,0
Mov  D,AX
;
;for a = 1 to 20 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_04:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_04_NegativeStep
Mov  AX,A
Cmp  AX,20       ;Ascending Step
Jle ForLoop_04Okay
Jmp ForLoop_04A
ForLoop_04_NegativeStep:
Mov  AX,20
Cmp  AX,A       ;Descending Step
Jle ForLoop_04Okay
Jmp ForLoop_04A
ForLoop_04Okay:
;
;for b = 1 to 30 
;
Mov  AX,1
Sub  AX,1
Mov  B,AX
ForLoop_05:
Mov  AX,1
Add  B,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_05_NegativeStep
Mov  AX,B
Cmp  AX,30       ;Ascending Step
Jle ForLoop_05Okay
Jmp ForLoop_05A
ForLoop_05_NegativeStep:
Mov  AX,30
Cmp  AX,B       ;Descending Step
Jle ForLoop_05Okay
Jmp ForLoop_05A
ForLoop_05Okay:
;
;for c = 1 to 40 
;
Mov  AX,1
Sub  AX,1
Mov  C,AX
ForLoop_06:
Mov  AX,1
Add  C,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_06_NegativeStep
Mov  AX,C
Cmp  AX,40       ;Ascending Step
Jle ForLoop_06Okay
Jmp ForLoop_06A
ForLoop_06_NegativeStep:
Mov  AX,40
Cmp  AX,C       ;Descending Step
Jle ForLoop_06Okay
Jmp ForLoop_06A
ForLoop_06Okay:
;
;d = d + 1 
;
Xor  AX,AX
Add  AX,D
Add  AX,1
Mov  D,AX
;
;next 
;
Jmp ForLoop_06
ForLoop_06A:
;
;next 
;
Jmp ForLoop_05
ForLoop_05A:
;
;next 
;
Jmp ForLoop_04
ForLoop_04A:
;
;PRINT d 
;
Mov  AX,D
Call PrintNum
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




PrintNum Proc Near
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  AX
Cmp  AX,32768 
Jb PositiveNumber 
Neg AX 
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Mov  DL,'-'
Mov  AH,2
Int  21h
Pop  AX
PositiveNumber:
Xor  CX,CX
GetAnotherDigit:
Inc  CX
Xor  DX,DX
Div $Base
Push DX
Cmp  AX,0
Jne GetAnotherDigit
PrntDigit:
Pop  AX
Add  AL,'0'
Push AX
Push BX
Push CX
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  CX
Pop  BX
Pop  AX
Mov  DL,AL
Mov  AH,2
Int  21h
Loop PrntDigit
Inc  $Xcur
Ret
PrintNum Endp




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "This should print the number 24000 twice",0
A            DW  0
B            DW  0
C            DW  0
D            DW  0

;_________________System Un-Initialized Data_________________


;_________________Users Un-Initialized Data__________________

Data Ends

End
