;Ŀ
; DEMO36.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:15:23                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;A = VIDEOCARD 
;
Xor  AX,AX
Mov  $Var0,AX
Call VideoCard
Add  AX,$Var0
Mov  A,AX
;
;IF A = &HB000 THEN 
;
Cmp  A,-20480
Je   _True_01
Jmp  _EndIf_01
_True_01:
;
;A$ = "Monochrome" 
;
Mov  SI,Offset $tring_02
Mov  DI,Offset A$
Call MoveStr
;
;ELSE 
;
Jmp _EndIf_01A
_EndIf_01:
;
;A$ = "Color" 
;
Mov  SI,Offset $tring_04
Mov  DI,Offset A$
Call MoveStr
;
;END IF 
;
_EndIf_01A:
;
;LOCATE 3 1 
;
Mov  $Ycur,3
Mov  $Xcur,1
;
;PRINT "This demo detected a " A$ " Video Adapter." 
;
Mov  SI,Offset $tring_05
Call PrintStr
Call SetCursor
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Mov  SI,Offset $tring_06
Call PrintStr
Call SetCursor
Call DoCrLf
;
;IF A$ = "Color" THEN
;
Mov  SI,Offset A$
Mov  DI,Offset $tring_04   
Call StrCompare
Je   _True_02
Jmp  _EndIf_02
_True_02:
;
;DEF SEG = &HB800 
;
Xor  AX,AX
Add  AX,-18432
Mov  DEFSEG,AX
;
;END IF
;
_EndIf_02:
;
;IF A$ = "Monochrome" THEN
;
Mov  SI,Offset A$
Mov  DI,Offset $tring_02   
Call StrCompare
Je   _True_03
Jmp  _EndIf_03
_True_03:
;
;DEF SEG = &HB000 
;
Xor  AX,AX
Add  AX,-20480
Mov  DEFSEG,AX
;
;END IF
;
_EndIf_03:
;
;OS = 0 
;
Xor  AX,AX
Add  AX,0
Mov  OS,AX
;
;FOR Letter = 65 TO 90 
;
Mov  AX,65
Sub  AX,1
Mov  LETTER,AX
ForLoop_01:
Mov  AX,1
Add  LETTER,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,LETTER
Cmp  AX,90       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,90
Cmp  AX,LETTER       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;POKE OS Letter 
;
Mov  DI,OS ;Offset
Mov  BX,Letter ;Value
Call Poke
;
;INCR OS 2 
;
Mov   BX,2
Add   OS,BX
;
;NEXT 
;
Jmp ForLoop_01
ForLoop_01A:
;
;LOCATE 5 1 
;
Mov  $Ycur,5
Mov  $Xcur,1
;
;PRINT "The top line of your screen should have upper case letters displayed." 
;
Mov  SI,Offset $tring_11
Call PrintStr
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




StrCompare Proc Near 
Push AX 
Push DI 
Push SI 
Cld 
StrCmp1: 
Lodsb 
Scasb 
Jne  StrCmp2 
Or   AL,AL 
Jne StrCmp1 
StrCmp2: 
Pop  SI 
Pop  DI 
Pop  AX 
Ret 
StrCompare Endp 


 
 
VideoCard Proc Near 
Mov  AH,0FH 
Int  10H 
And  AL,0FFH 
Cmp  AL,7 
Je   VC_Mono 
Mov  AX,0B800H 
Jmp  VC_Exit 
VC_Mono: 
Mov  AX,0B000H 
VC_Exit: 
Ret 
VideoCard Endp 
 
 


Poke Proc Near 
Push DS 
Mov  AX,DefSeg 
Mov  DS,AX 
Mov  [DI],BL 
Pop  DS 
Ret 
Poke Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

A            DW  0
$tring_02    DB "Monochrome",0
$tring_04    DB "Color",0
$tring_05    DB "This demo detected a ",0
$tring_06    DB " Video Adapter.",0
&HB800       DW  0
&HB000       DW  0
OS           DW  0
LETTER       DW  0
$tring_11    DB "The top line of your screen should have upper case letters displayed.",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
Data Ends

End
