;Ŀ
; DEMO46.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:19:58                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Setup
Call Cls
Mov  SI,Offset $tring_02
Call PrintStr
Call SetCursor
Call DoCrLf
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
Mov  AX,19
Push AX
Mov  AX,44
Push AX
Mov  AX,8
Push AX
Mov  AX,30
Push AX
Call Frame
Mov  AX,10
Push AX
Mov  AX,Offset A$
Push AX
Mov  AX,9
Push AX
Mov  AX,32
Push AX
Call List
Call Choose
Mov  $Ycur,23
Mov  $Xcur,26
Mov  SI,Offset $tring_03
Call PrintStr
Call SetCursor
Mov  SI,Offset CHOICE$
Call PrintStr
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




SetAttribute Proc Near 
Push CX 
Mov  CL,4 
Shl  AX,CL 
Pop  BX 
Add  AX,BX 
Mov  $Attr,AX 
Ret 
SetAttribute Endp 


 
 
ChangeAttr Proc Near 
Push BP 
Mov  BP,SP 
Mov  AX,[BP][6] 
Mov  BX,160 
IMul BX 
Mov  $Var7,AX 
Sub  AX,160 
Add  AX,[BP][4] 
Add  AX,[BP][4] 
Dec  AX 
Mov  $Var7,AX 
Mov  $Var8,AX 
Add  AX,[BP][8] 
Add  AX,[BP][8] 
Dec  AX 
Dec  AX 
Mov  $Var8,AX 
Xor  AX,AX 
Mov  $Var0,AX 
Call VideoCard 
Add  AX,$Var0 
Mov  DefSeg,AX 
Mov  AX,$Var7 
Dec  AX 
Dec  AX 
Mov  $Var9,AX 
CA_Loop_03: 
Mov  AX,2 
Add  $Var9,AX 
Mov  AX,$Var9 
Cmp  AX,$Var8 
Jle  CA_Loop_03_OK 
Jmp  CA_Loop_03A 
CA_Loop_03_OK: 
Mov  DI,$Var9 
Mov  AX,[BP][12] 
Mov  BX,[BP][10] 
Mov  CL,4 
Shl  AX,CL 
Add  BX,AX 
Call Poke 
Jmp  CA_Loop_03 
CA_Loop_03A: 
Pop  BP 
Ret  10 
ChangeAttr Endp 
 
 
 
 
VideoCard Proc Near 
Mov  AH,0FH 
Int  10H 
And  AL,0FFH 
Cmp  AL,7 
Je   VC_Mono 
Mov  AX,0B800H 
Jmp  VC_Exit 
VC_Mono: 
Mov  AX,0B000H 
VC_Exit: 
Ret 
VideoCard Endp 
 
 
 
 
Frame Proc Near 
Push BP 
Mov  BP,SP 
Xor  AX,AX
Mov  $Var2,AX 
Mov  $Var3,AX 
Mov  $Var4,AX 
Mov  DI,Offset $Work3 
Call Nullstr 
Mov  AX,[BP][8] 
Sub  AX,[BP][4] 
Dec  AX 
Mov  $Var2,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $Frame2 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][6] 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Call DoCrLf 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame4 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $pace 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame4 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][6] 
Inc  AX 
Mov  $Var3,AX 
Mov  AX,[BP][10] 
Sub  AX,[BP][6] 
Mov  $Var4,AX 
Mov  AX,$Var4 
Mov  $Var5,AX 
Mov  AX,$Var3 
Dec  AX 
Mov  $Var2,AX 
FrameForLoop_01: 
Mov  AX,1 
Add  $Var2,AX 
Mov  AX,1 
Cmp  AX,0 
Jl   FrameForLoop_01_NegativeStep 
Mov  AX,$Var2 
Cmp  AX,[BP][10] 
Jle  FrameForLoop_01_OK 
Jmp  FrameForLoop_01A 
FrameForLoop_01_NegativeStep: 
Mov  AX,$Var4 
Cmp  AX,$Var2 
Jle  FrameForLoop_01_OK 
Jmp  FrameForLoop_01A 
FrameForLoop_01_OK: 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Call DoCrLf 
Jmp  FrameForLoop_01 
FrameForLoop_01A: 
Mov  AX,[BP][8] 
Sub  AX,[BP][4] 
Dec  AX 
Mov  $Var2,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame5 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $Frame2 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame6 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][10] 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Pop  BP 
Ret  08 
Frame Endp 
 
 


Repeat$ Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,Offset $Work1 
Call Nullstr 
Mov  CX,[BP][4] 
RepeatLoop: 
Mov  SI,[BP][6] 
Mov  DI,Offset $Work1 
Call Concat 
Loop RepeatLoop 
Pop  BP 
Ret  04 
Repeat$ Endp 




Poke Proc Near 
Push DS 
Mov  AX,DefSeg 
Mov  DS,AX 
Mov  [DI],BL 
Pop  DS 
Ret 
Poke Endp 




Getkey Proc Near 
Xor  AX,AX 
Int  16h 
Cmp  AL,0 
Je   ExtendedKey 
Xor  AH,AH 
Jmp  RegularKey 
ExtendedKey: 
Mov  AL,AH 
Xor  AH,AH 
Neg  AX 
RegularKey: 
Ret 
GetKey Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 




ArrayPut Proc Near 
Push BP 
Mov  BP,SP 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  DI,[BP][04] 
Add  DI,AX 
Inc  DI 
Inc  DI 
Push DI 
Call NullStr 
Pop  DI 
Mov  SI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayPut Endp 




ArrayGet Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,[BP][08] 
Call NullStr 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  SI,[BP][04] 
Add  SI,AX 
Inc  SI 
Inc  SI 
Mov  DI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayGet Endp 




Setup Proc Near
Push BP
Mov  BP,SP
Mov  AX,Offset $tring_05
Push AX
Mov  AX,1
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_06
Push AX
Mov  AX,2
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_07
Push AX
Mov  AX,3
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_08
Push AX
Mov  AX,4
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_09
Push AX
Mov  AX,5
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_10
Push AX
Mov  AX,6
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_11
Push AX
Mov  AX,7
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_12
Push AX
Mov  AX,8
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_13
Push AX
Mov  AX,9
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Mov  AX,Offset $tring_14
Push AX
Mov  AX,10
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
Pop  BP
Ret  00
Setup Endp


List Proc Near
Push BP
Mov  BP,SP
Mov  L_LIST_YY,0
Mov  L_LIST_TMP,0
Mov  DI,Offset L_LIST_TMP$
Call Nullstr
Mov  AX,1
Sub  AX,1
Mov  L_LIST_TMP,AX
ListForLoop_01:
Mov  AX,1
Add  L_LIST_TMP,AX
Mov  AX,1
Cmp  AX,0
Jl   ListForLoop_01_NegativeStep
Mov  AX,L_LIST_TMP
Cmp  AX,[BP][10]       ;Ascending Step
Jle ListForLoop_01Okay
Jmp ListForLoop_01A
ListForLoop_01_NegativeStep:
Mov  AX,[BP][10]
Cmp  AX,L_LIST_TMP       ;Descending Step
Jle ListForLoop_01Okay
Jmp ListForLoop_01A
ListForLoop_01Okay:
Mov  AX,Offset L_LIST_TMP$
Push AX
Mov  AX,L_LIST_TMP
Push AX
Mov  AX,[BP][08]
Push AX
Call ArrayGet
Xor  AX,AX
Add  AX,[BP][06]
Add  AX,L_LIST_Tmp
Add  AX,-1
Mov  L_LIST_YY,AX
Mov  AX,L_LIST_YY
Mov  $Ycur,AX
Mov  AX,[BP][04]
Mov  $Xcur,AX
Mov  SI,Offset L_LIST_TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
Jmp ListForLoop_01
ListForLoop_01A:
Pop  BP
Ret  08
List Endp


Choose Proc Near
Push BP
Mov  BP,SP
Mov  L_CHOOSE_START,0
Mov  L_CHOOSE_ENND,0
Mov  L_CHOOSE_POINTER,0
Mov  L_CHOOSE_A,0
Mov  L_CHOOSE_TMP,0
Xor  AX,AX
Add  AX,9
Mov  L_CHOOSE_START,AX
Xor  AX,AX
Add  AX,L_CHOOSE_START
Add  AX,10
Add  AX,-1
Mov  L_CHOOSE_ENND,AX
Mov  AX,0
Push AX 
Mov  AX,7
Push AX 
Mov  AX,11
Push AX 
Mov  AX,L_CHOOSE_Start
Push AX 
Mov  AX,32
Push AX 
Call ChangeAttr
Xor  AX,AX
Add  AX,L_CHOOSE_START
Mov  L_CHOOSE_POINTER,AX
ChooseDoLoop_01:
Xor  AX,AX
Mov  $Var0,AX
Call GetKey
Add  AX,$Var0
Mov  L_CHOOSE_A,AX
Cmp  L_CHOOSE_A,-80
Je   Choose_True_01
Jmp  Choose_EndIf_01
Choose_True_01:
Inc  L_CHOOSE_POINTER
Choose_EndIf_01:
Cmp  L_CHOOSE_A,-72
Je   Choose_True_02
Jmp  Choose_EndIf_02
Choose_True_02:
Dec  L_CHOOSE_POINTER
Choose_EndIf_02:
Cmp  L_CHOOSE_A,13
Je   Choose_True_03
Jmp  Choose_EndIf_03
Choose_True_03:
Jmp ChooseDoLoop_01A
Choose_EndIf_03:
Mov  AX,L_CHOOSE_POINTER
Cmp  AX,L_CHOOSE_ENND
Jg   Choose_True_04
Jmp  Choose_EndIf_04
Choose_True_04:
Dec  L_CHOOSE_POINTER
Choose_EndIf_04:
Mov  AX,L_CHOOSE_POINTER
Cmp  AX,L_CHOOSE_START
Jl   Choose_True_05
Jmp  Choose_EndIf_05
Choose_True_05:
Inc  L_CHOOSE_POINTER
Choose_EndIf_05:
Xor  AX,AX
Add  AX,L_CHOOSE_POINTER
Add  AX,-1
Mov  L_CHOOSE_TMP,AX
Mov  AX,7
Push AX 
Mov  AX,0
Push AX 
Mov  AX,11
Push AX 
Mov  AX,L_CHOOSE_Tmp
Push AX 
Mov  AX,32
Push AX 
Call ChangeAttr
Mov  AX,0
Push AX 
Mov  AX,7
Push AX 
Mov  AX,11
Push AX 
Mov  AX,L_CHOOSE_Pointer
Push AX 
Mov  AX,32
Push AX 
Call ChangeAttr
Xor  AX,AX
Add  AX,L_CHOOSE_POINTER
Add  AX,1
Mov  L_CHOOSE_TMP,AX
Mov  AX,7
Push AX 
Mov  AX,0
Push AX 
Mov  AX,11
Push AX 
Mov  AX,L_CHOOSE_Tmp
Push AX 
Mov  AX,32
Push AX 
Call ChangeAttr
Jmp ChooseDoLoop_01
ChooseDoLoop_01A:
Mov   BX,L_CHOOSE_START
Sub   L_CHOOSE_POINTER,BX
Inc  L_CHOOSE_POINTER
Mov  AX,Offset CHOICE$
Push AX
Mov  AX,L_CHOOSE_POINTER
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayGet
Pop  BP
Ret  00
Choose Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$pace        DB 32,0 
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
$Frame1      DB 213,0
$Frame2      DB 205,0
$Frame3      DB 184,0
$Frame4      DB 179,0
$Frame5      DB 212,0
$Frame6      DB 190,0

;__________________Users Initialized Data____________________

$tring_02    DB "            Press the UP and DOWN Arrows, press ENTER to select",0
$tring_03    DB "You selected ",0
$tring_05    DB "Apples",0
$tring_06    DB "Oranges",0
$tring_07    DB "Bananas",0
$tring_08    DB "Kiwi",0
$tring_09    DB "Raspberries",0
$tring_10    DB "Raisins",0
$tring_11    DB "Cantelope",0
$tring_12    DB "Watermelon",0
$tring_13    DB "Blueberries",0
$tring_14    DB "Grapes",0
L_LIST_YY    DW  0
L_LIST_TMP   DW  0
L_CHOOSE_START DW  0
L_CHOOSE_ENND DW  0
L_CHOOSE_POINTER DW  0
L_CHOOSE_A   DW  0
L_CHOOSE_TMP DW  0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 00,12, 132 DUP(?)
CHOICE$      DB 81 DUP(?)
L_LIST_TMP$  DB 81 DUP(?)
Data Ends

End
