;Ŀ
; DEMO48.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:21:10                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;PRINT "Ŀ 
;
Mov  SI,Offset $tring_01
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT " Demonstates the BIN$ function  
;
Mov  SI,Offset $tring_02
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT " 
;
Mov  SI,Offset $tring_03
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT 
;
Call DoCrLf
;
;PRINT "Decimal     Binary 
;
Mov  SI,Offset $tring_04
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "-------    -------- 
;
Mov  SI,Offset $tring_05
Call PrintStr
Call SetCursor
Call DoCrLf
;
;for a = 1 to 15 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,15       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,15
Cmp  AX,A       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;a$ = str$ a 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,a
Call Str$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;tmp = len a$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset a$
Call Len
Add  AX,$Var0
Mov  TMP,AX
;
;if tmp = 1 then 
;
Cmp  TMP,1
Je   _True_01
Jmp  _EndIf_01
_True_01:
;
;a$ = " " + a$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_09
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset A$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;end if 
;
_EndIf_01:
;
;a$ = mid$ a$ 1 2 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset a$
Mov  DI,Offset $Work1
Mov  CX,2
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;b$ = bin$ a 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,a
Push AX
Call Bin$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset B$
Call MoveStr
;
;PRINT "  " a$ "       " b$ 
;
Mov  SI,Offset $tring_11
Call PrintStr
Call SetCursor
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Mov  SI,Offset $tring_12
Call PrintStr
Call SetCursor
Mov  SI,Offset B$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;next 
;
Jmp ForLoop_01
ForLoop_01A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




Bin$ Proc Near 
Push BP 
Mov  BP,SP 
Xor  AX,AX 
Mov  $Var0,AX 
Mov  $Var1,AX 
Mov  $Var2,AX 
Mov  $Var3,AX 
Mov  $Var4,AX 
Mov  $Var5,AX 
Mov  $Var6,AX 
Mov  $Var7,AX 
Mov  AX,[BP][4] 
Sub  AX,128 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_02 
Jmp  Bin_Fail_02 
Bin_Pass_02: 
Mov  AX,1 
Mov  $Var0,AX 
Bin_Fail_02: 
Cmp  $Var8,0 
Jl   Bin_Pass_03 
Jmp  Bin_Fail_03 
Bin_Pass_03: 
Mov  AX,[BP][4] 
Mov  $Var8,AX 
Bin_Fail_03: 
Mov  AX,$Var8 
Sub  AX,64 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_04 
Jmp  Bin_Fail_04 
Bin_Pass_04: 
Mov  AX,1 
Mov  $Var1,AX 
Bin_Fail_04: 
Cmp  $Var8,0 
Jl   Bin_Pass_05 
Jmp  Bin_Fail_05 
Bin_Pass_05: 
Mov   BX,64 
Add   $Var8,BX 
Bin_Fail_05: 
Mov  AX,$Var8 
Sub  AX,32 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_06 
Jmp  Bin_Fail_06 
Bin_Pass_06: 
Mov  AX,1 
Mov  $Var2,AX 
Bin_Fail_06: 
Cmp  $Var8,0 
Jl   Bin_Pass_07 
Jmp  Bin_Fail_07 
Bin_Pass_07: 
Mov  BX,32 
Add  $Var8,BX 
Bin_Fail_07: 
Mov  AX,$Var8 
Sub  AX,16 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_08 
Jmp  Bin_Fail_08 
Bin_Pass_08: 
Mov  AX,1 
Mov  $Var3,AX 
Bin_Fail_08: 
Cmp  $Var8,0 
Jl   Bin_Pass_09 
Jmp  Bin_Fail_09 
Bin_Pass_09: 
Mov  BX,16 
Add  $Var8,BX 
Bin_Fail_09: 
Mov  AX,$Var8 
Sub  AX,8 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_10 
Jmp  Bin_Fail_10 
Bin_Pass_10: 
Mov  AX,1 
Mov  $Var4,AX 
Bin_Fail_10: 
Cmp  $Var8,0 
Jl   Bin_Pass_11 
Jmp  Bin_Fail_11 
Bin_Pass_11: 
Mov  BX,8 
Add  $Var8,BX 
Bin_Fail_11: 
Mov  AX,$Var8 
Sub  AX,4 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_12 
Jmp  Bin_Fail_12 
Bin_Pass_12: 
Mov  AX,1 
Mov  $Var5,AX 
Bin_Fail_12: 
Cmp  $Var8,0 
Jl   Bin_Pass_13 
Jmp  Bin_Fail_13 
Bin_Pass_13: 
Mov  BX,4 
Add  $Var8,BX 
Bin_Fail_13: 
Mov  AX,$Var8 
Sub  AX,2 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_14 
Jmp  Bin_Fail_14 
Bin_Pass_14: 
Mov  AX,1 
Mov  $Var6,AX 
Bin_Fail_14: 
Cmp  $Var8,0 
Jl   Bin_Pass_15 
Jmp  Bin_Fail_15 
Bin_Pass_15: 
Mov  BX,2 
Add  $Var8,BX 
Bin_Fail_15: 
Mov  AX,$Var8 
Dec  AX 
Mov  $Var8,AX 
Cmp  $Var8,0 
Jge  Bin_Pass_16 
Jmp  Bin_Fail_16 
Bin_Pass_16: 
Mov  AX,1 
Mov  $Var7,AX 
Bin_Fail_16: 
Mov  DI,Offset $Work1 
Call Nullstr 
Mov  DI,Offset $Work2 
Mov  AX,$Var0 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var1 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var2 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var3 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var4 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var5 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var6 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Mov  DI,Offset $Work2 
Mov  AX,$Var7 
Call Str$ 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call Concat 
Pop  BP 
Ret  02 
Bin$ Endp 




Str$ Proc Near 
;
; AX=number to convert to string 
; DI=address of receiving String 
;
Xor  BX,BX 
Cmp  AX,32768 
Jb   Str_PosNumber 
Neg  AX 
Mov  [DI],Byte Ptr '-'
Inc  DI 
Str_PosNumber: 
Xor  CX,CX 
Str_Another: 
Inc  CX 
Xor  DX,DX 
Div  $Base 
Push DX 
Cmp  AX,0 
Jne  Str_another 
EmitDigit: 
Pop  AX 
Add  AL,'0' 
Mov  [DI],AL 
Inc  DI 
Loop EmitDigit 
Mov  [DI],Byte Ptr 0 
Ret 
Str$ Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Zero        DB '0',0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "Ŀ",0
$tring_02    DB " Demonstates the BIN$ function ",0
$tring_03    DB "",0
$tring_04    DB "Decimal     Binary",0
$tring_05    DB "-------    --------",0
A            DW  0
TMP          DW  0
$tring_09    DB " ",0
$tring_11    DB "  ",0
$tring_12    DB "       ",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
B$           DB 81 DUP(?)
Data Ends

End
