;Ŀ
; DEMO58.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:27:07                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;Set_Up 
;
Call Set_Up
;
;FRAME 10 10 30 20 
;
Mov  AX,20
Push AX
Mov  AX,30
Push AX
Mov  AX,10
Push AX
Mov  AX,10
Push AX
Call Frame
;
;LOCATE 15 12 0 
;
Mov  $Ycur,15
Mov  $Xcur,12
Mov  AX,0
Call ShowHideCursor
;
;PRINT "This is Window 1 
;
Mov  SI,Offset $tring_06
Call PrintStr
Call SetCursor
Call DoCrLf
;
;GETSCREEN B$ 
;
Call GetScreen
Mov  SI,Offset $ScrnBuf 
Mov  DI,Offset B$
Call MoveStr
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;FRAME 45 5 79 10 
;
Mov  AX,10
Push AX
Mov  AX,79
Push AX
Mov  AX,5
Push AX
Mov  AX,45
Push AX
Call Frame
;
;LOCATE 7 53 
;
Mov  $Ycur,7
Mov  $Xcur,53
;
;PRINT "This is Window 2 
;
Mov  SI,Offset $tring_07
Call PrintStr
Call SetCursor
Call DoCrLf
;
;GETSCREEN C$ 
;
Call GetScreen
Mov  SI,Offset $ScrnBuf 
Mov  DI,Offset C$
Call MoveStr
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;FRAME 5 5 50 15 
;
Mov  AX,15
Push AX
Mov  AX,50
Push AX
Mov  AX,5
Push AX
Mov  AX,5
Push AX
Call Frame
;
;LOCATE 10 19 
;
Mov  $Ycur,10
Mov  $Xcur,19
;
;PRINT "This is Window 3 
;
Mov  SI,Offset $tring_08
Call PrintStr
Call SetCursor
Call DoCrLf
;
;GETSCREEN D$ 
;
Call GetScreen
Mov  SI,Offset $ScrnBuf 
Mov  DI,Offset D$
Call MoveStr
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;FRAME 5 20 70 24 
;
Mov  AX,24
Push AX
Mov  AX,70
Push AX
Mov  AX,20
Push AX
Mov  AX,5
Push AX
Call Frame
;
;LOCATE 22 28 
;
Mov  $Ycur,22
Mov  $Xcur,28
;
;PRINT "This is Window 4 
;
Mov  SI,Offset $tring_09
Call PrintStr
Call SetCursor
Call DoCrLf
;
;GETSCREEN E$ 
;
Call GetScreen
Mov  SI,Offset $ScrnBuf 
Mov  DI,Offset E$
Call MoveStr
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;FRAME 12 12 60 18 
;
Mov  AX,18
Push AX
Mov  AX,60
Push AX
Mov  AX,12
Push AX
Mov  AX,12
Push AX
Call Frame
;
;LOCATE 15 26 
;
Mov  $Ycur,15
Mov  $Xcur,26
;
;PRINT "This is Window 5 
;
Mov  SI,Offset $tring_10
Call PrintStr
Call SetCursor
Call DoCrLf
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;PUTSCREEN E$ 
;
Mov  SI,Offset E$
Call PutScreen
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;PUTSCREEN D$ 
;
Mov  SI,Offset D$
Call PutScreen
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;PUTSCREEN C$ 
;
Mov  SI,Offset C$
Call PutScreen
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;PUTSCREEN B$ 
;
Mov  SI,Offset B$
Call PutScreen
;
;DELAY 1 
;
Mov  BX,1
Call Delay
;
;PUTSCREEN A$ 
;
Mov  SI,Offset A$
Call PutScreen
;
;COLOR 7 0 
;
Mov  AX,7
Mov  $FgColor,AX
Mov  AX,0
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;LOCATE Y X 1 
;
Mov  AX,Y
Mov  $Ycur,AX
Mov  AX,X
Mov  $Xcur,AX
Mov  AX,1
Call ShowHideCursor
;
;PRINT ""  ;
;
Mov  SI,Offset $tring_11
Call PrintStr
Call SetCursor

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




SetAttribute Proc Near 
Push CX 
Mov  CL,4 
Shl  AX,CL 
Pop  BX 
Add  AX,BX 
Mov  $Attr,AX 
Ret 
SetAttribute Endp 


 
 
VideoCard Proc Near 
Mov  AH,0FH 
Int  10H 
And  AL,0FFH 
Cmp  AL,7 
Je   VC_Mono 
Mov  AX,0B800H 
Jmp  VC_Exit 
VC_Mono: 
Mov  AX,0B000H 
VC_Exit: 
Ret 
VideoCard Endp 
 
 
 
 
Frame Proc Near 
Push BP 
Mov  BP,SP 
Xor  AX,AX
Mov  $Var2,AX 
Mov  $Var3,AX 
Mov  $Var4,AX 
Mov  DI,Offset $Work3 
Call Nullstr 
Mov  AX,[BP][8] 
Sub  AX,[BP][4] 
Dec  AX 
Mov  $Var2,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $Frame2 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][6] 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Call DoCrLf 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame4 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $pace 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame4 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][6] 
Inc  AX 
Mov  $Var3,AX 
Mov  AX,[BP][10] 
Sub  AX,[BP][6] 
Mov  $Var4,AX 
Mov  AX,$Var4 
Mov  $Var5,AX 
Mov  AX,$Var3 
Dec  AX 
Mov  $Var2,AX 
FrameForLoop_01: 
Mov  AX,1 
Add  $Var2,AX 
Mov  AX,1 
Cmp  AX,0 
Jl   FrameForLoop_01_NegativeStep 
Mov  AX,$Var2 
Cmp  AX,[BP][10] 
Jle  FrameForLoop_01_OK 
Jmp  FrameForLoop_01A 
FrameForLoop_01_NegativeStep: 
Mov  AX,$Var4 
Cmp  AX,$Var2 
Jle  FrameForLoop_01_OK 
Jmp  FrameForLoop_01A 
FrameForLoop_01_OK: 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Call DoCrLf 
Jmp  FrameForLoop_01 
FrameForLoop_01A: 
Mov  AX,[BP][8] 
Sub  AX,[BP][4] 
Dec  AX 
Mov  $Var2,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame5 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $Frame2 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame6 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][10] 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Pop  BP 
Ret  08 
Frame Endp 
 
 


Repeat$ Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,Offset $Work1 
Call Nullstr 
Mov  CX,[BP][4] 
RepeatLoop: 
Mov  SI,[BP][6] 
Mov  DI,Offset $Work1 
Call Concat 
Loop RepeatLoop 
Pop  BP 
Ret  04 
Repeat$ Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




Delay Proc Near 
Mov  AL,18 
Mul  BL 
Mov  BX,AX 
Xor  AH,AH 
Int  1Ah 
Add  BX,DX 
DelayLoop: 
Xor  AH,AH 
Int  1Ah 
Cmp  DX,BX 
Jne DelayLoop 
Ret 
Delay Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 




GetScreen Proc Near 
Push ES 
Push DS 
Push DS 
Pop  ES 
Call VideoCard 
Push AX 
Pop  DS 
Mov  SI,0 
Mov  DI,Offset $ScrnBuf 
Mov  CX,2000 
Cld 
Rep  Movs Word Ptr [DI],[SI] 
Pop  DS 
Pop  ES 
Ret 
GetScreen Endp 




PutScreen Proc Near 
Push DS 
Push ES 
Call VideoCard
Mov ES,AX
Mov DI,0 
Mov CX,2000 
Cld
Rep Movs Word Ptr [DI],[SI] 
Pop ES 
Pop DS
Ret 
PutScreen Endp 




Set_up Proc Near
Push BP
Mov  BP,SP
;
;X = POS 
;
Xor  AX,AX
Mov  $Var0,AX
Call GetCursor
Mov  AX,$Xcur
Add  AX,$Var0
Mov  X,AX
;
;Y = CSRLIN 
;
Xor  AX,AX
Mov  $Var0,AX
Call GetCursor
Mov  AX,$Ycur
Add  AX,$Var0
Mov  Y,AX
;
;GETSCREEN a$ 
;
Call GetScreen
Mov  SI,Offset $ScrnBuf 
Mov  DI,Offset A$
Call MoveStr
;
;COLOR 7 0 
;
Mov  AX,7
Mov  $FgColor,AX
Mov  AX,0
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
Call Cls
;
;LOCATE 12 20 0 
;
Mov  $Ycur,12
Mov  $Xcur,20
Mov  AX,0
Call ShowHideCursor
;
;PRINT "Creating Text Windows is EASY! with BASM" 
;
Mov  SI,Offset $tring_14
Call PrintStr
Call SetCursor
Call DoCrLf
;
;DELAY 2 
;
Mov  BX,2
Call Delay
Call Cls
;
;COLOR 0 7 
;
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
Pop  BP
Ret  00
Set_up Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$pace        DB 32,0 
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
$Frame1      DB 213,0
$Frame2      DB 205,0
$Frame3      DB 184,0
$Frame4      DB 179,0
$Frame5      DB 212,0
$Frame6      DB 190,0

;__________________Users Initialized Data____________________

$tring_06    DB "This is Window 1",0
$tring_07    DB "This is Window 2",0
$tring_08    DB "This is Window 3",0
$tring_09    DB "This is Window 4",0
$tring_10    DB "This is Window 5",0
$tring_11    DB  0,0
X            DW  0
Y            DW  0
$tring_14    DB "Creating Text Windows is EASY! with BASM",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 4001 DUP(?)
B$           DB 4001 DUP(?)
C$           DB 4001 DUP(?)
D$           DB 4001 DUP(?)
E$           DB 4001 DUP(?)
$ScrnBuf     DB 4000 DUP(?)  ;DO NOT move this label!  It MUST remain last. 
Data Ends

End
