;Ŀ
; DEMO62.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:30:23                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;Z$ = "This is a simple sentence designed to demonstrate the Rextract$ Function" 
;
Mov  SI,Offset $tring_01
Mov  DI,Offset Z$
Call MoveStr
;
;DO
;
DoLoop_01:
;
;IF Z$ > ""  THEN
;
Mov  SI,Offset Z$
Mov  DI,Offset $tring_03
Call StrCompare
Jg   _True_01
Jmp  _EndIf_01
_True_01:
;
;B$ = EXTRACT$ Z$ " " 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset Z$
Mov  DI,Offset $tring_04
Call Extract
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset B$
Call MoveStr
;
;PRINT B$ 
;
Mov  SI,Offset B$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;Z$ = Rextract$ Z$ " " 
;
Mov  AX,Offset $tring_04   
Push AX
Mov  AX,Offset Z$
Push AX
Call Rextract$
Mov  SI,Offset $StrFunc
Mov  DI,Offset Z$
Call MoveStr
;
;Z$ = LTRIM$ Z$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset Z$
Call Ltrim$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset Z$
Call MoveStr
;
;ELSE
;
Jmp _EndIf_01A
_EndIf_01:
;
;EXIT LOOP
;
Jmp DoLoop_01A
;
;END IF
;
_EndIf_01A:
;
;LOOP
;
Jmp DoLoop_01
DoLoop_01A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




StrCompare Proc Near 
Push AX 
Push DI 
Push SI 
Cld 
StrCmp1: 
Lodsb 
Scasb 
Jne  StrCmp2 
Or   AL,AL 
Jne StrCmp1 
StrCmp2: 
Pop  SI 
Pop  DI 
Pop  AX 
Ret 
StrCompare Endp 




Instr Proc Near 
;---------------------- 
;SI = match   (len = 1) 
;DI = main 
;output position In   AX 
;---------------------- 
Xor  AX,AX 
Mov  CX,AX 
Mov  AL,[SI]  ;load match 
InstrLoop: 
Cmp  [DI],AL 
Je   InstrExit 
Cmp  [DI],Byte ptr 0 
Je   InstrNoMatch 
Cmp  CX, 81 
Je   InstrNoMatch 
Inc  CX 
Inc  DI 
Jmp  InstrLoop 
InstrNoMatch: 
Xor  AX,AX 
Jmp  InstrDone 
InstrExit: 
Inc  CX 
Mov  AX,CX 
InstrDone: 
Ret 
Instr Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




Ltrim$ Proc Near 
;---------------------------------------- 
; SI=$Work2       Output String In   $Work1 
;---------------------------------------- 
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $Work2
Xor  CX,CX 
LtrimLoop: 
Cmp  [SI],Byte ptr 32 
Jne  LtrimDone 
Inc  SI 
Inc  CX 
Cmp  CX, 81 
Jne  LtrimLoop 
LtrimDone: 
Mov  CX, 81 
Mov  DI,Offset $Work1 
Cld 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Ret 
Ltrim$ Endp 




Extract Proc Near 
;
;SI = main$ 
;DI = match$     Len match$ = 1 only 
;
Mov  AL,[DI] 
Mov  DI,Offset $Work1 
Xor  CX,CX 
Extr_loop: 
Mov  BL,[SI] 
Cmp  BL,AL 
Je   Extr_Done 
Mov  [DI],BL 
Inc  DI 
Inc  SI 
Inc  CX 
Cmp  CX, 81 
Jne  Extr_loop 
Extr_Done: 
Mov  [DI],Byte Ptr 0 
Ret 
Extract Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




Rextract$ Proc Near
Push BP
Mov  BP,SP
;
;LOCAL A 
;
Mov  L_REXTRACT_A,0
;
;A = INSTR Main$ Match$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][04]
Mov  SI,[BP][06]
Call Instr
Add  AX,$Var0
Mov  L_REXTRACT_A,AX
;
;IF A THEN 
;
Cmp  L_REXTRACT_A,0
Jne  Rextract$_True_02
Jmp  Rextract$_EndIf_02
Rextract$_True_02:
;
;INCR A 
;
Inc  L_REXTRACT_A
;
;Rextract$ = MID$ Main$ A 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_REXTRACT_A
Dec  SI
Mov  CX,81
Sub  CX,L_REXTRACT_A
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset $STRFUNC
Call MoveStr
;
;ELSE 
;
Jmp Rextract$_EndIf_02A
Rextract$_EndIf_02:
;
;Rextract$ = "" 
;
Mov  SI,Offset $tring_08
Mov  DI,Offset $StrFunc
Call MoveStr
;
;END IF 
;
Rextract$_EndIf_02A:
Pop  BP
Ret  04
Rextract$ Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "This is a simple sentence designed to demonstrate the Rextract$ Function",0
$tring_03    DB  0,0
$tring_04    DB " ",0
L_REXTRACT_A DW  0
$tring_08    DB  0,0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

Z$           DB 81 DUP(?)
B$           DB 81 DUP(?)
$STRFUNC     DB 81 DUP(?)
Data Ends

End
