;Ŀ
; DEMO63.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:31:59                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;a$ = "-1.1" 
;
Mov  SI,Offset $tring_01
Mov  DI,Offset a$
Call MoveStr
;
;b$ = ".99" 
;
Mov  SI,Offset $tring_03
Mov  DI,Offset b$
Call MoveStr
Call Cls
;
;for z = 1 to 20 
;
Mov  AX,1
Sub  AX,1
Mov  Z,AX
ForLoop_01:
Mov  AX,1
Add  Z,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,Z
Cmp  AX,20       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,20
Cmp  AX,Z       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;a$ = fpadd$ a$ b$ 
;
Mov  AX,Offset b$
Push AX
Mov  AX,Offset a$
Push AX
Call fpadd$
Mov  SI,Offset $StrFunc
Mov  DI,Offset A$
Call MoveStr
;
;PRINT a$ 
;
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;next 
;
Jmp ForLoop_01
ForLoop_01A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




StrCompare Proc Near 
Push AX 
Push DI 
Push SI 
Cld 
StrCmp1: 
Lodsb 
Scasb 
Jne  StrCmp2 
Or   AL,AL 
Jne StrCmp1 
StrCmp2: 
Pop  SI 
Pop  DI 
Pop  AX 
Ret 
StrCompare Endp 



Remove$ Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,Offset $Work2 
Call Nullstr 
Mov  DI,Offset $Work3 
Call Nullstr 
Mov  $Var2,0 
Mov  $Var3,0 
Xor  AX,AX 
Mov  $Var0,AX 
Mov  SI,[BP][4] 
Call Len 
Add  AX,$Var0 
Mov  $Var2,AX 
Xor  AX,AX 
Mov  $Var3,AX 
RemoveForLoop_01: 
Mov  AX,1 
Add  $Var3,AX 
Mov  AX,$Var3 
Cmp  AX,$Var2 
Jle  RemoveForLoop_01_OK 
Jmp  RemoveForLoop_01A 
RemoveForLoop_01_OK: 
Mov  DI,Offset $Work4 
Call Nullstr 
Cld 
Mov  SI,[BP][4] 
Mov  DI,Offset $Work1 
Add  SI,$Var3 
Dec  SI 
Mov  CX,1 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work4 
Call Concat 
Mov  SI,Offset $Work4 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  SI,Offset $Work3 
Mov  DI,[BP][6] 
Call StrCompare 
Jne _RemoveTrue_01 
Jmp _RemoveEndIf_01 
_RemoveTrue_01: 
Mov  DI,Offset $Work4 
Call Nullstr 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work4 
Call Concat 
Mov  SI,Offset $Work3 
Mov  DI,Offset $Work4 
Call Concat 
Mov  SI,Offset $Work4 
Mov  DI,Offset $Work2 
Call MoveStr 
_RemoveEndIf_01: 
Jmp  RemoveForLoop_01 
RemoveForLoop_01A: 
Mov  DI,Offset $Work4 
Call Nullstr 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Call MoveStr 
Pop  BP 
Ret  04 
Remove$ Endp 



Replace Proc Near 
; -------------------------------- 
; match$   = $Work2 
; repl$    = $Work3 
; main$    = $Work4 
; ------------------------------- 
; Resulting string is In   $Work0 
; ------------------------------- 
Mov  DI,Offset $Work5 
Call NullStr 
Mov  DI,Offset $Work0 
Call NullStr 
Xor  AX,AX 
Mov  $Var0,AX 
Mov  SI,Offset $Work4 
Call Len 
Add  AX,$Var0 
Mov  $Var4,AX 
Mov  SI,Offset $Work2 
Call Len 
Mov  $Var5,AX 
Xor  AX,AX 
Mov  $Var6,AX 
ReplaceForLoop_01: 
Mov  AX,1 
Add  $Var6,AX 
Mov  AX,$Var6 
Cmp  AX,$Var4 
Jg   ReplaceForLoop_01A 
Cld 
Mov  SI,Offset $Work4 
Mov  DI,Offset $Work1 
Add  SI,$Var6 
Dec  SI 
Mov  CX,$Var5 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work5 
Call MoveStr 
Mov  SI,Offset $Work5 
Mov  DI,Offset $Work2 
Call StrCompare 
Jne  Replace_Fail01 
Mov  SI,Offset $Work3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,$Var5 
Add  $Var6,AX 
Dec  $Var6 
Jmp  Replace_Fail01A 
Replace_Fail01: 
Cld 
Mov  SI,Offset $Work4 
Mov  DI,Offset $Work1 
Add  SI,$Var6 
Dec  SI 
Mov  CX,1 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Replace_Fail01A: 
Jmp  ReplaceForLoop_01 
ReplaceForLoop_01A: 
Ret 
Replace Endp 




Val Proc Near 
;
; DI = string TO Convert 
;
Mov  $Var1,0       ;negative number flag 
Xor  BX,BX         ;Used to accumulate binary Values 
Mov  SI,BX         ;power register : 1,10,100,1000,10000 
Mov  CX,1          ;counts number of Digits In   String 
ValLoop: 
Mov  AX,[DI] 
Xor  AH,AH 
Cmp  AL,0          ;END of string? 
Je   ValPopStack   ;yes 
Cmp  AL,48         ;test for Valid chars:  0123456789 
Jb   ValBadChar 
Cmp  AL,57 
Jg   ValBadChar 
Sub  AL,'0'        ;Convert ascii TO binary 
Push AX 
Inc  SI            ;bump the number of Digits 
ValBadChar: 
Cmp  AL,45 
Jne ValMore 
Mov  $Var1,1 
ValMore: 
Inc  DI 
Jmp  ValLoop 
ValPopstack: 
Cmp  SI,0          ;IF SI = 0 THEN no Valid Digits 
JE   ValNull 
Pop  AX            ;get rightmost Digit 
Mul  CX            ;Multiply it by factor 1,10,100,1000,... 
Add  BX,AX         ;accumulate it 
Mov  AX,CX         ;get the factor 1,10,100,1000... 
Mov  CX,10 
Mul  CX            ;Multiply factor by 10 
Mov  CX,AX         ;And  re-save it 
Dec  SI            ;get NEXT Digit 
Cmp  SI,1          ;is it the leftmost Digit? 
Jge  ValPopStack   ;no 
Mov  AX,BX         ;yes...binary # In   AX 
Jmp  ValExit 
ValNull: 
Xor  AX,AX         ;get rid of cr 
ValExit: 
Cmp  $Var1,1 
Jne  Valgone 
Neg  AX 
Valgone: 
Ret 
Val Endp 




Str$ Proc Near 
;
; AX=number to convert to string 
; DI=address of receiving String 
;
Xor  BX,BX 
Cmp  AX,32768 
Jb   Str_PosNumber 
Neg  AX 
Mov  [DI],Byte Ptr '-'
Inc  DI 
Str_PosNumber: 
Xor  CX,CX 
Str_Another: 
Inc  CX 
Xor  DX,DX 
Div  $Base 
Push DX 
Cmp  AX,0 
Jne  Str_another 
EmitDigit: 
Pop  AX 
Add  AL,'0' 
Mov  [DI],AL 
Inc  DI 
Loop EmitDigit 
Mov  [DI],Byte Ptr 0 
Ret 
Str$ Endp 




Instr Proc Near 
;---------------------- 
;SI = match   (len = 1) 
;DI = main 
;output position In   AX 
;---------------------- 
Xor  AX,AX 
Mov  CX,AX 
Mov  AL,[SI]  ;load match 
InstrLoop: 
Cmp  [DI],AL 
Je   InstrExit 
Cmp  [DI],Byte ptr 0 
Je   InstrNoMatch 
Cmp  CX, 81 
Je   InstrNoMatch 
Inc  CX 
Inc  DI 
Jmp  InstrLoop 
InstrNoMatch: 
Xor  AX,AX 
Jmp  InstrDone 
InstrExit: 
Inc  CX 
Mov  AX,CX 
InstrDone: 
Ret 
Instr Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




Extract Proc Near 
;
;SI = main$ 
;DI = match$     Len match$ = 1 only 
;
Mov  AL,[DI] 
Mov  DI,Offset $Work1 
Xor  CX,CX 
Extr_loop: 
Mov  BL,[SI] 
Cmp  BL,AL 
Je   Extr_Done 
Mov  [DI],BL 
Inc  DI 
Inc  SI 
Inc  CX 
Cmp  CX, 81 
Jne  Extr_loop 
Extr_Done: 
Mov  [DI],Byte Ptr 0 
Ret 
Extract Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




Fpadd$ Proc Near
Push BP
Mov  BP,SP
;
;local xpoint ypoint 
;
Mov  L_FPADD_XPOINT,0
Mov  L_FPADD_YPOINT,0
;
;local lena carry 
;
Mov  L_FPADD_LENA,0
Mov  L_FPADD_CARRY,0
;
;local digit1 digit2 digit3 
;
Mov  L_FPADD_DIGIT1,0
Mov  L_FPADD_DIGIT2,0
Mov  L_FPADD_DIGIT3,0
;
;local a b c 
;
Mov  L_FPADD_A,0
Mov  L_FPADD_B,0
Mov  L_FPADD_C,0
;
;local integer1$ integer2$ 
;
Mov  DI,Offset L_FPADD_INTEGER1$
Call Nullstr
Mov  DI,Offset L_FPADD_INTEGER2$
Call Nullstr
;
;local dec1$ dec2$ 
;
Mov  DI,Offset L_FPADD_DEC1$
Call Nullstr
Mov  DI,Offset L_FPADD_DEC2$
Call Nullstr
;
;local num1$ num2$ 
;
Mov  DI,Offset L_FPADD_NUM1$
Call Nullstr
Mov  DI,Offset L_FPADD_NUM2$
Call Nullstr
;
;local tmp1$ tmp2$ 
;
Mov  DI,Offset L_FPADD_TMP1$
Call Nullstr
Mov  DI,Offset L_FPADD_TMP2$
Call Nullstr
;
;local accum$ result$ 
;
Mov  DI,Offset L_FPADD_ACCUM$
Call Nullstr
Mov  DI,Offset L_FPADD_RESULT$
Call Nullstr
;
;local special 
;
Mov  L_FPADD_SPECIAL,0
;
;a = instr x$ "-" 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][04]
Mov  SI,Offset $tring_28
Call Instr
Add  AX,$Var0
Mov  L_FPADD_A,AX
;
;b = instr y$ "-" 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset $tring_28   
Call Instr
Add  AX,$Var0
Mov  L_FPADD_B,AX
;
;if a > 0 then 
;
Cmp  L_FPADD_A,0
Jg   Fpadd$_True_01
Jmp  Fpadd$_EndIf_01
Fpadd$_True_01:
;
;if b = 0 then 
;
Cmp  L_FPADD_B,0
Je   Fpadd$_True_02
Jmp  Fpadd$_EndIf_02
Fpadd$_True_02:
;
;Special = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_FPADD_SPECIAL,AX
;
;end if 
;
Fpadd$_EndIf_02:
;
;end if 
;
Fpadd$_EndIf_01:
;
;if a = 0 then 
;
Cmp  L_FPADD_A,0
Je   Fpadd$_True_03
Jmp  Fpadd$_EndIf_03
Fpadd$_True_03:
;
;if b > 0 then 
;
Cmp  L_FPADD_B,0
Jg   Fpadd$_True_04
Jmp  Fpadd$_EndIf_04
Fpadd$_True_04:
;
;Special = 2 
;
Xor  AX,AX
Add  AX,2
Mov  L_FPADD_SPECIAL,AX
;
;end if 
;
Fpadd$_EndIf_04:
;
;end if 
;
Fpadd$_EndIf_03:
;
;if a > 0 then 
;
Cmp  L_FPADD_A,0
Jg   Fpadd$_True_05
Jmp  Fpadd$_EndIf_05
Fpadd$_True_05:
;
;if b > 0 then 
;
Cmp  L_FPADD_B,0
Jg   Fpadd$_True_06
Jmp  Fpadd$_EndIf_06
Fpadd$_True_06:
;
;Special = 3 
;
Xor  AX,AX
Add  AX,3
Mov  L_FPADD_SPECIAL,AX
;
;end if 
;
Fpadd$_EndIf_06:
;
;end if 
;
Fpadd$_EndIf_05:
;
;if special = 1 then 
;
Cmp  L_FPADD_SPECIAL,1
Je   Fpadd$_True_07
Jmp  Fpadd$_EndIf_07
Fpadd$_True_07:
;
;tmp1$ = remove$ x$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][04]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_TMP1$
Call MoveStr
;
;tmp2$ = remove$ y$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][06]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_TMP2$
Call MoveStr
;
;fpadd$ = fpsub$ tmp2$ tmp1$ 
;
Mov  AX,Offset L_FPADD_tmp1$
Push AX
Mov  AX,Offset L_FPADD_tmp2$
Push AX
Call fpsub$
Mov  SI,Offset $StrFunc
Mov  DI,Offset $STRFUNC
Call MoveStr
Pop  BP
Ret  04
;
;end if 
;
Fpadd$_EndIf_07:
;
;if special = 2 then 
;
Cmp  L_FPADD_SPECIAL,2
Je   Fpadd$_True_08
Jmp  Fpadd$_EndIf_08
Fpadd$_True_08:
;
;tmp1$ = remove$ x$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][04]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_TMP1$
Call MoveStr
;
;tmp2$ = remove$ y$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][06]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_TMP2$
Call MoveStr
;
;fpadd$ = fpsub$ tmp1$ tmp2$ 
;
Mov  AX,Offset L_FPADD_tmp2$
Push AX
Mov  AX,Offset L_FPADD_tmp1$
Push AX
Call fpsub$
Mov  SI,Offset $StrFunc
Mov  DI,Offset $STRFUNC
Call MoveStr
Pop  BP
Ret  04
;
;end if 
;
Fpadd$_EndIf_08:
;
;xpoint = instr x$ "." 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][04]
Mov  SI,Offset $tring_29
Call Instr
Add  AX,$Var0
Mov  L_FPADD_XPOINT,AX
;
;ypoint = instr y$ "." 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset $tring_29   
Call Instr
Add  AX,$Var0
Mov  L_FPADD_YPOINT,AX
;
;integer1$ = extract$ x$ "." 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,[BP][04]
Mov  DI,Offset $tring_29   
Call Extract
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_INTEGER1$
Call MoveStr
;
;integer2$ = extract$ y$ "." 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,[BP][06]
Mov  DI,Offset $tring_29   
Call Extract
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_INTEGER2$
Call MoveStr
;
;integer1$ = remove$ integer1$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,Offset L_FPADD_integer1$
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_INTEGER1$
Call MoveStr
;
;integer2$ = remove$ integer2$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,Offset L_FPADD_integer2$
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_INTEGER2$
Call MoveStr
;
;a = len integer1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_integer1$
Call Len
Add  AX,$Var0
Mov  L_FPADD_A,AX
;
;b = len integer2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_integer2$
Call Len
Add  AX,$Var0
Mov  L_FPADD_B,AX
;
;do 
;
Fpadd$DoLoop_01:
;
;c = len integer1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_integer1$
Call Len
Add  AX,$Var0
Mov  L_FPADD_C,AX
;
;if c < b then 
;
Mov  AX,L_FPADD_C
Cmp  AX,L_FPADD_B
Jl   Fpadd$_True_09
Jmp  Fpadd$_EndIf_09
Fpadd$_True_09:
;
;integer1$ = "0" + integer1$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_30
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPADD_INTEGER1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_INTEGER1$
Call MoveStr
;
;else 
;
Jmp Fpadd$_EndIf_09A
Fpadd$_EndIf_09:
;
;exit loop 
;
Jmp Fpadd$DoLoop_01A
;
;end if 
;
Fpadd$_EndIf_09A:
;
;loop 
;
Jmp Fpadd$DoLoop_01
Fpadd$DoLoop_01A:
;
;do 
;
Fpadd$DoLoop_02:
;
;c = len integer2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_integer2$
Call Len
Add  AX,$Var0
Mov  L_FPADD_C,AX
;
;if c < a then 
;
Mov  AX,L_FPADD_C
Cmp  AX,L_FPADD_A
Jl   Fpadd$_True_10
Jmp  Fpadd$_EndIf_10
Fpadd$_True_10:
;
;integer2$ = "0" + integer2$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPADD_INTEGER2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_INTEGER2$
Call MoveStr
;
;else 
;
Jmp Fpadd$_EndIf_10A
Fpadd$_EndIf_10:
;
;exit loop 
;
Jmp Fpadd$DoLoop_02A
;
;end if 
;
Fpadd$_EndIf_10A:
;
;loop 
;
Jmp Fpadd$DoLoop_02
Fpadd$DoLoop_02A:
;
;if xpoint = 0 then 
;
Cmp  L_FPADD_XPOINT,0
Je   Fpadd$_True_11
Jmp  Fpadd$_EndIf_11
Fpadd$_True_11:
;
;dec1$ = "." 
;
Mov  SI,Offset $tring_29   
Mov  DI,Offset L_FPADD_dec1$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_11:
;
;if ypoint = 0 then 
;
Cmp  L_FPADD_YPOINT,0
Je   Fpadd$_True_12
Jmp  Fpadd$_EndIf_12
Fpadd$_True_12:
;
;dec2$ = "." 
;
Mov  SI,Offset $tring_29   
Mov  DI,Offset L_FPADD_dec2$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_12:
;
;if xpoint then 
;
Cmp  L_FPADD_XPOINT,0
Jne  Fpadd$_True_13
Jmp  Fpadd$_EndIf_13
Fpadd$_True_13:
;
;dec1$ = dec1$ + mid$ x$ xpoint 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_DEC1$
Mov  DI,Offset $Work0
Call Concat
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_FPADD_xpoint
Dec  SI
Mov  CX,81
Sub  CX,L_FPADD_xpoint
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_DEC1$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_13:
;
;if ypoint then 
;
Cmp  L_FPADD_YPOINT,0
Jne  Fpadd$_True_14
Jmp  Fpadd$_EndIf_14
Fpadd$_True_14:
;
;dec2$ = dec2$ + mid$ y$ ypoint 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_DEC2$
Mov  DI,Offset $Work0
Call Concat
Cld
Mov  SI,[BP][06]
Mov  DI,Offset $Work1
Add  SI,L_FPADD_ypoint
Dec  SI
Mov  CX,81
Sub  CX,L_FPADD_ypoint
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_DEC2$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_14:
;
;a = len dec1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_dec1$
Call Len
Add  AX,$Var0
Mov  L_FPADD_A,AX
;
;b = len dec2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_dec2$
Call Len
Add  AX,$Var0
Mov  L_FPADD_B,AX
;
;do 
;
Fpadd$DoLoop_03:
;
;c = len dec1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_dec1$
Call Len
Add  AX,$Var0
Mov  L_FPADD_C,AX
;
;if c < b then 
;
Mov  AX,L_FPADD_C
Cmp  AX,L_FPADD_B
Jl   Fpadd$_True_15
Jmp  Fpadd$_EndIf_15
Fpadd$_True_15:
;
;dec1$ = dec1$ + "0" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_DEC1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_DEC1$
Call MoveStr
;
;else 
;
Jmp Fpadd$_EndIf_15A
Fpadd$_EndIf_15:
;
;exit loop 
;
Jmp Fpadd$DoLoop_03A
;
;end if 
;
Fpadd$_EndIf_15A:
;
;loop 
;
Jmp Fpadd$DoLoop_03
Fpadd$DoLoop_03A:
;
;do 
;
Fpadd$DoLoop_04:
;
;c = len dec2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_dec2$
Call Len
Add  AX,$Var0
Mov  L_FPADD_C,AX
;
;if c < a then 
;
Mov  AX,L_FPADD_C
Cmp  AX,L_FPADD_A
Jl   Fpadd$_True_16
Jmp  Fpadd$_EndIf_16
Fpadd$_True_16:
;
;dec2$ = dec2$ + "0" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_DEC2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_DEC2$
Call MoveStr
;
;else 
;
Jmp Fpadd$_EndIf_16A
Fpadd$_EndIf_16:
;
;exit loop 
;
Jmp Fpadd$DoLoop_04A
;
;end if 
;
Fpadd$_EndIf_16A:
;
;loop 
;
Jmp Fpadd$DoLoop_04
Fpadd$DoLoop_04A:
;
;num1$ = integer1$ + dec1$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_INTEGER1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPADD_DEC1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_NUM1$
Call MoveStr
;
;num2$ = integer2$ + dec2$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_INTEGER2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPADD_DEC2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_NUM2$
Call MoveStr
;
;lena = len num1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_num1$
Call Len
Add  AX,$Var0
Mov  L_FPADD_LENA,AX
;
;for a = lena to 1 step -1 
;
Mov  AX,L_FPADD_LENA
Sub  AX,-1
Mov  L_FPADD_A,AX
Fpadd$ForLoop_02:
Mov  AX,-1
Add  L_FPADD_A,AX
Mov  AX,-1
Cmp  AX,0
Jl   Fpadd$ForLoop_02_NegativeStep
Mov  AX,L_FPADD_A
Cmp  AX,1       ;Ascending Step
Jle Fpadd$ForLoop_02Okay
Jmp Fpadd$ForLoop_02A
Fpadd$ForLoop_02_NegativeStep:
Mov  AX,1
Cmp  AX,L_FPADD_A       ;Descending Step
Jle Fpadd$ForLoop_02Okay
Jmp Fpadd$ForLoop_02A
Fpadd$ForLoop_02Okay:
;
;tmp1$ = mid$ num1$ a 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPADD_num1$
Mov  DI,Offset $Work1
Add  SI,L_FPADD_a
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_TMP1$
Call MoveStr
;
;tmp2$ = mid$ num2$ a 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPADD_num2$
Mov  DI,Offset $Work1
Add  SI,L_FPADD_a
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_TMP2$
Call MoveStr
;
;if tmp1$ < > "." then 
;
Mov  SI,Offset L_FPADD_TMP1$
Mov  DI,Offset $tring_29   
Call StrCompare
Jne  Fpadd$_True_17
Jmp  Fpadd$_EndIf_17
Fpadd$_True_17:
;
;digit1 = val tmp1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,Offset L_FPADD_tmp1$
Call Val
Add  AX,$Var0
Mov  L_FPADD_DIGIT1,AX
;
;digit2 = val tmp2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,Offset L_FPADD_tmp2$
Call Val
Add  AX,$Var0
Mov  L_FPADD_DIGIT2,AX
;
;digit3 = digit1 + digit2 + carry 
;
Xor  AX,AX
Add  AX,L_FPADD_DIGIT1
Add  AX,L_FPADD_digit2
Add  AX,L_FPADD_carry
Mov  L_FPADD_DIGIT3,AX
;
;if digit3 > = 10 then 
;
Cmp  L_FPADD_DIGIT3,10
Jge  Fpadd$_True_18
Jmp  Fpadd$_EndIf_18
Fpadd$_True_18:
;
;digit3 = digit3 -10 
;
Xor  AX,AX
Add  AX,L_FPADD_DIGIT3
Add  AX,-10
Mov  L_FPADD_DIGIT3,AX
;
;carry = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_FPADD_CARRY,AX
;
;else 
;
Jmp Fpadd$_EndIf_18A
Fpadd$_EndIf_18:
;
;carry = 0 
;
Xor  AX,AX
Add  AX,0
Mov  L_FPADD_CARRY,AX
;
;end if 
;
Fpadd$_EndIf_18A:
;
;accum$ = accum$ + str$ digit3 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_ACCUM$
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,L_FPADD_digit3
Call Str$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_ACCUM$
Call MoveStr
;
;else 
;
Jmp Fpadd$_EndIf_17A
Fpadd$_EndIf_17:
;
;accum$ = accum$ + "." 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_ACCUM$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_29   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_ACCUM$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_17A:
;
;next 
;
Jmp Fpadd$ForLoop_02
Fpadd$ForLoop_02A:
;
;accum$ = remove$ accum$ " " 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_31
Push AX
Mov  AX,Offset L_FPADD_accum$
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_ACCUM$
Call MoveStr
;
;a = len accum$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPADD_accum$
Call Len
Add  AX,$Var0
Mov  L_FPADD_A,AX
;
;for b = a to 1 step -1 
;
Mov  AX,L_FPADD_A
Sub  AX,-1
Mov  L_FPADD_B,AX
Fpadd$ForLoop_03:
Mov  AX,-1
Add  L_FPADD_B,AX
Mov  AX,-1
Cmp  AX,0
Jl   Fpadd$ForLoop_03_NegativeStep
Mov  AX,L_FPADD_B
Cmp  AX,1       ;Ascending Step
Jle Fpadd$ForLoop_03Okay
Jmp Fpadd$ForLoop_03A
Fpadd$ForLoop_03_NegativeStep:
Mov  AX,1
Cmp  AX,L_FPADD_B       ;Descending Step
Jle Fpadd$ForLoop_03Okay
Jmp Fpadd$ForLoop_03A
Fpadd$ForLoop_03Okay:
;
;a$ = mid$ accum$ b 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPADD_accum$
Mov  DI,Offset $Work1
Add  SI,L_FPADD_b
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;result$ = result$ + a$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPADD_RESULT$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset A$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_RESULT$
Call MoveStr
;
;next 
;
Jmp Fpadd$ForLoop_03
Fpadd$ForLoop_03A:
;
;if carry then 
;
Cmp  L_FPADD_CARRY,0
Jne  Fpadd$_True_19
Jmp  Fpadd$_EndIf_19
Fpadd$_True_19:
;
;result$ = "1" + result$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_32
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPADD_RESULT$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_RESULT$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_19:
;
;if special = 3 then 
;
Cmp  L_FPADD_SPECIAL,3
Je   Fpadd$_True_20
Jmp  Fpadd$_EndIf_20
Fpadd$_True_20:
;
;result$ = "-" + result$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_28   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPADD_RESULT$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPADD_RESULT$
Call MoveStr
;
;end if 
;
Fpadd$_EndIf_20:
;
;fpAdd$ = result$ 
;
Mov  SI,Offset L_FPADD_result$
Mov  DI,Offset $StrFunc
Call MoveStr
Pop  BP
Ret  04
Fpadd$ Endp


Fpsub$ Proc Near
Push BP
Mov  BP,SP
;
;local xpoint ypoint 
;
Mov  L_FPSUB_XPOINT,0
Mov  L_FPSUB_YPOINT,0
;
;local lena borrow 
;
Mov  L_FPSUB_LENA,0
Mov  L_FPSUB_BORROW,0
;
;local digit1 digit2 digit3 
;
Mov  L_FPSUB_DIGIT1,0
Mov  L_FPSUB_DIGIT2,0
Mov  L_FPSUB_DIGIT3,0
;
;local a b c 
;
Mov  L_FPSUB_A,0
Mov  L_FPSUB_B,0
Mov  L_FPSUB_C,0
;
;local integer1$ integer2$ 
;
Mov  DI,Offset L_FPSUB_INTEGER1$
Call Nullstr
Mov  DI,Offset L_FPSUB_INTEGER2$
Call Nullstr
;
;local dec1$ dec2$ 
;
Mov  DI,Offset L_FPSUB_DEC1$
Call Nullstr
Mov  DI,Offset L_FPSUB_DEC2$
Call Nullstr
;
;local num1$ num2$ 
;
Mov  DI,Offset L_FPSUB_NUM1$
Call Nullstr
Mov  DI,Offset L_FPSUB_NUM2$
Call Nullstr
;
;local tmp1$ tmp2$ 
;
Mov  DI,Offset L_FPSUB_TMP1$
Call Nullstr
Mov  DI,Offset L_FPSUB_TMP2$
Call Nullstr
;
;local accum$ result$ 
;
Mov  DI,Offset L_FPSUB_ACCUM$
Call Nullstr
Mov  DI,Offset L_FPSUB_RESULT$
Call Nullstr
;
;local special Negated 
;
Mov  L_FPSUB_SPECIAL,0
Mov  L_FPSUB_NEGATED,0
;
;a = instr x$ "-" 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][04]
Mov  SI,Offset $tring_28   
Call Instr
Add  AX,$Var0
Mov  L_FPSUB_A,AX
;
;b = instr y$ "-" 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset $tring_28   
Call Instr
Add  AX,$Var0
Mov  L_FPSUB_B,AX
;
;if a > 0 then 
;
Cmp  L_FPSUB_A,0
Jg   Fpsub$_True_21
Jmp  Fpsub$_EndIf_21
Fpsub$_True_21:
;
;if b = 0 then 
;
Cmp  L_FPSUB_B,0
Je   Fpsub$_True_22
Jmp  Fpsub$_EndIf_22
Fpsub$_True_22:
;
;Special = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_FPSUB_SPECIAL,AX
;
;end if 
;
Fpsub$_EndIf_22:
;
;end if 
;
Fpsub$_EndIf_21:
;
;if a = 0 then 
;
Cmp  L_FPSUB_A,0
Je   Fpsub$_True_23
Jmp  Fpsub$_EndIf_23
Fpsub$_True_23:
;
;if b > 0 then 
;
Cmp  L_FPSUB_B,0
Jg   Fpsub$_True_24
Jmp  Fpsub$_EndIf_24
Fpsub$_True_24:
;
;Special = 2 
;
Xor  AX,AX
Add  AX,2
Mov  L_FPSUB_SPECIAL,AX
;
;end if 
;
Fpsub$_EndIf_24:
;
;end if 
;
Fpsub$_EndIf_23:
;
;if special = 1 then 
;
Cmp  L_FPSUB_SPECIAL,1
Je   Fpsub$_True_25
Jmp  Fpsub$_EndIf_25
Fpsub$_True_25:
;
;tmp1$ = remove$ x$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][04]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP1$
Call MoveStr
;
;tmp2$ = remove$ y$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][06]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP2$
Call MoveStr
;
;tmp1$ = fpadd$ tmp1$ tmp2$ 
;
Mov  AX,Offset L_FPSUB_tmp2$
Push AX
Mov  AX,Offset L_FPSUB_tmp1$
Push AX
Call fpadd$
Mov  SI,Offset $StrFunc
Mov  DI,Offset L_FPSUB_TMP1$
Call MoveStr
;
;tmp1$ = "-" + tmp1$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_28   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPSUB_TMP1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP1$
Call MoveStr
;
;replace "--" with "-" in tmp1$ 
;
Mov  SI,Offset $tring_55
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $tring_28   
Mov  DI,Offset $Work3
Call MoveStr
Mov  SI,Offset L_FPSUB_tmp1$
Mov  DI,Offset $Work4
Call MoveStr
Call Replace
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_tmp1$
Call MoveStr
;
;fpsub$ = tmp1$ 
;
Mov  SI,Offset L_FPSUB_tmp1$
Mov  DI,Offset $StrFunc
Call MoveStr
Pop  BP
Ret  04
;
;end if 
;
Fpsub$_EndIf_25:
;
;if special = 2 then 
;
Cmp  L_FPSUB_SPECIAL,2
Je   Fpsub$_True_26
Jmp  Fpsub$_EndIf_26
Fpsub$_True_26:
;
;tmp1$ = remove$ x$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][04]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP1$
Call MoveStr
;
;tmp2$ = remove$ y$ "-" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_28   
Push AX
Mov  AX,[BP][06]
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP2$
Call MoveStr
;
;fpsub$ = fpadd$ tmp1$ tmp2$ 
;
Mov  AX,Offset L_FPSUB_tmp2$
Push AX
Mov  AX,Offset L_FPSUB_tmp1$
Push AX
Call fpadd$
Mov  SI,Offset $StrFunc
Mov  DI,Offset $STRFUNC
Call MoveStr
Pop  BP
Ret  04
;
;end if 
;
Fpsub$_EndIf_26:
;
;xpoint = instr x$ "." 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][04]
Mov  SI,Offset $tring_29   
Call Instr
Add  AX,$Var0
Mov  L_FPSUB_XPOINT,AX
;
;ypoint = instr y$ "." 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset $tring_29   
Call Instr
Add  AX,$Var0
Mov  L_FPSUB_YPOINT,AX
;
;integer1$ = extract$ x$ "." 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,[BP][04]
Mov  DI,Offset $tring_29   
Call Extract
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_INTEGER1$
Call MoveStr
;
;integer2$ = extract$ y$ "." 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,[BP][06]
Mov  DI,Offset $tring_29   
Call Extract
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_INTEGER2$
Call MoveStr
;
;a = len integer1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_integer1$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_A,AX
;
;b = len integer2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_integer2$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_B,AX
;
;do 
;
Fpsub$DoLoop_05:
;
;c = len integer1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_integer1$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_C,AX
;
;if c < b then 
;
Mov  AX,L_FPSUB_C
Cmp  AX,L_FPSUB_B
Jl   Fpsub$_True_27
Jmp  Fpsub$_EndIf_27
Fpsub$_True_27:
;
;integer1$ = "0" + integer1$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPSUB_INTEGER1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_INTEGER1$
Call MoveStr
;
;else 
;
Jmp Fpsub$_EndIf_27A
Fpsub$_EndIf_27:
;
;exit loop 
;
Jmp Fpsub$DoLoop_05A
;
;end if 
;
Fpsub$_EndIf_27A:
;
;loop 
;
Jmp Fpsub$DoLoop_05
Fpsub$DoLoop_05A:
;
;do 
;
Fpsub$DoLoop_06:
;
;c = len integer2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_integer2$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_C,AX
;
;if c < a then 
;
Mov  AX,L_FPSUB_C
Cmp  AX,L_FPSUB_A
Jl   Fpsub$_True_28
Jmp  Fpsub$_EndIf_28
Fpsub$_True_28:
;
;integer2$ = "0" + integer2$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPSUB_INTEGER2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_INTEGER2$
Call MoveStr
;
;else 
;
Jmp Fpsub$_EndIf_28A
Fpsub$_EndIf_28:
;
;exit loop 
;
Jmp Fpsub$DoLoop_06A
;
;end if 
;
Fpsub$_EndIf_28A:
;
;loop 
;
Jmp Fpsub$DoLoop_06
Fpsub$DoLoop_06A:
;
;if xpoint = 0 then 
;
Cmp  L_FPSUB_XPOINT,0
Je   Fpsub$_True_29
Jmp  Fpsub$_EndIf_29
Fpsub$_True_29:
;
;dec1$ = "." 
;
Mov  SI,Offset $tring_29   
Mov  DI,Offset L_FPSUB_dec1$
Call MoveStr
;
;end if 
;
Fpsub$_EndIf_29:
;
;if ypoint = 0 then 
;
Cmp  L_FPSUB_YPOINT,0
Je   Fpsub$_True_30
Jmp  Fpsub$_EndIf_30
Fpsub$_True_30:
;
;dec2$ = "." 
;
Mov  SI,Offset $tring_29   
Mov  DI,Offset L_FPSUB_dec2$
Call MoveStr
;
;end if 
;
Fpsub$_EndIf_30:
;
;if xpoint then 
;
Cmp  L_FPSUB_XPOINT,0
Jne  Fpsub$_True_31
Jmp  Fpsub$_EndIf_31
Fpsub$_True_31:
;
;dec1$ = dec1$ + mid$ x$ xpoint 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_DEC1$
Mov  DI,Offset $Work0
Call Concat
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_xpoint
Dec  SI
Mov  CX,81
Sub  CX,L_FPSUB_xpoint
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_DEC1$
Call MoveStr
;
;end if 
;
Fpsub$_EndIf_31:
;
;if ypoint then 
;
Cmp  L_FPSUB_YPOINT,0
Jne  Fpsub$_True_32
Jmp  Fpsub$_EndIf_32
Fpsub$_True_32:
;
;dec2$ = dec2$ + mid$ y$ ypoint 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_DEC2$
Mov  DI,Offset $Work0
Call Concat
Cld
Mov  SI,[BP][06]
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_ypoint
Dec  SI
Mov  CX,81
Sub  CX,L_FPSUB_ypoint
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_DEC2$
Call MoveStr
;
;end if 
;
Fpsub$_EndIf_32:
;
;a = len dec1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_dec1$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_A,AX
;
;b = len dec2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_dec2$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_B,AX
;
;do 
;
Fpsub$DoLoop_07:
;
;c = len dec1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_dec1$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_C,AX
;
;if c < b then 
;
Mov  AX,L_FPSUB_C
Cmp  AX,L_FPSUB_B
Jl   Fpsub$_True_33
Jmp  Fpsub$_EndIf_33
Fpsub$_True_33:
;
;dec1$ = dec1$ + "0" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_DEC1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_DEC1$
Call MoveStr
;
;else 
;
Jmp Fpsub$_EndIf_33A
Fpsub$_EndIf_33:
;
;exit loop 
;
Jmp Fpsub$DoLoop_07A
;
;end if 
;
Fpsub$_EndIf_33A:
;
;loop 
;
Jmp Fpsub$DoLoop_07
Fpsub$DoLoop_07A:
;
;do 
;
Fpsub$DoLoop_08:
;
;c = len dec2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_dec2$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_C,AX
;
;if c < a then 
;
Mov  AX,L_FPSUB_C
Cmp  AX,L_FPSUB_A
Jl   Fpsub$_True_34
Jmp  Fpsub$_EndIf_34
Fpsub$_True_34:
;
;dec2$ = dec2$ + "0" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_DEC2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_30   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_DEC2$
Call MoveStr
;
;else 
;
Jmp Fpsub$_EndIf_34A
Fpsub$_EndIf_34:
;
;exit loop 
;
Jmp Fpsub$DoLoop_08A
;
;end if 
;
Fpsub$_EndIf_34A:
;
;loop 
;
Jmp Fpsub$DoLoop_08
Fpsub$DoLoop_08A:
;
;num1$ = integer1$ + dec1$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_INTEGER1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPSUB_DEC1$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_NUM1$
Call MoveStr
;
;num2$ = integer2$ + dec2$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_INTEGER2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPSUB_DEC2$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_NUM2$
Call MoveStr
;
;lena = len num1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_num1$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_LENA,AX
;
;if num1$ < num2$ then 
;
Mov  SI,Offset L_FPSUB_NUM1$
Mov  DI,Offset L_FPSUB_NUM2$
Call StrCompare
Jl   Fpsub$_True_35
Jmp  Fpsub$_EndIf_35
Fpsub$_True_35:
;
;swap num1$ num2$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_num1$
Mov  DI,Offset $Work0
Call Movestr
Mov  SI,Offset L_FPSUB_num2$
Mov  DI,Offset L_FPSUB_num1$
Call Movestr
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_num2$
Call Movestr
;
;Negated = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_FPSUB_NEGATED,AX
;
;end if 
;
Fpsub$_EndIf_35:
;
;for a = lena to 1 step -1 
;
Mov  AX,L_FPSUB_LENA
Sub  AX,-1
Mov  L_FPSUB_A,AX
Fpsub$ForLoop_04:
Mov  AX,-1
Add  L_FPSUB_A,AX
Mov  AX,-1
Cmp  AX,0
Jl   Fpsub$ForLoop_04_NegativeStep
Mov  AX,L_FPSUB_A
Cmp  AX,1       ;Ascending Step
Jle Fpsub$ForLoop_04Okay
Jmp Fpsub$ForLoop_04A
Fpsub$ForLoop_04_NegativeStep:
Mov  AX,1
Cmp  AX,L_FPSUB_A       ;Descending Step
Jle Fpsub$ForLoop_04Okay
Jmp Fpsub$ForLoop_04A
Fpsub$ForLoop_04Okay:
;
;tmp1$ = mid$ num1$ a 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPSUB_num1$
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_a
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP1$
Call MoveStr
;
;tmp2$ = mid$ num2$ a 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPSUB_num2$
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_a
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_TMP2$
Call MoveStr
;
;if tmp1$ < > "." then 
;
Mov  SI,Offset L_FPSUB_TMP1$
Mov  DI,Offset $tring_29   
Call StrCompare
Jne  Fpsub$_True_36
Jmp  Fpsub$_EndIf_36
Fpsub$_True_36:
;
;digit1 = val tmp1$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,Offset L_FPSUB_tmp1$
Call Val
Add  AX,$Var0
Mov  L_FPSUB_DIGIT1,AX
;
;digit2 = val tmp2$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,Offset L_FPSUB_tmp2$
Call Val
Add  AX,$Var0
Mov  L_FPSUB_DIGIT2,AX
;
;digit3 = digit1 - digit2 - borrow 
;
Xor  AX,AX
Add  AX,L_FPSUB_DIGIT1
Sub  AX,L_FPSUB_digit2
Sub  AX,L_FPSUB_borrow
Mov  L_FPSUB_DIGIT3,AX
;
;if digit3 < 0 then 
;
Cmp  L_FPSUB_DIGIT3,0
Jl   Fpsub$_True_37
Jmp  Fpsub$_EndIf_37
Fpsub$_True_37:
;
;digit3 = digit3 + 10 
;
Xor  AX,AX
Add  AX,L_FPSUB_DIGIT3
Add  AX,10
Mov  L_FPSUB_DIGIT3,AX
;
;borrow = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_FPSUB_BORROW,AX
;
;else 
;
Jmp Fpsub$_EndIf_37A
Fpsub$_EndIf_37:
;
;borrow = 0 
;
Xor  AX,AX
Add  AX,0
Mov  L_FPSUB_BORROW,AX
;
;end if 
;
Fpsub$_EndIf_37A:
;
;accum$ = accum$ + str$ digit3 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_ACCUM$
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,L_FPSUB_digit3
Call Str$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_ACCUM$
Call MoveStr
;
;else 
;
Jmp Fpsub$_EndIf_36A
Fpsub$_EndIf_36:
;
;accum$ = accum$ + "." 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_ACCUM$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_29   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_ACCUM$
Call MoveStr
;
;end if 
;
Fpsub$_EndIf_36A:
;
;next 
;
Jmp Fpsub$ForLoop_04
Fpsub$ForLoop_04A:
;
;accum$ = remove$ accum$ " " 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  AX,Offset $tring_31   
Push AX
Mov  AX,Offset L_FPSUB_accum$
Push AX
Call Remove$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_ACCUM$
Call MoveStr
;
;a = len accum$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_FPSUB_accum$
Call Len
Add  AX,$Var0
Mov  L_FPSUB_A,AX
;
;for b = a to 1 step -1 
;
Mov  AX,L_FPSUB_A
Sub  AX,-1
Mov  L_FPSUB_B,AX
Fpsub$ForLoop_05:
Mov  AX,-1
Add  L_FPSUB_B,AX
Mov  AX,-1
Cmp  AX,0
Jl   Fpsub$ForLoop_05_NegativeStep
Mov  AX,L_FPSUB_B
Cmp  AX,1       ;Ascending Step
Jle Fpsub$ForLoop_05Okay
Jmp Fpsub$ForLoop_05A
Fpsub$ForLoop_05_NegativeStep:
Mov  AX,1
Cmp  AX,L_FPSUB_B       ;Descending Step
Jle Fpsub$ForLoop_05Okay
Jmp Fpsub$ForLoop_05A
Fpsub$ForLoop_05Okay:
;
;a$ = mid$ accum$ b 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPSUB_accum$
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_b
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;result$ = result$ + a$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_FPSUB_RESULT$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset A$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_RESULT$
Call MoveStr
;
;next 
;
Jmp Fpsub$ForLoop_05
Fpsub$ForLoop_05A:
;
;a = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_FPSUB_A,AX
;
;do 
;
Fpsub$DoLoop_09:
;
;a$ = mid$ result$ a 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPSUB_result$
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_a
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;if a$ < > "0" then 
;
Mov  SI,Offset A$
Mov  DI,Offset $tring_30   
Call StrCompare
Jne  Fpsub$_True_38
Jmp  Fpsub$_EndIf_38
Fpsub$_True_38:
;
;result$ = mid$ result$ a 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_FPSUB_result$
Mov  DI,Offset $Work1
Add  SI,L_FPSUB_a
Dec  SI
Mov  CX,81
Sub  CX,L_FPSUB_a
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_RESULT$
Call MoveStr
;
;exit loop 
;
Jmp Fpsub$DoLoop_09A
;
;end if 
;
Fpsub$_EndIf_38:
;
;incr a 
;
Inc  L_FPSUB_A
;
;loop 
;
Jmp Fpsub$DoLoop_09
Fpsub$DoLoop_09A:
;
;if Negated then 
;
Cmp  L_FPSUB_NEGATED,0
Jne  Fpsub$_True_39
Jmp  Fpsub$_EndIf_39
Fpsub$_True_39:
;
;result$ = "-" + result$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_28   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_FPSUB_RESULT$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_FPSUB_RESULT$
Call MoveStr
;
;end if 
;
Fpsub$_EndIf_39:
;
;fpSub$ = result$ 
;
Mov  SI,Offset L_FPSUB_result$
Mov  DI,Offset $StrFunc
Call MoveStr
Pop  BP
Ret  04
Fpsub$ Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "-1.1",0
$tring_03    DB ".99",0
Z            DW  0
L_FPADD_XPOINT DW  0
L_FPADD_YPOINT DW  0
L_FPADD_LENA DW  0
L_FPADD_CARRY DW  0
L_FPADD_DIGIT1 DW  0
L_FPADD_DIGIT2 DW  0
L_FPADD_DIGIT3 DW  0
L_FPADD_A    DW  0
L_FPADD_B    DW  0
L_FPADD_C    DW  0
L_FPADD_SPECIAL DW  0
$tring_28    DB "-",0
$tring_29    DB ".",0
$tring_30    DB "0",0
$tring_31    DB " ",0
$tring_32    DB "1",0
L_FPSUB_XPOINT DW  0
L_FPSUB_YPOINT DW  0
L_FPSUB_LENA DW  0
L_FPSUB_BORROW DW  0
L_FPSUB_DIGIT1 DW  0
L_FPSUB_DIGIT2 DW  0
L_FPSUB_DIGIT3 DW  0
L_FPSUB_A    DW  0
L_FPSUB_B    DW  0
L_FPSUB_C    DW  0
L_FPSUB_SPECIAL DW  0
L_FPSUB_NEGATED DW  0
$tring_55    DB "--",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)
$Work4       DB 81 DUP(?)
$Work5       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
B$           DB 81 DUP(?)
$STRFUNC     DB 81 DUP(?)
L_FPADD_INTEGER1$ DB 81 DUP(?)
L_FPADD_INTEGER2$ DB 81 DUP(?)
L_FPADD_DEC1$ DB 81 DUP(?)
L_FPADD_DEC2$ DB 81 DUP(?)
L_FPADD_NUM1$ DB 81 DUP(?)
L_FPADD_NUM2$ DB 81 DUP(?)
L_FPADD_TMP1$ DB 81 DUP(?)
L_FPADD_TMP2$ DB 81 DUP(?)
L_FPADD_ACCUM$ DB 81 DUP(?)
L_FPADD_RESULT$ DB 81 DUP(?)
L_FPSUB_INTEGER1$ DB 81 DUP(?)
L_FPSUB_INTEGER2$ DB 81 DUP(?)
L_FPSUB_DEC1$ DB 81 DUP(?)
L_FPSUB_DEC2$ DB 81 DUP(?)
L_FPSUB_NUM1$ DB 81 DUP(?)
L_FPSUB_NUM2$ DB 81 DUP(?)
L_FPSUB_TMP1$ DB 81 DUP(?)
L_FPSUB_TMP2$ DB 81 DUP(?)
L_FPSUB_ACCUM$ DB 81 DUP(?)
L_FPSUB_RESULT$ DB 81 DUP(?)
Data Ends

End
