;Ŀ
; DEMO23.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:09:41                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;--------------------------------
;Fetch the command line Arguments
;--------------------------------
Push ES     ;Save the PSP Segment
Mov  BX,Seg Data
Mov  DS,BX
Push DS
Push DS
Mov  DI,0
Lea  BX,ES:[81h]
GetCmdLine:
Mov  AL,ES:[BX]
Cmp  AL,13
Je   GotCmdLine
Mov  Command$ [DI],AL
Inc  DI
Inc  BX
Jmp  GetCmdLine
GotCmdLine:
Mov  Command$ [DI],0
Pop  DS
Pop  ES
Cld
Mov  SI,Offset Command$+1
Mov  DI,Offset Command$
Mov  CX,80
Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
Pop  ES             ;Restore PSP Segment
;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;a = len command$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset command$
Call Len
Add  AX,$Var0
Mov  A,AX
;
;a$ = str$ a 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,a
Call Str$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset A$
Call MoveStr
;
;PRINT "The command line tail: " command$ 
;
Mov  SI,Offset $tring_03
Call PrintStr
Call SetCursor
Mov  SI,Offset COMMAND$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "The length of command$ is " a$ 
;
Mov  SI,Offset $tring_04
Call PrintStr
Call SetCursor
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




Str$ Proc Near 
;
; AX=number to convert to string 
; DI=address of receiving String 
;
Xor  BX,BX 
Cmp  AX,32768 
Jb   Str_PosNumber 
Neg  AX 
Mov  [DI],Byte Ptr '-'
Inc  DI 
Str_PosNumber: 
Xor  CX,CX 
Str_Another: 
Inc  CX 
Xor  DX,DX 
Div  $Base 
Push DX 
Cmp  AX,0 
Jne  Str_another 
EmitDigit: 
Pop  AX 
Add  AL,'0' 
Mov  [DI],AL 
Inc  DI 
Loop EmitDigit 
Mov  [DI],Byte Ptr 0 
Ret 
Str$ Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
Command$     DB 81 DUP(0)

;__________________Users Initialized Data____________________

A            DW  0
$tring_03    DB "The command line tail: ",0
$tring_04    DB "The length of command$ is ",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 81 DUP(?)
Data Ends

End
