;Ŀ
; DEMO26.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:11:04                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call GetDosDate
;
;Print Today$ 
;
Mov  SI,Offset TODAY$
Call PrintStr
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




Str$ Proc Near 
;
; AX=number to convert to string 
; DI=address of receiving String 
;
Xor  BX,BX 
Cmp  AX,32768 
Jb   Str_PosNumber 
Neg  AX 
Mov  [DI],Byte Ptr '-'
Inc  DI 
Str_PosNumber: 
Xor  CX,CX 
Str_Another: 
Inc  CX 
Xor  DX,DX 
Div  $Base 
Push DX 
Cmp  AX,0 
Jne  Str_another 
EmitDigit: 
Pop  AX 
Add  AL,'0' 
Mov  [DI],AL 
Inc  DI 
Loop EmitDigit 
Mov  [DI],Byte Ptr 0 
Ret 
Str$ Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




Getdosdate Proc Near
Push BP
Mov  BP,SP
;
;Date = 0 
;
Xor  AX,AX
Add  AX,0
Mov  DATE,AX
;
;Mon = 0 
;
Xor  AX,AX
Add  AX,0
Mov  MON,AX
;
;Year = 0 
;
Xor  AX,AX
Add  AX,0
Mov  YEAR,AX
;
;Day = 0 
;
Xor  AX,AX
Add  AX,0
Mov  DAY,AX
Mov AH,2Ah   ;Dos Get Date Function
Int 21h      ;Call DOS
Xor AH,AH    ;zero out the high byte
;--------------------------------------------------------
Mov Day,AX   ;Date of week ... 0=sun 1=Mon and so on...
Mov AL,DL
Mov Date,AX  ;Date of Month
Mov AL,DH
Mov Mon,AX   ;Month of year
Mov AX,CX
Mov Year,CX  ;Year a
;
;IF mon = 1 THEN
;
Cmp  MON,1
Je   Getdosdate_True_01
Jmp  Getdosdate_EndIf_01
Getdosdate_True_01:
;
;month$ = "Jan " 
;
Mov  SI,Offset $tring_06
Mov  DI,Offset month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_01:
;
;IF mon = 2 THEN
;
Cmp  MON,2
Je   Getdosdate_True_02
Jmp  Getdosdate_EndIf_02
Getdosdate_True_02:
;
;Month$ = "Feb " 
;
Mov  SI,Offset $tring_08
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_02:
;
;IF mon = 3 THEN
;
Cmp  MON,3
Je   Getdosdate_True_03
Jmp  Getdosdate_EndIf_03
Getdosdate_True_03:
;
;Month$ = "Mar " 
;
Mov  SI,Offset $tring_09
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_03:
;
;IF mon = 4 THEN
;
Cmp  MON,4
Je   Getdosdate_True_04
Jmp  Getdosdate_EndIf_04
Getdosdate_True_04:
;
;Month$ = "Apr " 
;
Mov  SI,Offset $tring_10
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_04:
;
;IF mon = 5 THEN
;
Cmp  MON,5
Je   Getdosdate_True_05
Jmp  Getdosdate_EndIf_05
Getdosdate_True_05:
;
;Month$ = "May " 
;
Mov  SI,Offset $tring_11
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_05:
;
;IF mon = 6 THEN
;
Cmp  MON,6
Je   Getdosdate_True_06
Jmp  Getdosdate_EndIf_06
Getdosdate_True_06:
;
;Month$ = "Jun " 
;
Mov  SI,Offset $tring_12
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_06:
;
;IF mon = 7 THEN
;
Cmp  MON,7
Je   Getdosdate_True_07
Jmp  Getdosdate_EndIf_07
Getdosdate_True_07:
;
;Month$ = "Jul " 
;
Mov  SI,Offset $tring_13
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_07:
;
;IF mon = 8 THEN
;
Cmp  MON,8
Je   Getdosdate_True_08
Jmp  Getdosdate_EndIf_08
Getdosdate_True_08:
;
;Month$ = "Aug " 
;
Mov  SI,Offset $tring_14
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_08:
;
;IF mon = 9 THEN
;
Cmp  MON,9
Je   Getdosdate_True_09
Jmp  Getdosdate_EndIf_09
Getdosdate_True_09:
;
;Month$ = "Sep " 
;
Mov  SI,Offset $tring_15
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_09:
;
;IF mon = 10 THEN
;
Cmp  MON,10
Je   Getdosdate_True_10
Jmp  Getdosdate_EndIf_10
Getdosdate_True_10:
;
;Month$ = "Oct " 
;
Mov  SI,Offset $tring_16
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_10:
;
;IF mon = 11 THEN
;
Cmp  MON,11
Je   Getdosdate_True_11
Jmp  Getdosdate_EndIf_11
Getdosdate_True_11:
;
;Month$ = "Nov " 
;
Mov  SI,Offset $tring_17
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_11:
;
;IF mon = 12 THEN
;
Cmp  MON,12
Je   Getdosdate_True_12
Jmp  Getdosdate_EndIf_12
Getdosdate_True_12:
;
;Month$ = "Dec " 
;
Mov  SI,Offset $tring_18
Mov  DI,Offset Month$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_12:
;
;IF day = 0 THEN
;
Cmp  DAY,0
Je   Getdosdate_True_13
Jmp  Getdosdate_EndIf_13
Getdosdate_True_13:
;
;DOW$ = "Sun " 
;
Mov  SI,Offset $tring_19
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_13:
;
;IF day = 1 THEN
;
Cmp  DAY,1
Je   Getdosdate_True_14
Jmp  Getdosdate_EndIf_14
Getdosdate_True_14:
;
;DOW$ = "Mon " 
;
Mov  SI,Offset $tring_21
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_14:
;
;IF day = 2 THEN
;
Cmp  DAY,2
Je   Getdosdate_True_15
Jmp  Getdosdate_EndIf_15
Getdosdate_True_15:
;
;DOW$ = "Tue " 
;
Mov  SI,Offset $tring_22
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_15:
;
;IF day = 3 THEN
;
Cmp  DAY,3
Je   Getdosdate_True_16
Jmp  Getdosdate_EndIf_16
Getdosdate_True_16:
;
;DOW$ = "Wed " 
;
Mov  SI,Offset $tring_23
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_16:
;
;IF day = 4 THEN
;
Cmp  DAY,4
Je   Getdosdate_True_17
Jmp  Getdosdate_EndIf_17
Getdosdate_True_17:
;
;DOW$ = "Thu " 
;
Mov  SI,Offset $tring_24
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_17:
;
;IF day = 5 THEN
;
Cmp  DAY,5
Je   Getdosdate_True_18
Jmp  Getdosdate_EndIf_18
Getdosdate_True_18:
;
;DOW$ = "Fri " 
;
Mov  SI,Offset $tring_25
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_18:
;
;IF day = 6 THEN
;
Cmp  DAY,6
Je   Getdosdate_True_19
Jmp  Getdosdate_EndIf_19
Getdosdate_True_19:
;
;DOW$ = "Sat " 
;
Mov  SI,Offset $tring_26
Mov  DI,Offset DOW$
Call MoveStr
;
;END IF
;
Getdosdate_EndIf_19:
;
;Today$ = DOW$ + Month$ + STR$ Date + "," + STR$ Year 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset DOW$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset MONTH$
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,Date
Call Str$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_27
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,Year
Call Str$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset TODAY$
Call MoveStr
Pop  BP
Ret  00
Getdosdate Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

DATE         DW  0
MON          DW  0
YEAR         DW  0
DAY          DW  0
$tring_06    DB "Jan ",0
$tring_08    DB "Feb ",0
$tring_09    DB "Mar ",0
$tring_10    DB "Apr ",0
$tring_11    DB "May ",0
$tring_12    DB "Jun ",0
$tring_13    DB "Jul ",0
$tring_14    DB "Aug ",0
$tring_15    DB "Sep ",0
$tring_16    DB "Oct ",0
$tring_17    DB "Nov ",0
$tring_18    DB "Dec ",0
$tring_19    DB "Sun ",0
$tring_21    DB "Mon ",0
$tring_22    DB "Tue ",0
$tring_23    DB "Wed ",0
$tring_24    DB "Thu ",0
$tring_25    DB "Fri ",0
$tring_26    DB "Sat ",0
$tring_27    DB ",",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

TODAY$       DB 81 DUP(?)
MONTH$       DB 81 DUP(?)
DOW$         DB 81 DUP(?)
Data Ends

End
