;Ŀ
; DEMO37.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:15:56                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;Print "This demo will draw a box" 
;
Mov  SI,Offset $tring_01
Call PrintStr
Call SetCursor
Call DoCrLf
;
;Print "-------------------------" 
;
Mov  SI,Offset $tring_02
Call PrintStr
Call SetCursor
Call DoCrLf
;
;input "Enter width  (1 TO 78) " BoxW 
;
Mov  SI,Offset $tring_03
Call PrintStr
Call SetCursor
Call KBInput
Mov DI,Offset $Work2
Call Val
Mov BOXW,AX
Call DoCrLf
;
;input "Enter height (1 TO 20) " BoxH 
;
Mov  SI,Offset $tring_05
Call PrintStr
Call SetCursor
Call KBInput
Mov DI,Offset $Work2
Call Val
Mov BOXH,AX
Call DoCrLf
Call DrawBox

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




Val Proc Near 
;
; DI = string TO Convert 
;
Mov  $Var1,0       ;negative number flag 
Xor  BX,BX         ;Used to accumulate binary Values 
Mov  SI,BX         ;power register : 1,10,100,1000,10000 
Mov  CX,1          ;counts number of Digits In   String 
ValLoop: 
Mov  AX,[DI] 
Xor  AH,AH 
Cmp  AL,0          ;END of string? 
Je   ValPopStack   ;yes 
Cmp  AL,48         ;test for Valid chars:  0123456789 
Jb   ValBadChar 
Cmp  AL,57 
Jg   ValBadChar 
Sub  AL,'0'        ;Convert ascii TO binary 
Push AX 
Inc  SI            ;bump the number of Digits 
ValBadChar: 
Cmp  AL,45 
Jne ValMore 
Mov  $Var1,1 
ValMore: 
Inc  DI 
Jmp  ValLoop 
ValPopstack: 
Cmp  SI,0          ;IF SI = 0 THEN no Valid Digits 
JE   ValNull 
Pop  AX            ;get rightmost Digit 
Mul  CX            ;Multiply it by factor 1,10,100,1000,... 
Add  BX,AX         ;accumulate it 
Mov  AX,CX         ;get the factor 1,10,100,1000... 
Mov  CX,10 
Mul  CX            ;Multiply factor by 10 
Mov  CX,AX         ;And  re-save it 
Dec  SI            ;get NEXT Digit 
Cmp  SI,1          ;is it the leftmost Digit? 
Jge  ValPopStack   ;no 
Mov  AX,BX         ;yes...binary # In   AX 
Jmp  ValExit 
ValNull: 
Xor  AX,AX         ;get rid of cr 
ValExit: 
Cmp  $Var1,1 
Jne  Valgone 
Neg  AX 
Valgone: 
Ret 
Val Endp 




Getkey Proc Near 
Xor  AX,AX 
Int  16h 
Cmp  AL,0 
Je   ExtendedKey 
Xor  AH,AH 
Jmp  RegularKey 
ExtendedKey: 
Mov  AL,AH 
Xor  AH,AH 
Neg  AX 
RegularKey: 
Ret 
GetKey Endp 




Space$ Proc Near 
;
; AX=number of spaces to a mAX of the $String Directive 
; DI=address of receiving String 
;
Mov  CX,AX 
Mov  AL,32 
Cmp  CX, 81 
Jg   Space_Quit 
Jcxz SpaceDone 
Space_loop: 
Dec  CX 
Mov  [DI],AL 
Inc  DI 
Jcxz SpaceDone 
Jmp  Space_Loop 
SpaceDone:
Mov  [DI],Byte Ptr 0 
Space_Quit: 
Ret 
Space$ Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 


 
 
KBinput Proc Near 
Push BP 
Mov  BP,SP 
Mov  SI,Offset $KBcur 
Call PrintStr 
Xor  AX,AX 
Call ShowHideCursor 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $KBnull 
Mov  DI,Offset $Work2 
Call MoveStr 
Xor  AX,AX 
Mov  $Var0,AX 
Call GetCursor 
Mov  AX,$Xcur 
Add  AX,$Var0 
Mov  $Var1,AX 
Mov  AX,$Var1 
Mov  $Var3,AX 
Xor  AX,AX 
Mov  $Var0,AX 
Call GetCursor 
Mov  AX,$Ycur 
Add  AX,$Var0 
Mov  $Var2,AX 
KBinputLoop_1: 
Xor  AX,AX 
Mov  $Var0,AX 
Call GetKey 
Add  AX,$Var0 
Mov  $Var4,AX 
Cmp  $Var4,31 
Jg   KBinput_Pass_1 
Jmp  KBinput_Fail_1 
KBinput_Pass_1: 
Cmp  $Var4,128 
Jl   KBinput_Pass_2 
Jmp  KBinput_Fail_2 
KBinput_Pass_2: 
Xor  AX,AX 
Add  AX,$Var4 
Mov  $Var6,AX 
Mov  AX,255 
Mov  $Var4,AX 
KBinput_Fail_2: 
KBinput_Fail_1: 
Cmp  $Var4,8 
Je   KBinput_Pass_3 
Jmp  KBinput_Fail_3 
KBinput_Pass_3: 
Mov  AX,254 
Mov  $Var4,AX 
KBinput_Fail_3: 
Cmp  $Var4,-75 
Je   KBinput_Pass_4 
Jmp  KBinput_Fail_4 
KBinput_Pass_4: 
Mov  AX,254 
Mov  $Var4,AX 
KBinput_Fail_4: 
Cmp  $Var4,13 
Je   KBinput_Pass_5 
Jmp  KBinput_Fail_5 
KBinput_Pass_5: 
Jmp KBinputLoop_1A 
KBinput_Fail_5: 
Cmp  $Var4,255 
Je   KBinput_Pass_6 
Jmp  KBinput_Fail_6 
KBinput_Pass_6: 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  DI,Offset $Work1 
Mov  AX,$Var6 
Mov  [Byte Ptr DI],AX 
Xor  BX,BX 
Mov  [Byte Ptr DI+1],BX 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  AX,0 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Mov  SI,Offset $KBcur 
Call PrintStr 
Call SetCursor 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work2 
Call MoveStr 
Inc  $Var1 
KBinput_Fail_6: 
Cmp  $Var4,254 
Je   KBinput_Pass_7 
Jmp  KBinput_Fail_7 
KBinput_Pass_7: 
Xor  AX,AX 
Mov  $Var0,AX 
Mov  SI,Offset $Work2 
Call Len 
Add  AX,$Var0 
Mov  $Var5,AX 
Dec  $Var5 
Dec  $Var1 
Cmp  $Var5,1 
Jl   KBinput_Pass_8 
Jmp  KBinput_Fail_8 
KBinput_Pass_8: 
Mov  AX,1 
Mov  $Var5,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $KBnull 
Mov  DI,Offset $Work2 
Call MoveStr 
Inc  $Var1 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  SI,Offset $KBspc 
Call PrintStr 
Call SetCursor 
Xor  AX,AX 
Add  AX,$Var3 
Mov  $Var1,AX 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
KBinput_Fail_8: 
Mov  DI,Offset $Work0 
Call Nullstr 
Cld 
Mov  SI,Offset $Work2 
Mov  DI,Offset $Work1 
Mov  CX,$Var5 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work2 
Call MoveStr 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  SI,Offset $KBdblSpc 
Call PrintStr 
Call SetCursor 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  SI,Offset $KBcur 
Call PrintStr 
Call SetCursor 
KBinput_Fail_7: 
Jmp KBinputLoop_1 
KBinputLoop_1A: 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Mov  AX,1 
Call ShowHideCursor 
Mov  SI,Offset $KBspc 
Call PrintStr 
Call SetCursor 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,$Var1 
Mov  $Xcur,AX 
Pop  BP 
Ret 
KBinput Endp 
 
 


ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 




Drawbox Proc Near
Push BP
Mov  BP,SP
;
;IF BoxW < 1 THEN 
;
Cmp  BOXW,1
Jl   Drawbox_True_01
Jmp  Drawbox_EndIf_01
Drawbox_True_01:
;
;BoxW = 1 
;
Xor  AX,AX
Add  AX,1
Mov  BOXW,AX
;
;END IF 
;
Drawbox_EndIf_01:
;
;IF BoxW > 78 THEN 
;
Cmp  BOXW,78
Jg   Drawbox_True_02
Jmp  Drawbox_EndIf_02
Drawbox_True_02:
;
;BoxW = 78 
;
Xor  AX,AX
Add  AX,78
Mov  BOXW,AX
;
;END IF 
;
Drawbox_EndIf_02:
;
;IF BoxH < 1 THEN 
;
Cmp  BOXH,1
Jl   Drawbox_True_03
Jmp  Drawbox_EndIf_03
Drawbox_True_03:
;
;BoxH = 1 
;
Xor  AX,AX
Add  AX,1
Mov  BOXH,AX
;
;END IF 
;
Drawbox_EndIf_03:
;
;IF BoxH > 20 THEN 
;
Cmp  BOXH,20
Jg   Drawbox_True_04
Jmp  Drawbox_EndIf_04
Drawbox_True_04:
;
;BoxH = 20 
;
Xor  AX,AX
Add  AX,20
Mov  BOXH,AX
;
;END IF 
;
Drawbox_EndIf_04:
;
;Top$ = "" 
;
Mov  SI,Offset $tring_07
Mov  DI,Offset Top$
Call MoveStr
;
;FOR a = 1 TO BoxW 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
DrawboxForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   DrawboxForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,BOXW       ;Ascending Step
Jle DrawboxForLoop_01Okay
Jmp DrawboxForLoop_01A
DrawboxForLoop_01_NegativeStep:
Mov  AX,BOXW
Cmp  AX,A       ;Descending Step
Jle DrawboxForLoop_01Okay
Jmp DrawboxForLoop_01A
DrawboxForLoop_01Okay:
;
;Top$ = Top$ + "" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset TOP$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_10
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset TOP$
Call MoveStr
;
;NEXT 
;
Jmp DrawboxForLoop_01
DrawboxForLoop_01A:
;
;Top$ = Top$ + "" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset TOP$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_11
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset TOP$
Call MoveStr
;
;Middle$ = "" + SPACE$ BoxW + "" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset $tring_12
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,BoxW
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_12   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset MIDDLE$
Call MoveStr
;
;Bottom$ = "" 
;
Mov  SI,Offset $tring_14
Mov  DI,Offset Bottom$
Call MoveStr
;
;FOR a = 1 TO BoxW 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
DrawboxForLoop_02:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   DrawboxForLoop_02_NegativeStep
Mov  AX,A
Cmp  AX,BOXW       ;Ascending Step
Jle DrawboxForLoop_02Okay
Jmp DrawboxForLoop_02A
DrawboxForLoop_02_NegativeStep:
Mov  AX,BOXW
Cmp  AX,A       ;Descending Step
Jle DrawboxForLoop_02Okay
Jmp DrawboxForLoop_02A
DrawboxForLoop_02Okay:
;
;Bottom$ = Bottom$ + "" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset BOTTOM$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_10   
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset BOTTOM$
Call MoveStr
;
;NEXT 
;
Jmp DrawboxForLoop_02
DrawboxForLoop_02A:
;
;Bottom$ = Bottom$ + "" 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset BOTTOM$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $tring_16
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset BOTTOM$
Call MoveStr
Call Cls
;
;PRINT Top$ 
;
Mov  SI,Offset TOP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;FOR a = 1 TO BoxH 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
DrawboxForLoop_03:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   DrawboxForLoop_03_NegativeStep
Mov  AX,A
Cmp  AX,BOXH       ;Ascending Step
Jle DrawboxForLoop_03Okay
Jmp DrawboxForLoop_03A
DrawboxForLoop_03_NegativeStep:
Mov  AX,BOXH
Cmp  AX,A       ;Descending Step
Jle DrawboxForLoop_03Okay
Jmp DrawboxForLoop_03A
DrawboxForLoop_03Okay:
;
;PRINT Middle$ 
;
Mov  SI,Offset MIDDLE$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp DrawboxForLoop_03
DrawboxForLoop_03A:
;
;PRINT Bottom$ 
;
Mov  SI,Offset BOTTOM$
Call PrintStr
Call SetCursor
Call DoCrLf
Pop  BP
Ret  00
Drawbox Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
$KBnull      DB 0,0
$KBcur       DB '_',0
$KBspc       DB 32,0
$KBdblSpc    DB 32,32,0

;__________________Users Initialized Data____________________

$tring_01    DB "This demo will draw a box",0
$tring_02    DB "-------------------------",0
$tring_03    DB "Enter width  (1 TO 78) ",0
BOXW         DW  0
$tring_05    DB "Enter height (1 TO 20) ",0
BOXH         DW  0
$tring_07    DB "",0
A            DW  0
$tring_10    DB "",0
$tring_11    DB "",0
$tring_12    DB "",0
$tring_14    DB "",0
$tring_16    DB "",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

TOP$         DB 81 DUP(?)
MIDDLE$      DB 81 DUP(?)
BOTTOM$      DB 81 DUP(?)
Data Ends

End
