;Ŀ
; DEMO52.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:23:21                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;open "junk" for output as 1 
;
Mov  DX,Offset $tring_01
Xor  CX,CX     ; normal read/write attribute
Mov  Eof,CX
Mov  AH,3Ch    ; create file 
Int  21h
Call TrapError
Mov  HANDLE_1,AX
Mov  BX,AX
Mov  AH,3Eh    ; close file
Int  21h
Call TrapError
Mov  DX,Offset $tring_01
Mov  AL,1
Mov  AH,3DH    ; open file for writing
Int  21h
Call TrapError
;
;putchar #1 0 1 2 3 4 5 
;
Mov  AX,0
Mov  BX,HANDLE_1
Call PutChar
Mov  AX,1
Mov  BX,HANDLE_1
Call PutChar
Mov  AX,2
Mov  BX,HANDLE_1
Call PutChar
Mov  AX,3
Mov  BX,HANDLE_1
Call PutChar
Mov  AX,4
Mov  BX,HANDLE_1
Call PutChar
Mov  AX,5
Mov  BX,HANDLE_1
Call PutChar
;
;close 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;open "junk" for input as 1 
;
Mov  DX,Offset $tring_01   
Xor  AX,AX
Mov  Eof,AX
Mov  AH,3DH    ; open file for reading
Int  21h
Call TrapError
Mov  HANDLE_1,AX
;
;getchar #1 a b c d e f 
;
Mov  BX,HANDLE_1
Call GetChar
Mov  A,AX
Mov  BX,HANDLE_1
Call GetChar
Mov  B,AX
Mov  BX,HANDLE_1
Call GetChar
Mov  C,AX
Mov  BX,HANDLE_1
Call GetChar
Mov  D,AX
Mov  BX,HANDLE_1
Call GetChar
Mov  E,AX
Mov  BX,HANDLE_1
Call GetChar
Mov  F,AX
;
;close 
;
Mov  AX,HANDLE_1
Mov  BX,AX
Mov  AH,3Eh
Int  21h
Call TrapError
;
;PRINT a b c d e f 
;
Mov  AX,A
Call PrintNum
Call SetCursor
Mov  AX,B
Call PrintNum
Call SetCursor
Mov  AX,C
Call PrintNum
Call SetCursor
Mov  AX,D
Call PrintNum
Call SetCursor
Mov  AX,E
Call PrintNum
Call SetCursor
Mov  AX,F
Call PrintNum
Call SetCursor
Call DoCrLf
;
;kill "junk" 
;
Mov  DX,Offset $tring_01   
Mov  AH,41h
Int  21h
Call TrapError

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




TrapError Proc Near 
Jnc  NoError 
Mov  Err,AX
NoError: 
Ret
TrapError Endp 




PrintNum Proc Near
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  AX
Cmp  AX,32768 
Jb PositiveNumber 
Neg AX 
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Mov  DL,'-'
Mov  AH,2
Int  21h
Pop  AX
PositiveNumber:
Xor  CX,CX
GetAnotherDigit:
Inc  CX
Xor  DX,DX
Div $Base
Push DX
Cmp  AX,0
Jne GetAnotherDigit
PrntDigit:
Pop  AX
Add  AL,'0'
Push AX
Push BX
Push CX
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  CX
Pop  BX
Pop  AX
Mov  DL,AL
Mov  AH,2
Int  21h
Loop PrntDigit
Inc  $Xcur
Ret
PrintNum Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




PutChar Proc Near
Mov  AH,AL
Mov  $Var0,AX
Mov  DX,Offset $Var0
Mov  CX,1
Mov  AH,40h
Int  21h
Call TrapError
Ret
PutChar Endp




GetChar Proc Near
Mov  CX,1
Mov  DX,Offset $Var0
Mov  AH,3Fh
Int  21h
Mov  BX,AX
Xor  AX,AX
Mov  AX,[$Var0]
Xor  AH,AH
Cmp  BX,1
Je   GetCharExit
Mov  AX,-1
GetCharExit:
Ret
GetChar Endp


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Handle      DW 0
Eof          DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "junk",0
HANDLE_1     DW  0
A            DW  0
B            DW  0
C            DW  0
D            DW  0
E            DW  0
F            DW  0

;_________________System Un-Initialized Data_________________


;_________________Users Un-Initialized Data__________________

Data Ends

End
