;Ŀ
; DEMO54.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:24:36                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;FOR A = 1 to 20 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,20       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,20
Cmp  AX,A       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;ARRAYPUT A$ A "" 
;
Mov  AX,Offset $tring_03
Push AX
Mov  AX,A
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;NEXT 
;
Jmp ForLoop_01
ForLoop_01A:
;
;A$ 1 = "Apples" 
;
Mov  AX,Offset $tring_04
Push AX
Mov  AX,1
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;A$ 2 = "Oranges 
;
Mov  AX,Offset $tring_05
Push AX
Mov  AX,2
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;A$ 3 = "Bananas 
;
Mov  AX,Offset $tring_06
Push AX
Mov  AX,3
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;A$ 4 = "Grapes" 
;
Mov  AX,Offset $tring_07
Push AX
Mov  AX,4
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;A$ 5 = "Raisins" 
;
Mov  AX,Offset $tring_08
Push AX
Mov  AX,5
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;PRINT "Before insert... 
;
Mov  SI,Offset $tring_09
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT 
;
Call DoCrLf
;
;FOR A = 1 TO 5 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_02:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_02_NegativeStep
Mov  AX,A
Cmp  AX,5       ;Ascending Step
Jle ForLoop_02Okay
Jmp ForLoop_02A
ForLoop_02_NegativeStep:
Mov  AX,5
Cmp  AX,A       ;Descending Step
Jle ForLoop_02Okay
Jmp ForLoop_02A
ForLoop_02Okay:
;
;Tmp$ = A$ A 
;
Mov  AX,Offset TMP$
Push AX
Mov  AX,A
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayGet
;
;PRINT Tmp$ 
;
Mov  SI,Offset TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp ForLoop_02
ForLoop_02A:
;
;PRINT 
;
Call DoCrLf
;
;PRINT "After insert... 
;
Mov  SI,Offset $tring_11
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT 
;
Call DoCrLf
;
;ARRAY INSERT A$ 3 20 
;
Mov  AX,20
Push AX
Mov  AX,3
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayInsert
;
;A$ 3 = "INSERTED LINE" 
;
Mov  AX,Offset $tring_12
Push AX
Mov  AX,3
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayPut
;
;FOR A = 1 TO 6 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_03:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_03_NegativeStep
Mov  AX,A
Cmp  AX,6       ;Ascending Step
Jle ForLoop_03Okay
Jmp ForLoop_03A
ForLoop_03_NegativeStep:
Mov  AX,6
Cmp  AX,A       ;Descending Step
Jle ForLoop_03Okay
Jmp ForLoop_03A
ForLoop_03Okay:
;
;Tmp$ = A$ A 
;
Mov  AX,Offset TMP$
Push AX
Mov  AX,A
Push AX
Mov  AX,Offset A$
Push AX
Call ArrayGet
;
;PRINT Tmp$ 
;
Mov  SI,Offset TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp ForLoop_03
ForLoop_03A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ArrayInsert Proc Near 
Push BP 
Mov  BP,SP 
Xor  AX,AX 
Mov  $Var10,AX 
Mov  $Var11,AX 
Mov  $Var12,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  AX,[BP][08] 
Dec  AX 
Mov  $Var11,AX 
Mov  AX,$Var11 
Sub  AX,-1 
Mov  $Var10,AX 
ArrayInsertLoop_01: 
Mov  AX,-1 
Add  $Var10,AX 
Mov  AX,-1 
Cmp  AX,0 
Jl   ArrayInsertLoop_01_StepDn 
Mov  AX,$Var10 
Cmp  AX,[BP][06] 
Jle  ArrayInsertLoop_01_OK 
Jmp  ArrayInsertLoop_01A 
ArrayInsertLoop_01_StepDn: 
Mov  AX,[BP][06] 
Cmp  AX,$Var10 
Jle  ArrayInsertLoop_01_OK 
Jmp  ArrayInsertLoop_01A 
ArrayInsertLoop_01_OK: 
Mov  AX,Offset $Work0 
Push AX 
Mov  AX,$Var10 
Push AX 
Mov  AX,[BP][04] 
Push AX 
Call ArrayGet 
Mov  AX,$Var10 
Inc  AX 
Mov  $Var12,AX 
Mov  AX,Offset $Work0 
Push AX 
Mov  AX,$Var12 
Push AX 
Mov  AX,[BP][04] 
Push AX 
Call ArrayPut 
Jmp  ArrayInsertLoop_01 
ArrayInsertLoop_01A: 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  AX,Offset $Work0 
Push AX 
Mov  AX,[BP][06] 
Push AX 
Mov  AX,[BP][04] 
Push AX 
Call ArrayPut 
Pop  BP 
Ret  06 
ArrayInsert Endp 




ArrayPut Proc Near 
Push BP 
Mov  BP,SP 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  DI,[BP][04] 
Add  DI,AX 
Inc  DI 
Inc  DI 
Push DI 
Call NullStr 
Pop  DI 
Mov  SI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayPut Endp 




ArrayGet Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,[BP][08] 
Call NullStr 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  SI,[BP][04] 
Add  SI,AX 
Inc  SI 
Inc  SI 
Mov  DI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayGet Endp 


Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

A            DW  0
$tring_03    DB  0,0
$tring_04    DB "Apples",0
$tring_05    DB "Oranges",0
$tring_06    DB "Bananas",0
$tring_07    DB "Grapes",0
$tring_08    DB "Raisins",0
$tring_09    DB "Before insert...",0
$tring_11    DB "After insert...",0
$tring_12    DB "INSERTED LINE",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

A$           DB 00,20, 420 DUP(?)
TMP$         DB 81 DUP(?)
Data Ends

End
