;Ŀ
; DEMO59.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:27:56                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
Call Cls
;
;Z$ = "Apples,Oranges;Bananas-Grapes;Kiwi-Raisins,Berries Cantalope" 
;
Mov  SI,Offset $tring_01
Mov  DI,Offset Z$
Call MoveStr
;
;DO
;
DoLoop_01:
;
;IF Z$ > ""  THEN
;
Mov  SI,Offset Z$
Mov  DI,Offset $tring_03
Call StrCompare
Jg   _True_01
Jmp  _EndIf_01
_True_01:
;
;Parse Z$ ",;- " Q$ 
;
Mov  AX,Offset Q$
Push AX
Mov  AX,Offset $tring_04
Push AX
Mov  AX,Offset Z$
Push AX
Call Parse
;
;PRINT Q$ 
;
Mov  SI,Offset Q$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;ELSE
;
Jmp _EndIf_01A
_EndIf_01:
;
;EXIT LOOP
;
Jmp DoLoop_01A
;
;END IF
;
_EndIf_01A:
;
;LOOP
;
Jmp DoLoop_01
DoLoop_01A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




StrCompare Proc Near 
Push AX 
Push DI 
Push SI 
Cld 
StrCmp1: 
Lodsb 
Scasb 
Jne  StrCmp2 
Or   AL,AL 
Jne StrCmp1 
StrCmp2: 
Pop  SI 
Pop  DI 
Pop  AX 
Ret 
StrCompare Endp 




Instr Proc Near 
;---------------------- 
;SI = match   (len = 1) 
;DI = main 
;output position In   AX 
;---------------------- 
Xor  AX,AX 
Mov  CX,AX 
Mov  AL,[SI]  ;load match 
InstrLoop: 
Cmp  [DI],AL 
Je   InstrExit 
Cmp  [DI],Byte ptr 0 
Je   InstrNoMatch 
Cmp  CX, 81 
Je   InstrNoMatch 
Inc  CX 
Inc  DI 
Jmp  InstrLoop 
InstrNoMatch: 
Xor  AX,AX 
Jmp  InstrDone 
InstrExit: 
Inc  CX 
Mov  AX,CX 
InstrDone: 
Ret 
Instr Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




Parse Proc Near
Push BP
Mov  BP,SP
;
;LOCAL Tmp Tmp$ LenA I J K 
;
Mov  L_PARSE_TMP,0
Mov  DI,Offset L_PARSE_TMP$
Call Nullstr
Mov  L_PARSE_LENA,0
Mov  L_PARSE_I,0
Mov  L_PARSE_J,0
Mov  L_PARSE_K,0
;
;Word$ = "" 
;
Mov  SI,Offset $tring_12
Mov  DI,[BP][08]
Call MoveStr
;
;LenA = LEN A$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,[BP][04]
Call Len
Add  AX,$Var0
Mov  L_PARSE_LENA,AX
;
;IF A$ = "" THEN 
;
Mov  SI,[BP][04]
Mov  DI,Offset $tring_14
Call StrCompare
Je   Parse_True_02
Jmp  Parse_EndIf_02
Parse_True_02:
Pop  BP
Ret  06
;
;END IF 
;
Parse_EndIf_02:
;
;FOR I = 1 TO LenA 
;
Mov  AX,1
Sub  AX,1
Mov  L_PARSE_I,AX
ParseForLoop_01:
Mov  AX,1
Add  L_PARSE_I,AX
Mov  AX,1
Cmp  AX,0
Jl   ParseForLoop_01_NegativeStep
Mov  AX,L_PARSE_I
Cmp  AX,L_PARSE_LENA       ;Ascending Step
Jle ParseForLoop_01Okay
Jmp ParseForLoop_01A
ParseForLoop_01_NegativeStep:
Mov  AX,L_PARSE_LENA
Cmp  AX,L_PARSE_I       ;Descending Step
Jle ParseForLoop_01Okay
Jmp ParseForLoop_01A
ParseForLoop_01Okay:
;
;Tmp$ = MID$ A$ I 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_PARSE_I
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_TMP$
Call MoveStr
;
;Tmp = INSTR Sep$ Tmp$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset L_PARSE_Tmp$
Call Instr
Add  AX,$Var0
Mov  L_PARSE_TMP,AX
;
;IF Tmp = 0 THEN 
;
Cmp  L_PARSE_TMP,0
Je   Parse_True_03
Jmp  Parse_EndIf_03
Parse_True_03:
;
;EXIT FOR 
;
Jmp ParseForLoop_01A
;
;END IF 
;
Parse_EndIf_03:
;
;NEXT 
;
Jmp ParseForLoop_01
ParseForLoop_01A:
;
;FOR J = I TO LenA 
;
Mov  AX,L_PARSE_I
Sub  AX,1
Mov  L_PARSE_J,AX
ParseForLoop_02:
Mov  AX,1
Add  L_PARSE_J,AX
Mov  AX,1
Cmp  AX,0
Jl   ParseForLoop_02_NegativeStep
Mov  AX,L_PARSE_J
Cmp  AX,L_PARSE_LENA       ;Ascending Step
Jle ParseForLoop_02Okay
Jmp ParseForLoop_02A
ParseForLoop_02_NegativeStep:
Mov  AX,L_PARSE_LENA
Cmp  AX,L_PARSE_J       ;Descending Step
Jle ParseForLoop_02Okay
Jmp ParseForLoop_02A
ParseForLoop_02Okay:
;
;Tmp$ = MID$ A$ J 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_PARSE_J
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_TMP$
Call MoveStr
;
;Tmp = INSTR Sep$ Tmp$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset L_PARSE_Tmp$
Call Instr
Add  AX,$Var0
Mov  L_PARSE_TMP,AX
;
;IF Tmp THEN 
;
Cmp  L_PARSE_TMP,0
Jne  Parse_True_04
Jmp  Parse_EndIf_04
Parse_True_04:
;
;EXIT FOR 
;
Jmp ParseForLoop_02A
;
;END IF 
;
Parse_EndIf_04:
;
;NEXT 
;
Jmp ParseForLoop_02
ParseForLoop_02A:
;
;FOR K = J TO LenA 
;
Mov  AX,L_PARSE_J
Sub  AX,1
Mov  L_PARSE_K,AX
ParseForLoop_03:
Mov  AX,1
Add  L_PARSE_K,AX
Mov  AX,1
Cmp  AX,0
Jl   ParseForLoop_03_NegativeStep
Mov  AX,L_PARSE_K
Cmp  AX,L_PARSE_LENA       ;Ascending Step
Jle ParseForLoop_03Okay
Jmp ParseForLoop_03A
ParseForLoop_03_NegativeStep:
Mov  AX,L_PARSE_LENA
Cmp  AX,L_PARSE_K       ;Descending Step
Jle ParseForLoop_03Okay
Jmp ParseForLoop_03A
ParseForLoop_03Okay:
;
;Tmp$ = MID$ A$ K 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_PARSE_K
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_TMP$
Call MoveStr
;
;Tmp = INSTR Sep$ Tmp$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  DI,[BP][06]
Mov  SI,Offset L_PARSE_Tmp$
Call Instr
Add  AX,$Var0
Mov  L_PARSE_TMP,AX
;
;IF Tmp = 0 THEN 
;
Cmp  L_PARSE_TMP,0
Je   Parse_True_05
Jmp  Parse_EndIf_05
Parse_True_05:
;
;EXIT FOR 
;
Jmp ParseForLoop_03A
;
;END IF 
;
Parse_EndIf_05:
;
;NEXT 
;
Jmp ParseForLoop_03
ParseForLoop_03A:
;
;IF I > LenA THEN 
;
Mov  AX,L_PARSE_I
Cmp  AX,L_PARSE_LENA
Jg   Parse_True_06
Jmp  Parse_EndIf_06
Parse_True_06:
;
;A$ = "" 
;
Mov  SI,Offset $tring_16
Mov  DI,[BP][04]
Call MoveStr
Pop  BP
Ret  06
;
;END IF 
;
Parse_EndIf_06:
;
;IF J > LenA THEN 
;
Mov  AX,L_PARSE_J
Cmp  AX,L_PARSE_LENA
Jg   Parse_True_07
Jmp  Parse_EndIf_07
Parse_True_07:
;
;Word$ = MID$ A$ I 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_PARSE_I
Dec  SI
Mov  CX,81
Sub  CX,L_PARSE_I
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,[BP][08]
Call MoveStr
;
;A$ = "" 
;
Mov  SI,Offset $tring_17
Mov  DI,[BP][04]
Call MoveStr
Pop  BP
Ret  06
;
;END IF 
;
Parse_EndIf_07:
;
;Tmp = J - I 
;
Xor  AX,AX
Add  AX,L_PARSE_J
Sub  AX,L_PARSE_I
Mov  L_PARSE_TMP,AX
;
;Word$ = MID$ A$ 1 Tmp 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Mov  CX,L_PARSE_Tmp
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,[BP][08]
Call MoveStr
;
;IF K > LenA THEN 
;
Mov  AX,L_PARSE_K
Cmp  AX,L_PARSE_LENA
Jg   Parse_True_08
Jmp  Parse_EndIf_08
Parse_True_08:
;
;A$ = "" 
;
Mov  SI,Offset $tring_18
Mov  DI,[BP][04]
Call MoveStr
;
;ELSE 
;
Jmp Parse_EndIf_08A
Parse_EndIf_08:
;
;A$ = MID$ A$ K 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,[BP][04]
Mov  DI,Offset $Work1
Add  SI,L_PARSE_K
Dec  SI
Mov  CX,81
Sub  CX,L_PARSE_K
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,[BP][04]
Call MoveStr
;
;END IF 
;
Parse_EndIf_08A:
Pop  BP
Ret  06
Parse Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

$tring_01    DB "Apples,Oranges;Bananas-Grapes;Kiwi-Raisins,Berries Cantalope",0
$tring_03    DB  0,0
$tring_04    DB ",;- ",0
L_PARSE_TMP  DW  0
L_PARSE_LENA DW  0
L_PARSE_I    DW  0
L_PARSE_J    DW  0
L_PARSE_K    DW  0
$tring_12    DB  0,0
$tring_14    DB  0,0
$tring_16    DB  0,0
$tring_17    DB  0,0
$tring_18    DB  0,0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

Z$           DB 81 DUP(?)
Q$           DB 81 DUP(?)
L_PARSE_TMP$ DB 81 DUP(?)
WORD$        DB 81 DUP(?)
A$           DB 81 DUP(?)
Data Ends

End
