;Ŀ
; DEMO60.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:28:59                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;--------------------------------
;Fetch the command line Arguments
;--------------------------------
Push ES     ;Save the PSP Segment
Mov  BX,Seg Data
Mov  DS,BX
Push DS
Push DS
Mov  DI,0
Lea  BX,ES:[81h]
GetCmdLine:
Mov  AL,ES:[BX]
Cmp  AL,13
Je   GotCmdLine
Mov  Command$ [DI],AL
Inc  DI
Inc  BX
Jmp  GetCmdLine
GotCmdLine:
Mov  Command$ [DI],0
Pop  DS
Pop  ES
Cld
Mov  SI,Offset Command$+1
Mov  DI,Offset Command$
Mov  CX,80
Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
Pop  ES             ;Restore PSP Segment
;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;z$ = Command$ 
;
Mov  SI,Offset Command$
Mov  DI,Offset z$
Call MoveStr
;
;Tokens = Parse z$ Buf$ 40 
;
Mov  AX,40
Push AX
Mov  AX,Offset Buf$
Push AX
Mov  AX,Offset z$
Push AX
Call Parse
Mov  AX,NumFunc 
Mov  Tokens,AX
;
;IF Tokens = 0 THEN 
;
Cmp  TOKENS,0
Je   _True_01
Jmp  _EndIf_01
_True_01:
;
;PRINT "You did not pass any command line parameters" 
;
Mov  SI,Offset $tring_04
Call PrintStr
Call SetCursor
Call DoCrLf
;
;ELSE 
;
Jmp _EndIf_01A
_EndIf_01:
;
;FOR A = 1 TO Tokens 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ForLoop_01:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ForLoop_01_NegativeStep
Mov  AX,A
Cmp  AX,TOKENS       ;Ascending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01_NegativeStep:
Mov  AX,TOKENS
Cmp  AX,A       ;Descending Step
Jle ForLoop_01Okay
Jmp ForLoop_01A
ForLoop_01Okay:
;
;A$ = Buf$ a 
;
Mov  AX,Offset A$
Push AX
Mov  AX,A
Push AX
Mov  AX,Offset BUF$
Push AX
Call ArrayGet
;
;Print A$ 
;
Mov  SI,Offset A$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp ForLoop_01
ForLoop_01A:
;
;END IF 
;
_EndIf_01A:
;
;PRINT "Params:" Tokens 
;
Mov  SI,Offset $tring_07
Call PrintStr
Call SetCursor
Mov  AX,TOKENS
Call PrintNum
Call SetCursor
Call DoCrLf

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




StrCompare Proc Near 
Push AX 
Push DI 
Push SI 
Cld 
StrCmp1: 
Lodsb 
Scasb 
Jne  StrCmp2 
Or   AL,AL 
Jne StrCmp1 
StrCmp2: 
Pop  SI 
Pop  DI 
Pop  AX 
Ret 
StrCompare Endp 




Replace Proc Near 
; -------------------------------- 
; match$   = $Work2 
; repl$    = $Work3 
; main$    = $Work4 
; ------------------------------- 
; Resulting string is In   $Work0 
; ------------------------------- 
Mov  DI,Offset $Work5 
Call NullStr 
Mov  DI,Offset $Work0 
Call NullStr 
Xor  AX,AX 
Mov  $Var0,AX 
Mov  SI,Offset $Work4 
Call Len 
Add  AX,$Var0 
Mov  $Var4,AX 
Mov  SI,Offset $Work2 
Call Len 
Mov  $Var5,AX 
Xor  AX,AX 
Mov  $Var6,AX 
ReplaceForLoop_01: 
Mov  AX,1 
Add  $Var6,AX 
Mov  AX,$Var6 
Cmp  AX,$Var4 
Jg   ReplaceForLoop_01A 
Cld 
Mov  SI,Offset $Work4 
Mov  DI,Offset $Work1 
Add  SI,$Var6 
Dec  SI 
Mov  CX,$Var5 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work5 
Call MoveStr 
Mov  SI,Offset $Work5 
Mov  DI,Offset $Work2 
Call StrCompare 
Jne  Replace_Fail01 
Mov  SI,Offset $Work3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,$Var5 
Add  $Var6,AX 
Dec  $Var6 
Jmp  Replace_Fail01A 
Replace_Fail01: 
Cld 
Mov  SI,Offset $Work4 
Mov  DI,Offset $Work1 
Add  SI,$Var6 
Dec  SI 
Mov  CX,1 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Mov  [DI],Byte Ptr 0 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Replace_Fail01A: 
Jmp  ReplaceForLoop_01 
ReplaceForLoop_01A: 
Ret 
Replace Endp 




PrintNum Proc Near
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  AX
Cmp  AX,32768 
Jb PositiveNumber 
Neg AX 
Push AX
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Mov  DL,'-'
Mov  AH,2
Int  21h
Pop  AX
PositiveNumber:
Xor  CX,CX
GetAnotherDigit:
Inc  CX
Xor  DX,DX
Div $Base
Push DX
Cmp  AX,0
Jne GetAnotherDigit
PrntDigit:
Pop  AX
Add  AL,'0'
Push AX
Push BX
Push CX
Mov  AH,9
Mov  AL,32
Mov  CX,1
Mov  BX,$Attr
Xor  BH,BH
Int  10h
Inc  $Xcur
Pop  CX
Pop  BX
Pop  AX
Mov  DL,AL
Mov  AH,2
Int  21h
Loop PrntDigit
Inc  $Xcur
Ret
PrintNum Endp




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp



Trim$ Proc Near 
;------------------------ 
;SI=input   $Work1=output 
;------------------------ 
Mov  DI,Offset $Work2 
Call MoveStr 
Mov  SI,Offset $Work2 
Call Ltrim$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work2 
Call MoveStr 
Mov  SI,Offset $Work2 
Call Rtrim$ 
Ret 
Trim$ Endp 



Rtrim$ Proc Near 
;
; SI=address of String TO rtrim 
; * Note * trims ALL chars 0 TO 32 
;
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $Work2
Mov  DI,Offset $Work1 
Call MoveStr 
Mov  SI,Offset $Work1 
Call Len 
Mov  DI,Offset $Work1 
Mov  CX,AX 
Add  DI,AX 
Rtrim_loop: 
Mov  BX,[DI] 
Cmp  BX,32 
Jg   Rtrim_Quit 
Mov  [DI],Byte Ptr 0 
Dec  CX 
Dec  DI 
Cmp  CX,0 
Jge  Rtrim_loop 
Rtrim_quit: 
Ret 
Rtrim$ Endp 




Ltrim$ Proc Near 
;---------------------------------------- 
; SI=$Work2       Output String In   $Work1 
;---------------------------------------- 
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $Work2
Xor  CX,CX 
LtrimLoop: 
Cmp  [SI],Byte ptr 32 
Jne  LtrimDone 
Inc  SI 
Inc  CX 
Cmp  CX, 81 
Jne  LtrimLoop 
LtrimDone: 
Mov  CX, 81 
Mov  DI,Offset $Work1 
Cld 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Ret 
Ltrim$ Endp 




Extract Proc Near 
;
;SI = main$ 
;DI = match$     Len match$ = 1 only 
;
Mov  AL,[DI] 
Mov  DI,Offset $Work1 
Xor  CX,CX 
Extr_loop: 
Mov  BL,[SI] 
Cmp  BL,AL 
Je   Extr_Done 
Mov  [DI],BL 
Inc  DI 
Inc  SI 
Inc  CX 
Cmp  CX, 81 
Jne  Extr_loop 
Extr_Done: 
Mov  [DI],Byte Ptr 0 
Ret 
Extract Endp 




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ArrayPut Proc Near 
Push BP 
Mov  BP,SP 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  DI,[BP][04] 
Add  DI,AX 
Inc  DI 
Inc  DI 
Push DI 
Call NullStr 
Pop  DI 
Mov  SI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayPut Endp 




ArrayGet Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,[BP][08] 
Call NullStr 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  SI,[BP][04] 
Add  SI,AX 
Inc  SI 
Inc  SI 
Mov  DI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayGet Endp 




Parse Proc Near
Push BP
Mov  BP,SP
;
;LOCAL Tmp Ndx A$ B$ Quote$ Arglen IsQuote Lin$ Tmp$ 
;
Mov  L_PARSE_TMP,0
Mov  L_PARSE_NDX,0
Mov  DI,Offset L_PARSE_A$
Call Nullstr
Mov  DI,Offset L_PARSE_B$
Call Nullstr
Mov  DI,Offset L_PARSE_QUOTE$
Call Nullstr
Mov  L_PARSE_ARGLEN,0
Mov  L_PARSE_ISQUOTE,0
Mov  DI,Offset L_PARSE_LIN$
Call Nullstr
Mov  DI,Offset L_PARSE_TMP$
Call Nullstr
;
;Lin$ = Arg$ 
;
Mov  SI,[BP][04]
Mov  DI,Offset L_PARSE_Lin$
Call MoveStr
;
;Quote$ = CHR$ 34 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,34
Mov  [Byte Ptr DI],AX
Xor  BX,BX
Mov  [Byte Ptr DI+1],BX
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_QUOTE$
Call MoveStr
;
;Arglen = LEN Lin$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_PARSE_Lin$
Call Len
Add  AX,$Var0
Mov  L_PARSE_ARGLEN,AX
;
;FOR a = 1 TO Arglen 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ParseForLoop_02:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ParseForLoop_02_NegativeStep
Mov  AX,A
Cmp  AX,L_PARSE_ARGLEN       ;Ascending Step
Jle ParseForLoop_02Okay
Jmp ParseForLoop_02A
ParseForLoop_02_NegativeStep:
Mov  AX,L_PARSE_ARGLEN
Cmp  AX,A       ;Descending Step
Jle ParseForLoop_02Okay
Jmp ParseForLoop_02A
ParseForLoop_02Okay:
;
;A$ = MID$ Lin$ a 1 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_PARSE_Lin$
Mov  DI,Offset $Work1
Add  SI,a
Dec  SI
Mov  CX,1
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;IF A$ = Quote$ THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset L_PARSE_QUOTE$
Call StrCompare
Je   Parse_True_02
Jmp  Parse_EndIf_02
Parse_True_02:
;
;IsQuote = NOT IsQuote 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  AX,L_PARSE_IsQuote
Not  AX
Mov  $Var0,AX
Xor  AX,AX
Add  AX,$Var0
Mov  L_PARSE_ISQUOTE,AX
;
;END IF 
;
Parse_EndIf_02:
;
;IF A$ = " " THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_18
Call StrCompare
Je   Parse_True_03
Jmp  Parse_EndIf_03
Parse_True_03:
;
;IF IsQuote THEN 
;
Cmp  L_PARSE_ISQUOTE,0
Jne  Parse_True_04
Jmp  Parse_EndIf_04
Parse_True_04:
;
;A$ = CHR$ 255 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,255
Mov  [Byte Ptr DI],AX
Xor  BX,BX
Mov  [Byte Ptr DI+1],BX
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_04:
;
;END IF 
;
Parse_EndIf_03:
;
;IF A$ = ";" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_19
Call StrCompare
Je   Parse_True_05
Jmp  Parse_EndIf_05
Parse_True_05:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_06
Jmp  Parse_EndIf_06
Parse_True_06:
;
;A$ = " " 
;
Mov  SI,Offset $tring_18   
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_06:
;
;END IF 
;
Parse_EndIf_05:
;
;IF A$ = "," THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_20
Call StrCompare
Je   Parse_True_07
Jmp  Parse_EndIf_07
Parse_True_07:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_08
Jmp  Parse_EndIf_08
Parse_True_08:
;
;A$ = " " 
;
Mov  SI,Offset $tring_18   
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_08:
;
;END IF 
;
Parse_EndIf_07:
;
;IF A$ = "(" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_21
Call StrCompare
Je   Parse_True_09
Jmp  Parse_EndIf_09
Parse_True_09:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_10
Jmp  Parse_EndIf_10
Parse_True_10:
;
;A$ = " " 
;
Mov  SI,Offset $tring_18   
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_10:
;
;END IF 
;
Parse_EndIf_09:
;
;IF A$ = ")" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_22
Call StrCompare
Je   Parse_True_11
Jmp  Parse_EndIf_11
Parse_True_11:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_12
Jmp  Parse_EndIf_12
Parse_True_12:
;
;A$ = " " 
;
Mov  SI,Offset $tring_18   
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_12:
;
;END IF 
;
Parse_EndIf_11:
;
;IF A$ = "+" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_23
Call StrCompare
Je   Parse_True_13
Jmp  Parse_EndIf_13
Parse_True_13:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_14
Jmp  Parse_EndIf_14
Parse_True_14:
;
;A$ = " + " 
;
Mov  SI,Offset $tring_24
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_14:
;
;END IF 
;
Parse_EndIf_13:
;
;IF A$ = "-" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_25
Call StrCompare
Je   Parse_True_15
Jmp  Parse_EndIf_15
Parse_True_15:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_16
Jmp  Parse_EndIf_16
Parse_True_16:
;
;A$ = " - " 
;
Mov  SI,Offset $tring_26
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_16:
;
;END IF 
;
Parse_EndIf_15:
;
;IF A$ = "*" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_27
Call StrCompare
Je   Parse_True_17
Jmp  Parse_EndIf_17
Parse_True_17:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_18
Jmp  Parse_EndIf_18
Parse_True_18:
;
;A$ = " * " 
;
Mov  SI,Offset $tring_28
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_18:
;
;END IF 
;
Parse_EndIf_17:
;
;IF A$ = "/" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_29
Call StrCompare
Je   Parse_True_19
Jmp  Parse_EndIf_19
Parse_True_19:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_20
Jmp  Parse_EndIf_20
Parse_True_20:
;
;A$ = " / " 
;
Mov  SI,Offset $tring_30
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_20:
;
;END IF 
;
Parse_EndIf_19:
;
;IF A$ = "<" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_31
Call StrCompare
Je   Parse_True_21
Jmp  Parse_EndIf_21
Parse_True_21:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_22
Jmp  Parse_EndIf_22
Parse_True_22:
;
;A$ = " < " 
;
Mov  SI,Offset $tring_32
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_22:
;
;END IF 
;
Parse_EndIf_21:
;
;IF A$ = ">" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_33
Call StrCompare
Je   Parse_True_23
Jmp  Parse_EndIf_23
Parse_True_23:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_24
Jmp  Parse_EndIf_24
Parse_True_24:
;
;A$ = " > " 
;
Mov  SI,Offset $tring_34
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_24:
;
;END IF 
;
Parse_EndIf_23:
;
;IF A$ = "=" THEN 
;
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $tring_35
Call StrCompare
Je   Parse_True_25
Jmp  Parse_EndIf_25
Parse_True_25:
;
;IF Not IsQuote THEN 
;
Mov  AX,0
Cmp  AX,L_PARSE_ISQUOTE
Je   Parse_True_26
Jmp  Parse_EndIf_26
Parse_True_26:
;
;A$ = " = " 
;
Mov  SI,Offset $tring_36
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;GOTO ParseMore 
;
Jmp ParseMore
;
;END IF 
;
Parse_EndIf_26:
;
;END IF 
;
Parse_EndIf_25:

ParseMore:
;
;B$ = B$ + A$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_PARSE_B$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_B$
Call MoveStr
;
;NEXT 
;
Jmp ParseForLoop_02
ParseForLoop_02A:
;
;Lin$ = B$ 
;
Mov  SI,Offset L_PARSE_B$
Mov  DI,Offset L_PARSE_Lin$
Call MoveStr
;
;FOR Tmp = 1 TO StackSize 
;
Mov  AX,1
Sub  AX,1
Mov  L_PARSE_TMP,AX
ParseForLoop_03:
Mov  AX,1
Add  L_PARSE_TMP,AX
Mov  AX,1
Cmp  AX,0
Jl   ParseForLoop_03_NegativeStep
Mov  AX,L_PARSE_TMP
Cmp  AX,[BP][08]       ;Ascending Step
Jle ParseForLoop_03Okay
Jmp ParseForLoop_03A
ParseForLoop_03_NegativeStep:
Mov  AX,[BP][08]
Cmp  AX,L_PARSE_TMP       ;Descending Step
Jle ParseForLoop_03Okay
Jmp ParseForLoop_03A
ParseForLoop_03Okay:
;
;ParseStack$ Tmp = "" 
;
Mov  AX,Offset $tring_37
Push AX
Mov  AX,L_PARSE_TMP
Push AX
Mov  AX,[BP][06]
Push AX
Call ArrayPut
;
;NEXT 
;
Jmp ParseForLoop_03
ParseForLoop_03A:
;
;Lin$ = TRIM$ Lin$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_PARSE_Lin$
Call Trim$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_LIN$
Call MoveStr
;
;Tmp = LEN Lin$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_PARSE_Lin$
Call Len
Add  AX,$Var0
Mov  L_PARSE_TMP,AX
;
;IF Tmp = 0 THEN 
;
Cmp  L_PARSE_TMP,0
Je   Parse_True_27
Jmp  Parse_EndIf_27
Parse_True_27:
;
;Tokens = 0 
;
Xor  AX,AX
Add  AX,0
Mov  TOKENS,AX
;
;GOTO ParseQuit 
;
Jmp ParseQuit
;
;END IF 
;
Parse_EndIf_27:
;
;DO 
;
ParseDoLoop_01:
;
;Tmp$ = EXTRACT$ Lin$ " " 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_PARSE_Lin$
Mov  DI,Offset $tring_18   
Call Extract
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_TMP$
Call MoveStr
;
;INCR Ndx 
;
Inc  L_PARSE_NDX
;
;ParseStack$ Ndx = Tmp$ 
;
Mov  AX,Offset L_PARSE_TMP$
Push AX
Mov  AX,L_PARSE_NDX
Push AX
Mov  AX,[BP][06]
Push AX
Call ArrayPut
;
;Tmp = LEN Tmp$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_PARSE_Tmp$
Call Len
Add  AX,$Var0
Mov  L_PARSE_TMP,AX
;
;IF Tmp > 0 THEN 
;
Cmp  L_PARSE_TMP,0
Jg   Parse_True_28
Jmp  Parse_EndIf_28
Parse_True_28:
;
;INCR Tmp 
;
Inc  L_PARSE_TMP
;
;Lin$ = MID$ Lin$ Tmp 
;
Mov  DI,Offset $Work0
Call Nullstr
Cld
Mov  SI,Offset L_PARSE_Lin$
Mov  DI,Offset $Work1
Add  SI,L_PARSE_Tmp
Dec  SI
Mov  CX,81
Sub  CX,L_PARSE_Tmp
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
Mov  [DI],Byte Ptr 0
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_LIN$
Call MoveStr
;
;Lin$ = LTRIM$ Lin$ 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_PARSE_Lin$
Call Ltrim$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_LIN$
Call MoveStr
;
;ELSE 
;
Jmp Parse_EndIf_28A
Parse_EndIf_28:
;
;DECR Ndx 
;
Dec  L_PARSE_NDX
;
;EXIT LOOP 
;
Jmp ParseDoLoop_01A
;
;END IF 
;
Parse_EndIf_28A:
;
;LOOP 
;
Jmp ParseDoLoop_01
ParseDoLoop_01A:
;
;B$ = CHR$ 255 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,255
Mov  [Byte Ptr DI],AX
Xor  BX,BX
Mov  [Byte Ptr DI+1],BX
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_B$
Call MoveStr
;
;FOR a = 1 TO Ndx 
;
Mov  AX,1
Sub  AX,1
Mov  A,AX
ParseForLoop_04:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ParseForLoop_04_NegativeStep
Mov  AX,A
Cmp  AX,L_PARSE_NDX       ;Ascending Step
Jle ParseForLoop_04Okay
Jmp ParseForLoop_04A
ParseForLoop_04_NegativeStep:
Mov  AX,L_PARSE_NDX
Cmp  AX,A       ;Descending Step
Jle ParseForLoop_04Okay
Jmp ParseForLoop_04A
ParseForLoop_04Okay:
;
;A$ = ParseStack$ a 
;
Mov  AX,Offset L_PARSE_A$
Push AX
Mov  AX,A
Push AX
Mov  AX,[BP][06]
Push AX
Call ArrayGet
;
;REPLACE B$ WITH " " IN A$ 
;
Mov  SI,Offset L_PARSE_B$
Mov  DI,Offset $Work2
Call MoveStr
Mov  SI,Offset $tring_18   
Mov  DI,Offset $Work3
Call MoveStr
Mov  SI,Offset L_PARSE_A$
Mov  DI,Offset $Work4
Call MoveStr
Call Replace
Mov  SI,Offset $Work0
Mov  DI,Offset L_PARSE_A$
Call MoveStr
;
;ParseStack$ a = A$ 
;
Mov  AX,Offset L_PARSE_A$
Push AX
Mov  AX,A
Push AX
Mov  AX,[BP][06]
Push AX
Call ArrayPut
;
;NEXT 
;
Jmp ParseForLoop_04
ParseForLoop_04A:
;
;Parse = Ndx 
;
Xor  AX,AX
Add  AX,L_PARSE_NDX
Mov  NUMFUNC,AX

ParseQuit:
Pop  BP
Ret  06
Parse Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Base        DW 10
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
Command$     DB 81 DUP(0)

;__________________Users Initialized Data____________________

TOKENS       DW  0
$tring_04    DB "You did not pass any command line parameters",0
A            DW  0
$tring_07    DB "Params:",0
NUMFUNC      DW  0
L_PARSE_TMP  DW  0
L_PARSE_NDX  DW  0
L_PARSE_ARGLEN DW  0
L_PARSE_ISQUOTE DW  0
$tring_18    DB " ",0
$tring_19    DB ";",0
$tring_20    DB ",",0
$tring_21    DB "(",0
$tring_22    DB ")",0
$tring_23    DB "+",0
$tring_24    DB " + ",0
$tring_25    DB "-",0
$tring_26    DB " - ",0
$tring_27    DB "*",0
$tring_28    DB " * ",0
$tring_29    DB "/",0
$tring_30    DB " / ",0
$tring_31    DB "<",0
$tring_32    DB " < ",0
$tring_33    DB ">",0
$tring_34    DB " > ",0
$tring_35    DB "=",0
$tring_36    DB " = ",0
$tring_37    DB  0,0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)
$Work4       DB 81 DUP(?)
$Work5       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

Buf$         DB 00,11, 451 DUP(?)
Z$           DB 81 DUP(?)
A$           DB 81 DUP(?)
L_PARSE_A$   DB 81 DUP(?)
L_PARSE_B$   DB 81 DUP(?)
L_PARSE_QUOTE$ DB 81 DUP(?)
L_PARSE_LIN$ DB 81 DUP(?)
L_PARSE_TMP$ DB 81 DUP(?)
Data Ends

End
