;Ŀ
; DEMO65.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:34:54                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;--------------------------------
;Fetch the command line Arguments
;--------------------------------
Push ES     ;Save the PSP Segment
Mov  BX,Seg Data
Mov  DS,BX
Push DS
Push DS
Mov  DI,0
Lea  BX,ES:[81h]
GetCmdLine:
Mov  AL,ES:[BX]
Cmp  AL,13
Je   GotCmdLine
Mov  Command$ [DI],AL
Inc  DI
Inc  BX
Jmp  GetCmdLine
GotCmdLine:
Mov  Command$ [DI],0
Pop  DS
Pop  ES
Cld
Mov  SI,Offset Command$+1
Mov  DI,Offset Command$
Mov  CX,80
Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
Pop  ES             ;Restore PSP Segment
;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;Setup 
;
Call Setup
;
;Elements = LoadFileBuffer Buffer$ Mask$ 1000 
;
Mov  AX,1000
Push AX
Mov  AX,Offset Mask$
Push AX
Mov  AX,Offset Buffer$
Push AX
Call LoadFileBuffer
Mov  AX,NumFunc 
Mov  Elements,AX
;
;Chosen = ListBox 33 4 Buffer$ 15 Elements 12 
;
Mov  AX,12
Push AX
Mov  AX,Elements
Push AX
Mov  AX,15
Push AX
Mov  AX,Offset Buffer$
Push AX
Mov  AX,4
Push AX
Mov  AX,33
Push AX
Call ListBox
Mov  AX,NumFunc 
Mov  Chosen,AX
;
;ShowResult 
;
Call ShowResult

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




StrCompare Proc Near 
Push AX 
Push DI 
Push SI 
Cld 
StrCmp1: 
Lodsb 
Scasb 
Jne  StrCmp2 
Or   AL,AL 
Jne StrCmp1 
StrCmp2: 
Pop  SI 
Pop  DI 
Pop  AX 
Ret 
StrCompare Endp 




SetAttribute Proc Near 
Push CX 
Mov  CL,4 
Shl  AX,CL 
Pop  BX 
Add  AX,BX 
Mov  $Attr,AX 
Ret 
SetAttribute Endp 


 
 
Frame Proc Near 
Push BP 
Mov  BP,SP 
Xor  AX,AX
Mov  $Var2,AX 
Mov  $Var3,AX 
Mov  $Var4,AX 
Mov  DI,Offset $Work3 
Call Nullstr 
Mov  AX,[BP][8] 
Sub  AX,[BP][4] 
Dec  AX 
Mov  $Var2,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $Frame2 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame3 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][6] 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Call DoCrLf 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame4 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $pace 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame4 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][6] 
Inc  AX 
Mov  $Var3,AX 
Mov  AX,[BP][10] 
Sub  AX,[BP][6] 
Mov  $Var4,AX 
Mov  AX,$Var4 
Mov  $Var5,AX 
Mov  AX,$Var3 
Dec  AX 
Mov  $Var2,AX 
FrameForLoop_01: 
Mov  AX,1 
Add  $Var2,AX 
Mov  AX,1 
Cmp  AX,0 
Jl   FrameForLoop_01_NegativeStep 
Mov  AX,$Var2 
Cmp  AX,[BP][10] 
Jle  FrameForLoop_01_OK 
Jmp  FrameForLoop_01A 
FrameForLoop_01_NegativeStep: 
Mov  AX,$Var4 
Cmp  AX,$Var2 
Jle  FrameForLoop_01_OK 
Jmp  FrameForLoop_01A 
FrameForLoop_01_OK: 
Mov  AX,$Var2 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Call DoCrLf 
Jmp  FrameForLoop_01 
FrameForLoop_01A: 
Mov  AX,[BP][8] 
Sub  AX,[BP][4] 
Dec  AX 
Mov  $Var2,AX 
Mov  DI,Offset $Work0 
Call Nullstr 
Mov  SI,Offset $Frame5 
Mov  DI,Offset $Work0 
Call Concat 
Mov  AX,Offset $Frame2 
Push AX 
Mov  AX,$Var2 
Push AX 
Call Repeat$ 
Mov  SI,Offset $Work1 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Frame6 
Mov  DI,Offset $Work0 
Call Concat 
Mov  SI,Offset $Work0 
Mov  DI,Offset $Work3 
Call MoveStr 
Mov  AX,[BP][10] 
Mov  $Ycur,AX 
Mov  AX,[BP][4] 
Mov  $Xcur,AX 
Mov  SI,Offset $Work3 
Call PrintStr 
Call SetCursor 
Pop  BP 
Ret  08 
Frame Endp 
 
 


FindFirst Proc Near
Push CX
Push SI
Mov  CX,13
Xor  AX,AX
Mov  DI,Offset $Work1
Rep  Stosb
Mov  DX,Offset $Dta
Mov  Ah,1Ah                 ;set dta
Int  21h
Pop  DX                     ;get the file mask 
Pop  CX                     ;file search attributes
Mov  AH,4Eh                 ;find first function
Int  21h 
Call TrapError 
Mov  CX,12                  ;move this many chars 
Mov  SI,Offset $Dta+30      ;from here 
Mov  DI,Offset $Work1       ;to here 
Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
Mov  CX,12
Xor  AX,AX
Mov  DI,Offset $Dta+30
Rep  Stosb                  ;null out the filename area of the dta
Ret
FindFirst Endp




FindNext Proc Near
Mov  CX,13
Xor  AX,AX
Mov  DI,Offset $Work1
Rep  Stosb
Mov  AH,4Fh                 ;find next function 
Int  21h 
Call TrapError 
Mov  CX,12                  ;move this many chars 
Mov  SI,Offset $Dta+30      ;from here 
Mov  DI,Offset $Work1       ;to here 
Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
Mov  CX,12
Xor  AX,AX
Mov  DI,Offset $Dta+30
Rep  Stosb                 ;null out the filename area of the dta
Ret
FindNext Endp




Repeat$ Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,Offset $Work1 
Call Nullstr 
Mov  CX,[BP][4] 
RepeatLoop: 
Mov  SI,[BP][6] 
Mov  DI,Offset $Work1 
Call Concat 
Loop RepeatLoop 
Pop  BP 
Ret  04 
Repeat$ Endp 




Getkey Proc Near 
Xor  AX,AX 
Int  16h 
Cmp  AL,0 
Je   ExtendedKey 
Xor  AH,AH 
Jmp  RegularKey 
ExtendedKey: 
Mov  AL,AH 
Xor  AH,AH 
Neg  AX 
RegularKey: 
Ret 
GetKey Endp 




TrapError Proc Near 
Jnc  NoError 
Mov  Err,AX
NoError: 
Ret
TrapError Endp 




Space$ Proc Near 
;
; AX=number of spaces to a mAX of the $String Directive 
; DI=address of receiving String 
;
Mov  CX,AX 
Mov  AL,32 
Cmp  CX, 81 
Jg   Space_Quit 
Jcxz SpaceDone 
Space_loop: 
Dec  CX 
Mov  [DI],AL 
Inc  DI 
Jcxz SpaceDone 
Jmp  Space_Loop 
SpaceDone:
Mov  [DI],Byte Ptr 0 
Space_Quit: 
Ret 
Space$ Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 




ArrayPut Proc Near 
Push BP 
Mov  BP,SP 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  DI,[BP][04] 
Add  DI,AX 
Inc  DI 
Inc  DI 
Push DI 
Call NullStr 
Pop  DI 
Mov  SI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayPut Endp 




ArrayGet Proc Near 
Push BP 
Mov  BP,SP 
Mov  DI,[BP][08] 
Call NullStr 
Mov  BX,[BP][04] 
Mov  AH,[BX] 
Mov  AL,[BX][01] 
Mov  BX,[BP][06] 
Mul  BX 
Mov  BX,[BP][04] 
Mov  CH,[BX] 
Mov  CL,[BX+1] 
Sub  AX,CX 
Mov  SI,[BP][04] 
Add  SI,AX 
Inc  SI 
Inc  SI 
Mov  DI,[BP][08] 
Call MoveStr 
Pop  BP 
Ret  06 
ArrayGet Endp 




Listbox Proc Near
Push BP
Mov  BP,SP
;
;LOCAL Tmp$ 
;
Mov  DI,Offset L_LISTBOX_TMP$
Call Nullstr
;
;LOCAL TheTop 
;
Mov  L_LISTBOX_THETOP,0
;
;LOCAL TheBottom 
;
Mov  L_LISTBOX_THEBOTTOM,0
;
;LOCAL Rows 
;
Mov  L_LISTBOX_ROWS,0
;
;LOCAL CurX 
;
Mov  L_LISTBOX_CURX,0
;
;LOCAL CurY 
;
Mov  L_LISTBOX_CURY,0
;
;LOCAL Index 
;
Mov  L_LISTBOX_INDEX,0
;
;LOCAL Ylimit 
;
Mov  L_LISTBOX_YLIMIT,0
;
;LOCAL Ypos 
;
Mov  L_LISTBOX_YPOS,0
;
;LOCAL XX 
;
Mov  L_LISTBOX_XX,0
;
;LOCAL YY 
;
Mov  L_LISTBOX_YY,0
;
;LOCAL Tmp 
;
Mov  L_LISTBOX_TMP,0
;
;LOCAL Z 
;
Mov  L_LISTBOX_Z,0
;
;LOCAL Count 
;
Mov  L_LISTBOX_COUNT,0
;
;LOCAL RX 
;
Mov  L_LISTBOX_RX,0
;
;LOCAL RY 
;
Mov  L_LISTBOX_RY,0
;
;LOCAL ShowRows 
;
Mov  L_LISTBOX_SHOWROWS,0
;
;IF WinSize > Elements THEN 
;
Mov  AX,[BP][10]
Cmp  AX,[BP][12]
Jg   Listbox_True_01
Jmp  Listbox_EndIf_01
Listbox_True_01:
;
;ShowRows = Elements 
;
Xor  AX,AX
Add  AX,[BP][12]
Mov  L_LISTBOX_SHOWROWS,AX
;
;Else 
;
Jmp Listbox_EndIf_01A
Listbox_EndIf_01:
;
;ShowRows = WinSize 
;
Xor  AX,AX
Add  AX,[BP][10]
Mov  L_LISTBOX_SHOWROWS,AX
;
;END IF 
;
Listbox_EndIf_01A:
;
;XX = X + 1 
;
Xor  AX,AX
Add  AX,[BP][04]
Add  AX,1
Mov  L_LISTBOX_XX,AX
;
;YY = Y + 1 
;
Xor  AX,AX
Add  AX,[BP][06]
Add  AX,1
Mov  L_LISTBOX_YY,AX
;
;TheTop = YY 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YY
Mov  L_LISTBOX_THETOP,AX
;
;TheBottom = YY + ShowRows -1 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YY
Add  AX,L_LISTBOX_ShowRows
Add  AX,-1
Mov  L_LISTBOX_THEBOTTOM,AX
;
;CurX = XX 
;
Xor  AX,AX
Add  AX,L_LISTBOX_XX
Mov  L_LISTBOX_CURX,AX
;
;CurY = YY 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YY
Mov  L_LISTBOX_CURY,AX
;
;Index = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_LISTBOX_INDEX,AX
;
;Ylimit = ShowRows + YY -1 
;
Xor  AX,AX
Add  AX,L_LISTBOX_SHOWROWS
Add  AX,L_LISTBOX_YY
Add  AX,-1
Mov  L_LISTBOX_YLIMIT,AX
;
;Rows = TheBottom - TheTop + 1 
;
Xor  AX,AX
Add  AX,L_LISTBOX_THEBOTTOM
Sub  AX,L_LISTBOX_TheTop
Add  AX,1
Mov  L_LISTBOX_ROWS,AX
;
;COLOR 0 7 
;
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;RX = X + Width + 1 
;
Xor  AX,AX
Add  AX,[BP][04]
Add  AX,[BP][14]
Add  AX,1
Mov  L_LISTBOX_RX,AX
;
;RY = Y + ShowRows + 1 
;
Xor  AX,AX
Add  AX,[BP][06]
Add  AX,L_LISTBOX_ShowRows
Add  AX,1
Mov  L_LISTBOX_RY,AX
;
;FRAME X Y RX RY 
;
Mov  AX,L_LISTBOX_RY
Push AX
Mov  AX,L_LISTBOX_RX
Push AX
Mov  AX,[BP][06]
Push AX
Mov  AX,[BP][04]
Push AX
Call Frame
;
;DO 
;
ListboxDoLoop_01:
;
;GOSUB MoveCursor 
;
Call MoveCursor
;
;Keypress = GetKey 
;
Xor  AX,AX
Mov  $Var0,AX
Call GetKey
Add  AX,$Var0
Mov  KEYPRESS,AX
;
;IF Keypress = 13 THEN
;
Cmp  KEYPRESS,13
Je   Listbox_True_02
Jmp  Listbox_EndIf_02
Listbox_True_02:
;
;ListBox = Index 
;
Xor  AX,AX
Add  AX,L_LISTBOX_INDEX
Mov  NUMFUNC,AX
Pop  BP
Ret  12
;
;END IF
;
Listbox_EndIf_02:
;
;IF Keypress = -81 THEN
;
Cmp  KEYPRESS,-81
Je   Listbox_True_03
Jmp  Listbox_EndIf_03
Listbox_True_03:
;
;FOR Z = 1 TO ShowRows 
;
Mov  AX,1
Sub  AX,1
Mov  L_LISTBOX_Z,AX
ListboxForLoop_01:
Mov  AX,1
Add  L_LISTBOX_Z,AX
Mov  AX,1
Cmp  AX,0
Jl   ListboxForLoop_01_NegativeStep
Mov  AX,L_LISTBOX_Z
Cmp  AX,L_LISTBOX_SHOWROWS       ;Ascending Step
Jle ListboxForLoop_01Okay
Jmp ListboxForLoop_01A
ListboxForLoop_01_NegativeStep:
Mov  AX,L_LISTBOX_SHOWROWS
Cmp  AX,L_LISTBOX_Z       ;Descending Step
Jle ListboxForLoop_01Okay
Jmp ListboxForLoop_01A
ListboxForLoop_01Okay:
;
;INCR Index 
;
Inc  L_LISTBOX_INDEX
;
;IF Index > Elements THEN 
;
Mov  AX,L_LISTBOX_INDEX
Cmp  AX,[BP][12]
Jg   Listbox_True_04
Jmp  Listbox_EndIf_04
Listbox_True_04:
;
;Index = Elements 
;
Xor  AX,AX
Add  AX,[BP][12]
Mov  L_LISTBOX_INDEX,AX
;
;END IF 
;
Listbox_EndIf_04:
;
;INCR CurY 
;
Inc  L_LISTBOX_CURY
;
;IF CurY > Ylimit THEN 
;
Mov  AX,L_LISTBOX_CURY
Cmp  AX,L_LISTBOX_YLIMIT
Jg   Listbox_True_05
Jmp  Listbox_EndIf_05
Listbox_True_05:
;
;CurY = Ylimit 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YLIMIT
Mov  L_LISTBOX_CURY,AX
;
;END IF 
;
Listbox_EndIf_05:
;
;NEXT 
;
Jmp ListboxForLoop_01
ListboxForLoop_01A:
;
;END IF
;
Listbox_EndIf_03:
;
;IF Keypress = -73 THEN
;
Cmp  KEYPRESS,-73
Je   Listbox_True_06
Jmp  Listbox_EndIf_06
Listbox_True_06:
;
;FOR Z = 1 TO ShowRows 
;
Mov  AX,1
Sub  AX,1
Mov  L_LISTBOX_Z,AX
ListboxForLoop_02:
Mov  AX,1
Add  L_LISTBOX_Z,AX
Mov  AX,1
Cmp  AX,0
Jl   ListboxForLoop_02_NegativeStep
Mov  AX,L_LISTBOX_Z
Cmp  AX,L_LISTBOX_SHOWROWS       ;Ascending Step
Jle ListboxForLoop_02Okay
Jmp ListboxForLoop_02A
ListboxForLoop_02_NegativeStep:
Mov  AX,L_LISTBOX_SHOWROWS
Cmp  AX,L_LISTBOX_Z       ;Descending Step
Jle ListboxForLoop_02Okay
Jmp ListboxForLoop_02A
ListboxForLoop_02Okay:
;
;DECR Index 
;
Dec  L_LISTBOX_INDEX
;
;IF Index < 1 THEN 
;
Cmp  L_LISTBOX_INDEX,1
Jl   Listbox_True_07
Jmp  Listbox_EndIf_07
Listbox_True_07:
;
;Index = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_LISTBOX_INDEX,AX
;
;END IF 
;
Listbox_EndIf_07:
;
;DECR CurY 
;
Dec  L_LISTBOX_CURY
;
;IF CurY < YY THEN 
;
Mov  AX,L_LISTBOX_CURY
Cmp  AX,L_LISTBOX_YY
Jl   Listbox_True_08
Jmp  Listbox_EndIf_08
Listbox_True_08:
;
;CurY = YY 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YY
Mov  L_LISTBOX_CURY,AX
;
;END IF 
;
Listbox_EndIf_08:
;
;IF Index > = ShowRows THEN 
;
Mov  AX,L_LISTBOX_INDEX
Cmp  AX,L_LISTBOX_SHOWROWS
Jge  Listbox_True_09
Jmp  Listbox_EndIf_09
Listbox_True_09:
;
;INCR CurY 
;
Inc  L_LISTBOX_CURY
;
;END IF 
;
Listbox_EndIf_09:
;
;NEXT 
;
Jmp ListboxForLoop_02
ListboxForLoop_02A:
;
;END IF
;
Listbox_EndIf_06:
;
;IF Keypress = -72 THEN
;
Cmp  KEYPRESS,-72
Je   Listbox_True_10
Jmp  Listbox_EndIf_10
Listbox_True_10:
;
;DECR Index 
;
Dec  L_LISTBOX_INDEX
;
;IF Index < 1 THEN 
;
Cmp  L_LISTBOX_INDEX,1
Jl   Listbox_True_11
Jmp  Listbox_EndIf_11
Listbox_True_11:
;
;Index = 1 
;
Xor  AX,AX
Add  AX,1
Mov  L_LISTBOX_INDEX,AX
;
;END IF 
;
Listbox_EndIf_11:
;
;DECR CurY 
;
Dec  L_LISTBOX_CURY
;
;IF CurY < YY THEN 
;
Mov  AX,L_LISTBOX_CURY
Cmp  AX,L_LISTBOX_YY
Jl   Listbox_True_12
Jmp  Listbox_EndIf_12
Listbox_True_12:
;
;CurY = YY 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YY
Mov  L_LISTBOX_CURY,AX
;
;END IF 
;
Listbox_EndIf_12:
;
;IF Index > = ShowRows THEN 
;
Mov  AX,L_LISTBOX_INDEX
Cmp  AX,L_LISTBOX_SHOWROWS
Jge  Listbox_True_13
Jmp  Listbox_EndIf_13
Listbox_True_13:
;
;INCR CurY 
;
Inc  L_LISTBOX_CURY
;
;END IF 
;
Listbox_EndIf_13:
;
;END IF
;
Listbox_EndIf_10:
;
;IF Keypress = -80 THEN
;
Cmp  KEYPRESS,-80
Je   Listbox_True_14
Jmp  Listbox_EndIf_14
Listbox_True_14:
;
;INCR Index 
;
Inc  L_LISTBOX_INDEX
;
;IF Index > Elements THEN 
;
Mov  AX,L_LISTBOX_INDEX
Cmp  AX,[BP][12]
Jg   Listbox_True_15
Jmp  Listbox_EndIf_15
Listbox_True_15:
;
;Index = Elements 
;
Xor  AX,AX
Add  AX,[BP][12]
Mov  L_LISTBOX_INDEX,AX
;
;END IF 
;
Listbox_EndIf_15:
;
;INCR CurY 
;
Inc  L_LISTBOX_CURY
;
;IF CurY > Ylimit THEN 
;
Mov  AX,L_LISTBOX_CURY
Cmp  AX,L_LISTBOX_YLIMIT
Jg   Listbox_True_16
Jmp  Listbox_EndIf_16
Listbox_True_16:
;
;CurY = Ylimit 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YLIMIT
Mov  L_LISTBOX_CURY,AX
;
;END IF 
;
Listbox_EndIf_16:
;
;END IF
;
Listbox_EndIf_14:
;
;LOOP 
;
Jmp ListboxDoLoop_01
ListboxDoLoop_01A:

MoveCursor:
;
;GOSUB RefreshDisplay 
;
Call RefreshDisplay
;
;COLOR 7 0 
;
Mov  AX,7
Mov  $FgColor,AX
Mov  AX,0
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;LOCATE CurY CurX 0 
;
Mov  AX,L_LISTBOX_CurY
Mov  $Ycur,AX
Mov  AX,L_LISTBOX_CurX
Mov  $Xcur,AX
Mov  AX,0
Call ShowHideCursor
;
;Tmp$ = SPACE$ Width 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,[BP][14]
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_LISTBOX_TMP$
Call MoveStr
;
;PRINT Tmp$ 
;
Mov  SI,Offset L_LISTBOX_TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;Tmp$ = A$ Index 
;
Mov  AX,Offset L_LISTBOX_TMP$
Push AX
Mov  AX,L_LISTBOX_INDEX
Push AX
Mov  AX,[BP][08]
Push AX
Call ArrayGet
;
;COLOR 7 0 
;
Mov  AX,7
Mov  $FgColor,AX
Mov  AX,0
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;LOCATE CurY CurX 
;
Mov  AX,L_LISTBOX_CurY
Mov  $Ycur,AX
Mov  AX,L_LISTBOX_CurX
Mov  $Xcur,AX
;
;PRINT Tmp$ 
;
Mov  SI,Offset L_LISTBOX_TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;COLOR 0 7 
;
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;RETURN 
;
Ret

RefreshDisplay:
;
;IF Index < = ShowRows THEN 
;
Mov  AX,L_LISTBOX_INDEX
Cmp  AX,L_LISTBOX_SHOWROWS
Jle  Listbox_True_17
Jmp  Listbox_EndIf_17
Listbox_True_17:
;
;FOR Count = 1 to Rows 
;
Mov  AX,1
Sub  AX,1
Mov  L_LISTBOX_COUNT,AX
ListboxForLoop_03:
Mov  AX,1
Add  L_LISTBOX_COUNT,AX
Mov  AX,1
Cmp  AX,0
Jl   ListboxForLoop_03_NegativeStep
Mov  AX,L_LISTBOX_COUNT
Cmp  AX,L_LISTBOX_ROWS       ;Ascending Step
Jle ListboxForLoop_03Okay
Jmp ListboxForLoop_03A
ListboxForLoop_03_NegativeStep:
Mov  AX,L_LISTBOX_ROWS
Cmp  AX,L_LISTBOX_COUNT       ;Descending Step
Jle ListboxForLoop_03Okay
Jmp ListboxForLoop_03A
ListboxForLoop_03Okay:
;
;Ypos = YY -1 + Count 
;
Xor  AX,AX
Add  AX,L_LISTBOX_YY
Add  AX,-1
Add  AX,L_LISTBOX_Count
Mov  L_LISTBOX_YPOS,AX
;
;Tmp$ = A$ Count 
;
Mov  AX,Offset L_LISTBOX_TMP$
Push AX
Mov  AX,L_LISTBOX_COUNT
Push AX
Mov  AX,[BP][08]
Push AX
Call ArrayGet
;
;Tmp = LEN Tmp$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_LISTBOX_Tmp$
Call Len
Add  AX,$Var0
Mov  L_LISTBOX_TMP,AX
;
;Tmp = Width - Tmp 
;
Xor  AX,AX
Add  AX,[BP][14]
Sub  AX,L_LISTBOX_Tmp
Mov  L_LISTBOX_TMP,AX
;
;Tmp$ = Tmp$ + SPACE$ Tmp 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_LISTBOX_TMP$
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,L_LISTBOX_Tmp
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_LISTBOX_TMP$
Call MoveStr
;
;LOCATE Ypos XX 
;
Mov  AX,L_LISTBOX_Ypos
Mov  $Ycur,AX
Mov  AX,L_LISTBOX_XX
Mov  $Xcur,AX
;
;PRINT Tmp$ 
;
Mov  SI,Offset L_LISTBOX_TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp ListboxForLoop_03
ListboxForLoop_03A:
;
;ELSE 
;
Jmp Listbox_EndIf_17A
Listbox_EndIf_17:
;
;FOR Count = TheTop to TheBottom 
;
Mov  AX,L_LISTBOX_THETOP
Sub  AX,1
Mov  L_LISTBOX_COUNT,AX
ListboxForLoop_04:
Mov  AX,1
Add  L_LISTBOX_COUNT,AX
Mov  AX,1
Cmp  AX,0
Jl   ListboxForLoop_04_NegativeStep
Mov  AX,L_LISTBOX_COUNT
Cmp  AX,L_LISTBOX_THEBOTTOM       ;Ascending Step
Jle ListboxForLoop_04Okay
Jmp ListboxForLoop_04A
ListboxForLoop_04_NegativeStep:
Mov  AX,L_LISTBOX_THEBOTTOM
Cmp  AX,L_LISTBOX_COUNT       ;Descending Step
Jle ListboxForLoop_04Okay
Jmp ListboxForLoop_04A
ListboxForLoop_04Okay:
;
;Tmp = Index - TheTop + Count - ShowRows + 1 
;
Xor  AX,AX
Add  AX,L_LISTBOX_INDEX
Sub  AX,L_LISTBOX_TheTop
Add  AX,L_LISTBOX_Count
Sub  AX,L_LISTBOX_ShowRows
Add  AX,1
Mov  L_LISTBOX_TMP,AX
;
;Tmp$ = A$ Tmp 
;
Mov  AX,Offset L_LISTBOX_TMP$
Push AX
Mov  AX,L_LISTBOX_TMP
Push AX
Mov  AX,[BP][08]
Push AX
Call ArrayGet
;
;Tmp = LEN Tmp$ 
;
Xor  AX,AX
Mov  $Var0,AX
Mov  SI,Offset L_LISTBOX_Tmp$
Call Len
Add  AX,$Var0
Mov  L_LISTBOX_TMP,AX
;
;Tmp = Width - Tmp 
;
Xor  AX,AX
Add  AX,[BP][14]
Sub  AX,L_LISTBOX_Tmp
Mov  L_LISTBOX_TMP,AX
;
;Tmp$ = Tmp$ + SPACE$ Tmp 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,Offset L_LISTBOX_TMP$
Mov  DI,Offset $Work0
Call Concat
Mov  DI,Offset $Work1
Mov  AX,L_LISTBOX_Tmp
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_LISTBOX_TMP$
Call MoveStr
;
;LOCATE Count XX 
;
Mov  AX,L_LISTBOX_Count
Mov  $Ycur,AX
Mov  AX,L_LISTBOX_XX
Mov  $Xcur,AX
;
;PRINT Tmp$ 
;
Mov  SI,Offset L_LISTBOX_TMP$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp ListboxForLoop_04
ListboxForLoop_04A:
;
;END IF 
;
Listbox_EndIf_17A:
;
;RETURN 
;
Ret
Pop  BP
Ret  12
Listbox Endp


Loadfilebuffer Proc Near
Push BP
Mov  BP,SP
;
;LOCAL A$ Count 
;
Mov  DI,Offset L_LOADFILEBUFFER_A$
Call Nullstr
Mov  L_LOADFILEBUFFER_COUNT,0
;
;A$ = DIR$ Mask$ 0 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  SI,[BP][06]
Mov  CX,0
Call FindFirst
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_LOADFILEBUFFER_A$
Call MoveStr
;
;IF Err THEN 
;
Cmp  ERR,0
Jne  Loadfilebuffer_True_18
Jmp  Loadfilebuffer_EndIf_18
Loadfilebuffer_True_18:
;
;COLOR 0 7 
;
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;FRAME 1 1 80 5 
;
Mov  AX,5
Push AX
Mov  AX,80
Push AX
Mov  AX,1
Push AX
Mov  AX,1
Push AX
Call Frame
;
;LOCATE 2 2 
;
Mov  $Ycur,2
Mov  $Xcur,2
;
;PRINT "Usage: FILEBOX  [Drive:] \ [Directory] \ FileName.Ext 
;
Mov  SI,Offset $tring_25
Call PrintStr
Call SetCursor
Call DoCrLf
;
;LOCATE 3 2 
;
Mov  $Ycur,3
Mov  $Xcur,2
;
;PRINT "FileName and Ext must be specified. ( Wildcards are allowed. ) 
;
Mov  SI,Offset $tring_26
Call PrintStr
Call SetCursor
Call DoCrLf
;
;LOCATE 4 2 1 
;
Mov  $Ycur,4
Mov  $Xcur,2
Mov  AX,1
Call ShowHideCursor
;
;PRINT "[Drive] and [directory] are optional. Example: FILEBOX C:\DOS\*.SYS 
;
Mov  SI,Offset $tring_27
Call PrintStr
Call SetCursor
Call DoCrLf
;
;END 
;
Mov  AL,0
Mov  AH,4Ch
Int  21h
;
;END IF 
;
Loadfilebuffer_EndIf_18:
;
;DO
;
LoadfilebufferDoLoop_02:
;
;IF A$ > ""  THEN
;
Mov  SI,Offset L_LOADFILEBUFFER_A$
Mov  DI,Offset $tring_28
Call StrCompare
Jg   Loadfilebuffer_True_19
Jmp  Loadfilebuffer_EndIf_19
Loadfilebuffer_True_19:
;
;INCR Count 
;
Inc  L_LOADFILEBUFFER_COUNT
;
;Buf$ Count = A$ 
;
Mov  AX,Offset L_LOADFILEBUFFER_A$
Push AX
Mov  AX,L_LOADFILEBUFFER_COUNT
Push AX
Mov  AX,[BP][04]
Push AX
Call ArrayPut
;
;A$ = DIR$ 
;
Mov  DI,Offset $Work0
Call NullStr
Call FindNext
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset L_LOADFILEBUFFER_A$
Call MoveStr
;
;IF Count = MaxAllowed THEN 
;
Mov  AX,L_LOADFILEBUFFER_COUNT
Cmp  AX,[BP][08]
Je   Loadfilebuffer_True_20
Jmp  Loadfilebuffer_EndIf_20
Loadfilebuffer_True_20:
;
;EXIT LOOP
;
Jmp LoadfilebufferDoLoop_02A
;
;END IF 
;
Loadfilebuffer_EndIf_20:
;
;ELSE
;
Jmp Loadfilebuffer_EndIf_19A
Loadfilebuffer_EndIf_19:
;
;EXIT LOOP
;
Jmp LoadfilebufferDoLoop_02A
;
;END IF
;
Loadfilebuffer_EndIf_19A:
;
;LOOP
;
Jmp LoadfilebufferDoLoop_02
LoadfilebufferDoLoop_02A:
;
;LoadFileBuffer = Count 
;
Xor  AX,AX
Add  AX,L_LOADFILEBUFFER_COUNT
Mov  NUMFUNC,AX
Pop  BP
Ret  06
Loadfilebuffer Endp


Showresult Proc Near
Push BP
Mov  BP,SP
;
;Result$ = Space$ 78 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,78
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset RESULT$
Call MoveStr
;
;LOCATE 2 2 
;
Mov  $Ycur,2
Mov  $Xcur,2
;
;PRINT Result$ 
;
Mov  SI,Offset RESULT$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;Result$ = Buffer$ Chosen 
;
Mov  AX,Offset RESULT$
Push AX
Mov  AX,CHOSEN
Push AX
Mov  AX,Offset BUFFER$
Push AX
Call ArrayGet
;
;LOCATE 2 3 1 
;
Mov  $Ycur,2
Mov  $Xcur,3
Mov  AX,1
Call ShowHideCursor
;
;PRINT "You selected " Result$ 
;
Mov  SI,Offset $tring_30
Call PrintStr
Call SetCursor
Mov  SI,Offset RESULT$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;Result$ = Space$ 80 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,80
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset RESULT$
Call MoveStr
;
;COLOR 7 0 
;
Mov  AX,7
Mov  $FgColor,AX
Mov  AX,0
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;LOCATE 4 1 0 
;
Mov  $Ycur,4
Mov  $Xcur,1
Mov  AX,0
Call ShowHideCursor
;
;FOR A = 4 TO 23 
;
Mov  AX,4
Sub  AX,1
Mov  A,AX
ShowresultForLoop_05:
Mov  AX,1
Add  A,AX
Mov  AX,1
Cmp  AX,0
Jl   ShowresultForLoop_05_NegativeStep
Mov  AX,A
Cmp  AX,23       ;Ascending Step
Jle ShowresultForLoop_05Okay
Jmp ShowresultForLoop_05A
ShowresultForLoop_05_NegativeStep:
Mov  AX,23
Cmp  AX,A       ;Descending Step
Jle ShowresultForLoop_05Okay
Jmp ShowresultForLoop_05A
ShowresultForLoop_05Okay:
;
;PRINT Result$ 
;
Mov  SI,Offset RESULT$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;NEXT 
;
Jmp ShowresultForLoop_05
ShowresultForLoop_05A:
;
;LOCATE 3 3 1 
;
Mov  $Ycur,3
Mov  $Xcur,3
Mov  AX,1
Call ShowHideCursor
;
;Print  ;
;
Call SetCursor
Pop  BP
Ret  00
Showresult Endp


Setup Proc Near
Push BP
Mov  BP,SP
Call Cls
;
;Mask$ = Command$ 
;
Mov  SI,Offset Command$
Mov  DI,Offset Mask$
Call MoveStr
;
;IF Mask$ = "" THEN 
;
Mov  SI,Offset MASK$
Mov  DI,Offset $tring_33
Call StrCompare
Je   Setup_True_21
Jmp  Setup_EndIf_21
Setup_True_21:
;
;Mask$ = "*.*" 
;
Mov  SI,Offset $tring_34
Mov  DI,Offset Mask$
Call MoveStr
;
;END IF 
;
Setup_EndIf_21:
;
;COLOR 0 7 
;
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
;
;LOCATE 1 1 0 
;
Mov  $Ycur,1
Mov  $Xcur,1
Mov  AX,0
Call ShowHideCursor
Pop  BP
Ret  00
Setup Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$pace        DB 32,0 
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0
$Frame1      DB 213,0
$Frame2      DB 205,0
$Frame3      DB 184,0
$Frame4      DB 179,0
$Frame5      DB 212,0
$Frame6      DB 190,0
Command$     DB 81 DUP(0)

;__________________Users Initialized Data____________________

ELEMENTS     DW  0
CHOSEN       DW  0
NUMFUNC      DW  0
L_LISTBOX_THETOP DW  0
L_LISTBOX_THEBOTTOM DW  0
L_LISTBOX_ROWS DW  0
L_LISTBOX_CURX DW  0
L_LISTBOX_CURY DW  0
L_LISTBOX_INDEX DW  0
L_LISTBOX_YLIMIT DW  0
L_LISTBOX_YPOS DW  0
L_LISTBOX_XX DW  0
L_LISTBOX_YY DW  0
L_LISTBOX_TMP DW  0
L_LISTBOX_Z  DW  0
L_LISTBOX_COUNT DW  0
L_LISTBOX_RX DW  0
L_LISTBOX_RY DW  0
L_LISTBOX_SHOWROWS DW  0
KEYPRESS     DW  0
L_LOADFILEBUFFER_COUNT DW  0
$tring_25    DB "Usage: FILEBOX  [Drive:] \ [Directory] \ FileName.Ext",0
$tring_26    DB "FileName and Ext must be specified. ( Wildcards are allowed. )",0
$tring_27    DB "[Drive] and [directory] are optional. Example: FILEBOX C:\DOS\*.SYS",0
$tring_28    DB  0,0
$tring_30    DB "You selected ",0
A            DW  0
$tring_33    DB  0,0
$tring_34    DB "*.*",0

;_________________System Un-Initialized Data_________________

$Dta         DB 43 Dup(?)
$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)
$Work2       DB 81 DUP(?)
$Work3       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

Buffer$      DB 00,13, 13013 DUP(?)
L_LISTBOX_TMP$ DB 81 DUP(?)
L_LOADFILEBUFFER_A$ DB 81 DUP(?)
RESULT$      DB 81 DUP(?)
MASK$        DB 81 DUP(?)
Data Ends

End
