;Ŀ
; DEMO66.ASM   [ Created using BASM Version 1.00 by Kevin Diggins ]  
; Creation Date: 01-02-1995                                          
; Creation Time: 22:36:32                                            
;

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stack Segment Word Stack
DW  128 DUP (?)
Stack Ends

Dummy Segment Para Public
Dummy Ends

Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stack

;-------------------------------------------
;Release the unused memory allocated by DOS
;-------------------------------------------
Mov  BX,Seg Data
Mov  DS,BX                  ;setup data addressibility
Mov  BX,Seg Dummy           ;get the end of this program
Mov  AX,CS                  ;get the start of this program
Sub  BX,AX                  ;calc the difference
Add  BX,17                  ;Number of paragraphs in Stack + 1
Mov  AH,4AH                 ;Release the unused memory
Int  21h                    ;DOS does it for us
Push DS                     ;
Pop  ES                     ;Make the Extra Seg equal the Data Seg
;--------------------------------------------------------------------
Call GetCursor              ;locate the cursor coordinates
;--------------------------------------------------------------------
;                           ;Users program code begins here
;--------------------------------------------------------------------
;
;X = POS 
;
Xor  AX,AX
Mov  $Var0,AX
Call GetCursor
Mov  AX,$Xcur
Add  AX,$Var0
Mov  X,AX
;
;Y = CSRLIN 
;
Xor  AX,AX
Mov  $Var0,AX
Call GetCursor
Mov  AX,$Ycur
Add  AX,$Var0
Mov  Y,AX
;
;GETSCREEN DosScreen$ 
;
Call GetScreen
Mov  SI,Offset $ScrnBuf 
Mov  DI,Offset DOSSCREEN$
Call MoveStr
;
;ReFrame 
;
Call ReFrame
;
;ScrnNum = 1 
;
Xor  AX,AX
Add  AX,1
Mov  SCRNNUM,AX
;
;Display1 
;
Call Display1
;
;DO 
;
DoLoop_01:
;
;Keypress = GETKEY 
;
Xor  AX,AX
Mov  $Var0,AX
Call GetKey
Add  AX,$Var0
Mov  KEYPRESS,AX
;
;IF KeyPress = -80 THEN
;
Cmp  KEYPRESS,-80
Je   _True_01
Jmp  _EndIf_01
_True_01:
;
;INCR ScrnNum 
;
Inc  SCRNNUM
;
;IF ScrnNum > 3 THEN 
;
Cmp  SCRNNUM,3
Jg   _True_02
Jmp  _EndIf_02
_True_02:
;
;DECR ScrnNum 
;
Dec  SCRNNUM
;
;END IF 
;
_EndIf_02:
;
;END IF
;
_EndIf_01:
;
;IF KeyPress = -72 THEN
;
Cmp  KEYPRESS,-72
Je   _True_03
Jmp  _EndIf_03
_True_03:
;
;DECR ScrnNum 
;
Dec  SCRNNUM
;
;IF ScrnNum < 1 THEN 
;
Cmp  SCRNNUM,1
Jl   _True_04
Jmp  _EndIf_04
_True_04:
;
;INCR ScrnNum 
;
Inc  SCRNNUM
;
;END IF 
;
_EndIf_04:
;
;END IF
;
_EndIf_03:
;
;IF KeyPress = 27 THEN
;
Cmp  KEYPRESS,27
Je   _True_05
Jmp  _EndIf_05
_True_05:
;
;PUTSCREEN DosScreen$ 
;
Mov  SI,Offset DOSSCREEN$
Call PutScreen
;
;LOCATE Y X 1 
;
Mov  AX,Y
Mov  $Ycur,AX
Mov  AX,X
Mov  $Xcur,AX
Mov  AX,1
Call ShowHideCursor
;
;PRINT ""  ;
;
Mov  SI,Offset $tring_06
Call PrintStr
Call SetCursor
;
;END 
;
Mov  AL,0
Mov  AH,4Ch
Int  21h
;
;END IF
;
_EndIf_05:
;
;IF ScrnNum = 1 THEN
;
Cmp  SCRNNUM,1
Je   _True_06
Jmp  _EndIf_06
_True_06:
;
;Display1 
;
Call Display1
;
;END IF
;
_EndIf_06:
;
;IF ScrnNum = 2 THEN
;
Cmp  SCRNNUM,2
Je   _True_07
Jmp  _EndIf_07
_True_07:
;
;Display2 
;
Call Display2
;
;END IF
;
_EndIf_07:
;
;IF ScrnNum = 3 THEN
;
Cmp  SCRNNUM,3
Je   _True_08
Jmp  _EndIf_08
_True_08:
;
;Display3 
;
Call Display3
;
;END IF
;
_EndIf_08:
;
;LOOP 
;
Jmp DoLoop_01
DoLoop_01A:

ExitToDos:

Mov  AH,4Ch
Xor  AL,AL
Int  21h




GetCursor Proc Near 
Mov  AH,3 
Xor  BH,BH 
Int  10h 
Xor  AX,AX 
Mov  AL,DL 
Inc  AL 
Mov  $Xcur,AX 
Mov  AL,DH 
Inc  AL 
Mov  $Ycur,AX 
Ret
GetCursor Endp 




SetCursor Proc Near
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX
Mov  AH,2
Int  10h
Ret
SetCursor Endp




MoveStr Proc Near 
MoveStrLoop: 
Mov  al,[SI] 
Mov  [DI],al 
Or   al,al 
Jz   MoveStrDone 
Inc  SI 
Inc  DI 
Jmp  MoveStrLoop 
MoveStrDone: 
Ret 
MoveStr Endp 




NullStr Proc Near 
Xor  AX,AX 
Mov  [DI],al
Ret 
NullStr Endp 




Len Proc Near 
Push CX 
Push SI 
Push DI 
Mov  DI,SI 
Xor  AL,AL 
Mov  CX,0ffffh 
Cld 
Repnz Scasb 
Not  CX 
Dec  CX 
Mov  AX,CX 
Pop  DI 
Pop  SI 
Pop  CX 
Ret 
Len Endp 




Concat Proc Near 
Push CX 
Push DI 
Push SI 
Push SI 
Push DI 
Pop  SI 
Call Len 
Mov  BX,AX 
Pop  SI 
Call Len 
Mov  CX,AX 
Inc  CX 
Pop  SI 
Pop  DI 
Add  DI,BX 
Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI] 
Pop  CX 
Ret 
Concat Endp 




SetAttribute Proc Near 
Push CX 
Mov  CL,4 
Shl  AX,CL 
Pop  BX 
Add  AX,BX 
Mov  $Attr,AX 
Ret 
SetAttribute Endp 


 
 
VideoCard Proc Near 
Mov  AH,0FH 
Int  10H 
And  AL,0FFH 
Cmp  AL,7 
Je   VC_Mono 
Mov  AX,0B800H 
Jmp  VC_Exit 
VC_Mono: 
Mov  AX,0B000H 
VC_Exit: 
Ret 
VideoCard Endp 
 
 


Getkey Proc Near 
Xor  AX,AX 
Int  16h 
Cmp  AL,0 
Je   ExtendedKey 
Xor  AH,AH 
Jmp  RegularKey 
ExtendedKey: 
Mov  AL,AH 
Xor  AH,AH 
Neg  AX 
RegularKey: 
Ret 
GetKey Endp 




Space$ Proc Near 
;
; AX=number of spaces to a mAX of the $String Directive 
; DI=address of receiving String 
;
Mov  CX,AX 
Mov  AL,32 
Cmp  CX, 81 
Jg   Space_Quit 
Jcxz SpaceDone 
Space_loop: 
Dec  CX 
Mov  [DI],AL 
Inc  DI 
Jcxz SpaceDone 
Jmp  Space_Loop 
SpaceDone:
Mov  [DI],Byte Ptr 0 
Space_Quit: 
Ret 
Space$ Endp 




Cls Proc Near 
Mov   AH,06
Xor   AL,AL
Mov   BX,$Attr
Mov   BH,BL
Xor   CX,CX 
Mov   DH,24
Mov   DL,79
Int   10h
Xor   BX,BX 
Xor   DX,DX 
Mov   AH,02
Int   10h
Mov   $Xcur,1
Mov   $Ycur,1
Ret
Cls   Endp 




PrintStr Proc Near
;SI = Address of String
Push SI 
Call Len 
Mov  CX,AX 
Cmp  CX,0
Jle  No_String 
Mov  BX,$Attr
Mov  AX,$Ycur
Mov  DI,$Xcur
Push DS
Push ES
Dec  AX
Dec  DI
Cmp  DI,0
Jg   DI_OK
Xor  DI,DI
DI_OK:
Mov  DX,0050H
Mul  DX
Add  DI,AX
Shl  DI,1
Mov  AX,0B000H
Mov  ES,AX
Mov  AH,0FH
Int  10H
Cmp  AL,07H
Je   MoveVideoBytes
Mov  AX,0B800H
Mov  ES,AX
MoveVideoBytes:
Cld
Movsb
Mov  ES:[DI],BL
Inc  DI
Loop MoveVideoBytes
Pop  ES
Pop  DS
No_String:
Pop  SI 
Call Len 
Add  $Xcur,AX 
Ret
PrintStr Endp




DoCrLf Proc Near 
Mov  $Xcur,1 
Inc  $Ycur 
Cmp  $Ycur,26 
Jne  NormalCrLf 
Dec  $Ycur 
NormalCrLf: 
Mov  DX,Offset $CrLf 
Mov  AH,9 
Int  21h 
Mov  BX,$Xcur
Mov  DL,BL
Dec  DL
Mov  BX,$Ycur
Mov  DH,BL
Dec  DH
Xor  BX,BX 
Mov  AH,2
Int  10h
Ret 
DoCrLf Endp 




ShowHideCursor Proc Near 
Cmp  AX,0 
Je   HideTheCursor 
Mov  CL,13 
Mov  CH,12 
Mov  AH,01 
Int  10h 
Jmp  ShowHideQuit 
HideTheCursor: 
Mov  CL,0 
Mov  CH,1 
Mov  AH,1 
Int  10h 
ShowHideQuit: 
Ret 
ShowHideCursor Endp 




GetScreen Proc Near 
Push ES 
Push DS 
Push DS 
Pop  ES 
Call VideoCard 
Push AX 
Pop  DS 
Mov  SI,0 
Mov  DI,Offset $ScrnBuf 
Mov  CX,2000 
Cld 
Rep  Movs Word Ptr [DI],[SI] 
Pop  DS 
Pop  ES 
Ret 
GetScreen Endp 




PutScreen Proc Near 
Push DS 
Push ES 
Call VideoCard
Mov ES,AX
Mov DI,0 
Mov CX,2000 
Cld
Rep Movs Word Ptr [DI],[SI] 
Pop ES 
Pop DS
Ret 
PutScreen Endp 




Say Proc Near
Push BP
Mov  BP,SP
;
;LOCATE Y 2 0 
;
Mov  AX,[BP][06]
Mov  $Ycur,AX
Mov  $Xcur,2
Mov  AX,0
Call ShowHideCursor
;
;B$ = SPACE$ 78 
;
Mov  DI,Offset $Work0
Call Nullstr
Mov  DI,Offset $Work1
Mov  AX,78
Call Space$
Mov  SI,Offset $Work1
Mov  DI,Offset $Work0
Call Concat
Mov  SI,Offset $Work0
Mov  DI,Offset B$
Call MoveStr
;
;PRINT B$ 
;
Mov  SI,Offset B$
Call PrintStr
Call SetCursor
Call DoCrLf
;
;LOCATE Y X 
;
Mov  AX,[BP][06]
Mov  $Ycur,AX
Mov  AX,[BP][04]
Mov  $Xcur,AX
;
;PRINT A$ 
;
Mov  SI,[BP][08]
Call PrintStr
Call SetCursor
Call DoCrLf
Pop  BP
Ret  06
Say Endp


Display1 Proc Near
Push BP
Mov  BP,SP
;
;ReFrame 
;
Call ReFrame
;
;say 2 04 "            Ŀ 
;
Mov  AX,Offset $tring_08
Push AX
Mov  AX,04
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 05 "Ĵ BASM ... The BASIC to Assembly Language Translator Ŀ 
;
Mov  AX,Offset $tring_09
Push AX
Mov  AX,05
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 06 "                       
;
Mov  AX,Offset $tring_10
Push AX
Mov  AX,06
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 07 "                                                                             
;
Mov  AX,Offset $tring_11
Push AX
Mov  AX,07
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 08 " BASM is intended for anyone wishing to convert a BASIC program to an 8088   
;
Mov  AX,Offset $tring_12
Push AX
Mov  AX,08
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 09 " assembly language program.  BASM may be freely used and distributed, but I  
;
Mov  AX,Offset $tring_13
Push AX
Mov  AX,09
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 10 " reserve all rights to BASM.  Dependent upon the interest and response that  
;
Mov  AX,Offset $tring_14
Push AX
Mov  AX,10
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 11 " I receive, BASM may be enhanced in the future.  PowerBASIC 3.0 was used to  
;
Mov  AX,Offset $tring_15
Push AX
Mov  AX,11
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 12 " create BASM.  Those interested in the BASM source code may contact me at:   
;
Mov  AX,Offset $tring_16
Push AX
Mov  AX,12
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 13 "                                                                             
;
Mov  AX,Offset $tring_11   
Push AX
Mov  AX,13
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 14 "                             Kevin Diggins                                   
;
Mov  AX,Offset $tring_17
Push AX
Mov  AX,14
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 15 "                        10707 E. Quarterline Rd.                             
;
Mov  AX,Offset $tring_18
Push AX
Mov  AX,15
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 16 "                       Apache Junction, AZ  85220                            
;
Mov  AX,Offset $tring_19
Push AX
Mov  AX,16
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 17 "                            (602) 986-8777                                   
;
Mov  AX,Offset $tring_20
Push AX
Mov  AX,17
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 18 "                        ( weekends only please )                             
;
Mov  AX,Offset $tring_21
Push AX
Mov  AX,18
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 19 "                                                                             
;
Mov  AX,Offset $tring_11   
Push AX
Mov  AX,19
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 20 " Disclaimer:  The user accepts all risk and responsibility for any damages   
;
Mov  AX,Offset $tring_22
Push AX
Mov  AX,20
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 21 "              resulting directly or indirectly from the use of this utility  
;
Mov  AX,Offset $tring_23
Push AX
Mov  AX,21
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 22 "              and/or the code it creates.                                    
;
Mov  AX,Offset $tring_24
Push AX
Mov  AX,22
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 23 "                                                                             
;
Mov  AX,Offset $tring_11   
Push AX
Mov  AX,23
Push AX
Mov  AX,2
Push AX
Call say
;
;say 2 24 " 
;
Mov  AX,Offset $tring_25
Push AX
Mov  AX,24
Push AX
Mov  AX,2
Push AX
Call say
Pop  BP
Ret  00
Display1 Endp


Display2 Proc Near
Push BP
Mov  BP,SP
;
;ReFrame 
;
Call ReFrame
;
;Say 13 05 "BASM supports the following statements and functions:" 
;
Mov  AX,Offset $tring_26
Push AX
Mov  AX,05
Push AX
Mov  AX,13
Push AX
Call Say
;
;Say 07 07 "DIR$        HEX$         OPEN           CLS            REPLACE" 
;
Mov  AX,Offset $tring_27
Push AX
Mov  AX,07
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 08 "SHELL       ASC          CLOSE          PRINT          SWAP" 
;
Mov  AX,Offset $tring_28
Push AX
Mov  AX,08
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 09 "TIME$       ABS          KILL           INPUT          DELAY" 
;
Mov  AX,Offset $tring_29
Push AX
Mov  AX,09
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 10 "DATE$       BIN2DEC      CHDIR          POS            ASM" 
;
Mov  AX,Offset $tring_30
Push AX
Mov  AX,10
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 11 "COMMAND$    GETKEY       MKDIR          CSRLIN         BEEP" 
;
Mov  AX,Offset $tring_31
Push AX
Mov  AX,11
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 12 "CURDIR$     INSTR        RMDIR          LOCATE         DIM" 
;
Mov  AX,Offset $tring_32
Push AX
Mov  AX,12
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 13 "UCASE$      VAL          NAME           COLOR          ARRAY SORT" 
;
Mov  AX,Offset $tring_33
Push AX
Mov  AX,13
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 14 "LCASE$      LEN          PRINT#         FRAME          ARRAY INSERT" 
;
Mov  AX,Offset $tring_34
Push AX
Mov  AX,14
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 15 "MID$        SGN          INPUT#         GETSCREEN      ARRAY DELETE" 
;
Mov  AX,Offset $tring_35
Push AX
Mov  AX,15
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 16 "TRIM$       EOF          LINE INPUT#    PUTSCREEN      SCAN" 
;
Mov  AX,Offset $tring_36
Push AX
Mov  AX,16
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 17 "LTRIM$      ERR          EOF            CHANGEATTR     MOD" 
;
Mov  AX,Offset $tring_37
Push AX
Mov  AX,17
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 18 "RTRIM$      AND          DIR$           VIDEOCARD      INCR" 
;
Mov  AX,Offset $tring_38
Push AX
Mov  AX,18
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 19 "EXTRACT$    OR           CURDIR$        DEF SEG        DECR" 
;
Mov  AX,Offset $tring_39
Push AX
Mov  AX,19
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 20 "REMOVE$     XOR          GET$           PEEK           SHL" 
;
Mov  AX,Offset $tring_40
Push AX
Mov  AX,20
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 21 "REPEAT$     NOT          PUT$           POKE           SHR" 
;
Mov  AX,Offset $tring_41
Push AX
Mov  AX,21
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 22 "SPACE$      TICKS        LEFT$          RIGHT$" 
;
Mov  AX,Offset $tring_42
Push AX
Mov  AX,22
Push AX
Mov  AX,07
Push AX
Call Say
Pop  BP
Ret  00
Display2 Endp


Display3 Proc Near
Push BP
Mov  BP,SP
;
;ReFrame 
;
Call ReFrame
;
;Say 13 05 "BASM supports a rich set of control and loop constructs 
;
Mov  AX,Offset $tring_43
Push AX
Mov  AX,05
Push AX
Mov  AX,13
Push AX
Call Say
;
;Say 07 07 "DO  - EXIT LOOP  -  LOOP 
;
Mov  AX,Offset $tring_44
Push AX
Mov  AX,07
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 08 "FOR - NEXT - STEP - EXIT FOR 
;
Mov  AX,Offset $tring_45
Push AX
Mov  AX,08
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 09 "IF  - THEN - ELSE - END IF 
;
Mov  AX,Offset $tring_46
Push AX
Mov  AX,09
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 10 "SUB - EXIT SUB - END SUB 
;
Mov  AX,Offset $tring_47
Push AX
Mov  AX,10
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 11 "GOTO  labelname 
;
Mov  AX,Offset $tring_48
Push AX
Mov  AX,11
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 12 "GOSUB labelname 
;
Mov  AX,Offset $tring_49
Push AX
Mov  AX,12
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 13 "RETURN 
;
Mov  AX,Offset $tring_50
Push AX
Mov  AX,13
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 14 "FUNCTION - EXIT FUNCTION - END FUNCTION 
;
Mov  AX,Offset $tring_51
Push AX
Mov  AX,14
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 15 "CALL  subname [parameters]       { CALL is optional } 
;
Mov  AX,Offset $tring_52
Push AX
Mov  AX,15
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 16 "SELECT - CASE - END SELECT 
;
Mov  AX,Offset $tring_53
Push AX
Mov  AX,16
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 17 "WHILE -EXIT WHILE- WEND 
;
Mov  AX,Offset $tring_54
Push AX
Mov  AX,17
Push AX
Mov  AX,07
Push AX
Call Say
;
;Say 07 18 "END  [optional DOS Errorlevel value] 
;
Mov  AX,Offset $tring_55
Push AX
Mov  AX,18
Push AX
Mov  AX,07
Push AX
Call Say
Pop  BP
Ret  00
Display3 Endp


Reframe Proc Near
Push BP
Mov  BP,SP
;
;COLOR 0 7 
;
Mov  AX,0
Mov  $FgColor,AX
Mov  AX,7
Mov  $BgColor,AX
Mov  AX,$BgColor
Mov  CX,$FgColor
Call SetAttribute
Call Cls
;
;PRINT "͸ 
;
Mov  SI,Offset $tring_56
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT " Keys: Esc                      BASM version 1.0         by Kevin Diggins    
;
Mov  SI,Offset $tring_57
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "Ĵ 
;
Mov  SI,Offset $tring_58
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT "                                                                               
;
Mov  SI,Offset $tring_59   
Call PrintStr
Call SetCursor
Call DoCrLf
;
;PRINT ";;  ;
;
Mov  SI,Offset $tring_60
Call PrintStr
Call SetCursor
Pop  BP
Ret  00
Reframe Endp
Code Ends



Data Segment Word Public

;__________________System Initialized Data___________________ 

Err          DW 0
DefSeg       DW 0
$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$FgColor     DW 0
$BgColor     DW 0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
$Var4        DW 0
$Var5        DW 0
$Var6        DW 0
$Var7        DW 0
$Var8        DW 0
$Var9        DW 0
$Var10       DW 0
$Var11       DW 0
$Var12       DW 0

;__________________Users Initialized Data____________________

X            DW  0
Y            DW  0
SCRNNUM      DW  0
KEYPRESS     DW  0
$tring_06    DB  0,0
$tring_08    DB "            Ŀ",0
$tring_09    DB "Ĵ BASM ... The BASIC to Assembly Language Translator Ŀ",0
$tring_10    DB "                      ",0
$tring_11    DB "                                                                            ",0
$tring_12    DB " BASM is intended for anyone wishing to convert a BASIC program to an 8088  ",0
$tring_13    DB " assembly language program.  BASM may be freely used and distributed, but I ",0
$tring_14    DB " reserve all rights to BASM.  Dependent upon the interest and response that ",0
$tring_15    DB " I receive, BASM may be enhanced in the future.  PowerBASIC 3.0 was used to ",0
$tring_16    DB " create BASM.  Those interested in the BASM source code may contact me at:  ",0
$tring_17    DB "                             Kevin Diggins                                  ",0
$tring_18    DB "                        10707 E. Quarterline Rd.                            ",0
$tring_19    DB "                       Apache Junction, AZ  85220                           ",0
$tring_20    DB "                            (602) 986-8777                                  ",0
$tring_21    DB "                        ( weekends only please )                            ",0
$tring_22    DB " Disclaimer:  The user accepts all risk and responsibility for any damages  ",0
$tring_23    DB "              resulting directly or indirectly from the use of this utility ",0
$tring_24    DB "              and/or the code it creates.                                   ",0
$tring_25    DB "",0
$tring_26    DB "BASM supports the following statements and functions:",0
$tring_27    DB "DIR$        HEX$         OPEN           CLS            REPLACE",0
$tring_28    DB "SHELL       ASC          CLOSE          PRINT          SWAP",0
$tring_29    DB "TIME$       ABS          KILL           INPUT          DELAY",0
$tring_30    DB "DATE$       BIN2DEC      CHDIR          POS            ASM",0
$tring_31    DB "COMMAND$    GETKEY       MKDIR          CSRLIN         BEEP",0
$tring_32    DB "CURDIR$     INSTR        RMDIR          LOCATE         DIM",0
$tring_33    DB "UCASE$      VAL          NAME           COLOR          ARRAY SORT",0
$tring_34    DB "LCASE$      LEN          PRINT#         FRAME          ARRAY INSERT",0
$tring_35    DB "MID$        SGN          INPUT#         GETSCREEN      ARRAY DELETE",0
$tring_36    DB "TRIM$       EOF          LINE INPUT#    PUTSCREEN      SCAN",0
$tring_37    DB "LTRIM$      ERR          EOF            CHANGEATTR     MOD",0
$tring_38    DB "RTRIM$      AND          DIR$           VIDEOCARD      INCR",0
$tring_39    DB "EXTRACT$    OR           CURDIR$        DEF SEG        DECR",0
$tring_40    DB "REMOVE$     XOR          GET$           PEEK           SHL",0
$tring_41    DB "REPEAT$     NOT          PUT$           POKE           SHR",0
$tring_42    DB "SPACE$      TICKS        LEFT$          RIGHT$",0
$tring_43    DB "BASM supports a rich set of control and loop constructs",0
$tring_44    DB "DO  - EXIT LOOP  -  LOOP",0
$tring_45    DB "FOR - NEXT - STEP - EXIT FOR",0
$tring_46    DB "IF  - THEN - ELSE - END IF",0
$tring_47    DB "SUB - EXIT SUB - END SUB",0
$tring_48    DB "GOTO  labelname",0
$tring_49    DB "GOSUB labelname",0
$tring_50    DB "RETURN",0
$tring_51    DB "FUNCTION - EXIT FUNCTION - END FUNCTION",0
$tring_52    DB "CALL  subname [parameters]       { CALL is optional }",0
$tring_53    DB "SELECT - CASE - END SELECT",0
$tring_54    DB "WHILE -EXIT WHILE- WEND",0
$tring_55    DB "END  [optional DOS Errorlevel value]",0
$tring_56    DB "͸",0
$tring_57    DB " Keys: Esc                      BASM version 1.0         by Kevin Diggins   ",0
$tring_58    DB "Ĵ",0
$tring_59    DB "                                                                              ",0
$tring_60    DB ";;",0

;_________________System Un-Initialized Data_________________

$Work0       DB 81 DUP(?)
$Work1       DB 81 DUP(?)

;_________________Users Un-Initialized Data__________________

DosScreen$   DB 4001 DUP(?)
B$           DB 81 DUP(?)
$ScrnBuf     DB 4000 DUP(?)  ;DO NOT move this label!  It MUST remain last. 
Data Ends

End
